/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
** last changes 21/11/01 CK                                           **
**                                                                    **
***********************************************************************/
void pass0(void)
{
/*
** In pass0 werden die Anzahlen der Variablen vom Typ Matrix bestimmt und
** die Namen ermittelt und die Pointer fuer die namensgebundenen Zugriffe
** deklariert.
** Weiterhin werden die Parameter mit vorgebener Struktur schon in die
** Zieldateien uebertragen.
*/

/* 1. Fall Index-Pruefung fuer 1D-Felder */
if (type >= STATE && type <= FEATURES)
 {
 bp1=strpos(input, "[");
 bp2=strpos(input, "]");
 if (bp2>bp1)
  {
  box=atoi(strmid(input,bp1+1,bp2-bp1-1));
  boxes=box;
  }
 
 else bp1=strpos(input,"=");
 if (bp1<0) bp1=strpos(input,";");

 if (bp1>0) sprintf(svar,"%s",strmid(input,0,bp1));
    else sprintf(svar,"%s",input);

 if (strlen(svar) > sizeof(long_name)-1)
 {
     printf ("In %s name too long: %s\n",struct_file,svar);
     exit (1);
 }
 sprintf(all_names[num_vars],"%s",svar);
 all_types[num_vars]=type;
 num_vars++;
} 
/* Ende 1. Fall  Index-Pruefung fuer 1D-Felder */

/* 2. Fall  Index-Pruefung fuer 2D-Felder */
if (type >= _2D_STATE && type <= _2D_FEATURES)
 {
 bp1=strpos(input,"[");
 bp2=strpos(input,"]");
 if (bp1<=0)
 {
    bp1=strpos(input,"=");
    if (bp1<0) bp1=strpos(input,";");
    if (bp1>0) sprintf(svar,"%s",strmid(input,0,bp1));
       else sprintf(svar,"%s",input);
  }
 else
 {
  if (get_entries(box_entries,input,svar) != 2)
  {
     printf("ERROR: Wrong number of indices in statement %s\n",input);
     exit (1);
  } 
  box1 = box_entries[0];
  box2 = box_entries[1];
  boxes1=box1;
  boxes2=box2;
  fprintf(struct_def,"/*prepare_sub->pass0:type=%d,box1=%d,box2=%d*/\n",type,box1,box2);
 }
fprintf(struct_def,"/*input=%s svar=%s*/\n",input,svar); 

 if (strlen(svar) > sizeof(long_name)-1)
 {
     printf ("In %s name too long: %s\n",struct_file,svar);
     exit (1);
 }
 sprintf(all_names[num_vars],"%s",svar);
 all_types[num_vars]=type;
 num_vars++;
 
}
switch (type) 
 {
  case STATE:break;

  case GLOBAL:fprintf(struct_def,"real *%s;\n",svar);
         max_changes+=boxes;
         break;

  case INT_PARAM:fprintf(struct_def,"int *%s;\n",svar);
         max_changes+=boxes;
         break;
  case REAL_PARAM:fprintf(struct_def,"real *%s;\n",svar);
         max_changes+=boxes;
         break;
  case REAL_CONST:if (strpos(input,";")<0) strcat(input,";");
         fprintf(struct_def,"real %s \n",input);
         max_changes++;
         break;
  case INT_CONST:if (strpos(input,";")<0) strcat(input,";");
         fprintf(struct_def,"int %s \n",input);
         max_changes++;
         break;
  case DERIVES:break;
  case FEATURES:break;
  case FLUXES:break;

/* 2D Faelle */
  case _2D_STATE:break;

  case _2D_GLOBAL:fprintf(struct_def,"real **%s;\n",svar);
         max_changes+=boxes1+boxes2;
         break;

  case _2D_INT_PARAM:fprintf(struct_def,"int **%s;\n",svar);
         max_changes+=boxes1+boxes2;
         break;
  case _2D_REAL_PARAM:fprintf(struct_def,"real **%s;\n",svar);
         max_changes+=boxes1+boxes2;
         break;
  case _2D_DERIVES:break;
  case _2D_FEATURES:break;
  case _2D_FLUXES:break;
  
  default:break;
 }
} /* ende von pass0 */ 
