/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
** last changes 21/11/01 CK                                           **
**                                                                    **
***********************************************************************/
void pass1(void)
{

 bp1=strpos(input, "[");
 bp2=strpos(input, "]");
 if (bp2>bp1)
  {
     if (type >= STATE && type <= FEATURES)
     {
        boxes=atoi(strmid(input,bp1+1,bp2-bp1-1));
     }
     if (type >= _2D_STATE && type <= _2D_FEATURES)
     {
        get_entries(box_entries,input,svar);
        boxes1=box_entries[0];
        boxes2=box_entries[1];;
     }
  }
 if (bp2<=bp1) bp1=strpos(input,"=");
 if (bp1<0) bp1=strpos(input,";");

 if (bp1>0) sprintf(svar,"%s",strmid(input,0,bp1));
    else sprintf(svar,"%s",input);

if (type == INT_PARAM || type == REAL_PARAM)
{
bp1=strpos(input,"{");
bp2=strpos(input,"}");
while (bp2 == -1)
  {
  fgets(helpstr,100,global_defs);
  input=strcat(input,helpstr);
  bp2=strpos(input,"}");
  }
fprintf(struct_def,"printf(\"Initializing %s from %s\\n\");\n",strclip(input),orig_defs); 
sprintf(input,"%s",strmid(input,bp1+1,bp2-bp1-1));
strtrim(input);
expand(input);
}
switch (type)
 {
 /* 1D Faelle */
  case 0:
  case STATE:break;
  case GLOBAL:fprintf(struct_h,"%s%s%s \n","extern real *",svar,";");
         fprintf(struct_def,"%s%s%d%s%d%s \n",svar,"=vector(",1,",",boxes,");");
         break;

  case INT_PARAM:fprintf(struct_h,"%s%s%s \n","extern int *",svar,";");
         fprintf(struct_def,"%s%s%d%s%d%s \n", svar,"=ivector(",1,",",boxes,");");
         if (numchar(input,",") != boxes-1)
         {
            printf("Error: Wrong number of values for %s!\n",svar);
            exit(1);
         }
         for (k=1;k<=boxes;k++)
         {
         bp1=strpos(input,",");
         if ( bp1 > 0 )
          {
          sprintf(helpstr,"%s",strmid(input,0,bp1));
          sprintf(input,"%s",strmid(input,bp1+1,strlen(input)-bp1-1));
          }
         else
          {
          sprintf(helpstr,"%s",input);
          }
         sscanf(helpstr,"%d",&get_int);

         fprintf(struct_def,"%s[%d]= %d ;\n",svar,k,get_int);
         }
         break;

  case REAL_PARAM:fprintf(struct_h,"%s%s%s \n","extern real *",svar,";");
         fprintf(struct_def,"%s%s%d%s%d%s \n",svar,"=vector(",1,",",boxes,");");

         if (numchar(input,",") != boxes-1)
         {
            printf("Error: Wrong number of values for %s!\n",svar);
            exit(1);
         }

         for (k=1;k<=boxes;k++)
         {
         bp1=strpos(input,",");

         if ( bp1 > 0 )
          {
          sprintf(helpstr,"%s",strmid(input,0,bp1));
          sprintf(input,"%s",strmid(input,bp1+1,strlen(input)-bp1-1));
          }
         else
          {
          sprintf(helpstr,"%s",input);
          }
         get_flt=my_sscan(helpstr);

         fprintf(struct_def,"%s[%d]= %f ;\n",svar,k,get_flt);
         }
         break;


   case REAL_CONST:bp1=strpos(input,"=");
         sprintf(svar,"%s",strmid(input,0,bp1));
         fprintf(struct_h,"%s%s%s \n","extern real ",svar,";");

         break;

  case INT_CONST:bp1=strpos(input,"=");
         sprintf(svar,"%s",strmid(input,0,bp1));
         fprintf(struct_h,"%s%s%s \n","extern int ",svar,";");

         break;
   case DERIVES:
   case FEATURES: break;

 /* 2D Faelle */
  case _2D_STATE:break;
  case _2D_GLOBAL:fprintf(struct_h,"%s%s%s \n","extern real **",svar,";");
         fprintf(struct_def,"%s=matrix(1,%d,1,%d);",svar,boxes1,boxes2);
         break;

  case _2D_INT_PARAM:fprintf(struct_h,"%s%s%s \n","extern int **",svar,";");
         fprintf(struct_def,"%s=imatrix(1,%d,1,%d);\n",svar,boxes1,boxes2);
         fprintf(struct_def,"printf(\"Initializing %s from %s\\n\");\n",strclip(input),orig_defs); 
         bp1=strpos(input,"{");
         bp2=strpos(input,"}");
         sprintf(input,"%s",strmid(input,bp1+1,bp2-bp1-1));
         expand(input);

         if (numchar(input,",") != (boxes1*boxes2)-1)
         {
            printf("Error: Wrong number of values for %s!\n",svar);
            exit(1);
         }

         for (k=1;k<=boxes1;k++)
             for (l=1;l<=boxes2;l++)
            {
               bp1=strpos(input,",");
               if ( bp1 > 0 )
                {
                sprintf(helpstr,"%s",strmid(input,0,bp1));
                sprintf(input,"%s",strmid(input,bp1+1,strlen(input)-bp1-1));
                }
                else
                {
                sprintf(helpstr,"%s",input);
                }
                sscanf(helpstr,"%d",&get_int);
                fprintf(struct_def,"%s[%d][%d]= %d ;\n",svar,k,l,get_int);
                }
         break;

  case _2D_REAL_PARAM:fprintf(struct_h,"%s%s%s \n","extern real **",svar,";");
         fprintf(struct_def,"%s=matrix(1,%d,1,%d);\n",svar,boxes1,boxes2);
         fprintf(struct_def,"printf(\"Initializing %s from %s\\n\");\n",strclip(input),orig_defs); 

         bp1=strpos(input,"{");
         bp2=strpos(input,"}");
         sprintf(input,"%s",strmid(input,bp1+1,bp2-bp1-1));
         expand(input);

         if (numchar(input,",") != (boxes1*boxes2)-1)
         {
            printf("Error: Wrong number of values for %s!\n",svar);
            exit(1);
         }

         for (k=1;k<=boxes1;k++)
             for (l=1;l<=boxes2;l++)
            {
               bp1=strpos(input,",");
               if ( bp1 > 0 )
                {
                sprintf(helpstr,"%s",strmid(input,0,bp1));
                sprintf(input,"%s",strmid(input,bp1+1,strlen(input)-bp1-1));
                }
                else
                {
                sprintf(helpstr,"%s",input);
                }
                get_flt=my_sscan(helpstr);

         fprintf(struct_def,"%s[%d][%d]= %g ;\n",svar,k,l,get_flt);
         }
         break;

   default:break;
         }
} /* ende von pass1 */ 
