/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
**                                                                    **
***********************************************************************/

#include "struct.h"
#include <math.h>
int check_validity0(int var, real check)
{

/*#ifdef __STRICT_ANSI__
extern int isnan _PARAMS((double));
#endif*/

int warning=0;

if (isnan(check)!=0) 
{
        warning=2;
        printf("Error: time %g %s is NaN at assign=%d\n",
                (float) sim_time,_0D_state_names[var],assign);
        fflush(stdout);
        return(warning);
}

if ((check < (real) 0.0) && (check < -MAXFLOAT || check > -MINFLOAT)) warning = 1;
if ((check > (real) 0.0) && (check > MAXFLOAT || check < MINFLOAT)) warning = 1;
if (warning == 1)
        {
                printf("Warning: time %g %s leaving numerical range with value %g at assign=%d\n",
                        (float) sim_time,_0D_state_names[var],(double) check,assign);
                fflush(stdout);
        }
return(warning);
}



int check_validity1(int var, int __box, real check)
{

/*#ifdef __STRICT_ANSI__
extern int isnan _PARAMS((double));
#endif*/

int warning=0;

if (isnan(check)!=0) 
{
        warning=2;
        printf("Error: time %g %s[%d] is NaN at assign=%d\n",
                (float) sim_time,_1D_state_names[var],__box,assign);
        fflush(stdout);
        return(warning);
}

if ((check < (real) 0.0) && (check < -MAXFLOAT || check > -MINFLOAT)) warning = 1;
if ((check > (real) 0.0) && (check > MAXFLOAT || check < MINFLOAT)) warning = 1;
if (warning == 1)
        {
                printf("Warning: time %g %s[%d] leaving numerical range with value %g at assign=%d\n",
                        (float) sim_time,_1D_state_names[var],__box,(double) check,assign);
                fflush(stdout);
        }
return(warning);
}

 /*##########################################################*/

int check_validity2(int var, int __box1, int __box2, real check)
{

/*#ifdef __STRICT_ANSI__
extern int isnan _PARAMS((double));
#endif*/

int warning;

warning=0;
if (check > 0.0 || check < 0.0)
{
 if (check < (real) 0.0)
  {
   if (check < -MAXFLOAT || check > -MINFLOAT)
     {
      warning = 1;
     }
  }
 else
  {
   if (check > MAXFLOAT || check < MINFLOAT)
     {
      warning = 1;
     }
  }
if (isnan(check)!=0) warning=2;
if (warning == 1)
 {
   printf("Warning: time %g %s[%d][%d] leaving numerical range with value %g at assign=%d\n",
          (float) sim_time,_2D_state_names[var],__box1,__box2,(double) check,assign);
   fflush(stdout);
 }
 if (warning == 2)
 {
   printf("Error: time %g %s[%d][%d] is NaN at assign=%d\n",
          (float) sim_time,_2D_state_names[var],__box1,__box2,assign);
   fflush(stdout);
 }
}
return(warning);
}


