/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
**                                                                    **
***********************************************************************/
#include "struct.h"

void make_global(real *in_vector, real *out_vector, real **out_matrix, real ***out_tensor)
{
#if defined (__verbose__)
int check_validity0(int,real);
int check_validity1(int,int,real);
int check_validity2(int,int,int,real);
int stop=0;
#endif
int i,j,k,l,m,n;
long int offset1, offset2;

offset1=num_0D_states;
offset2=offset1+num_1D_states*l_comp;

for (i=1;i<=num_0D_states;i++) 
    {
    out_vector[i]=in_vector[i];
#if defined (__verbose__)
        if (check_validity0(i,in_vector[i]) == 2) stop=1; 
#endif
    }
for (i=1; i<=num_1D_states; i++)
    {
    l=(i-1)*l_comp;
    for (j=1; j<=l_comp; j++)
        {
        k=l+j+offset1;
        out_matrix[i][i_com[j]]=in_vector[k];
#if defined (__verbose__)
        if (check_validity1(i,i_com[j],in_vector[k]) == 2) stop=1; 
#endif
        }
    }

for (i=1;i<=num_2D_states;i++)
    {
    l=(i-1)*g_comp1*g_comp2;
    for (j=1;j<=g_comp1;j++)
        {
         n=(j-1)*g_comp2;
         for (k=1;k<=g_comp2;k++)
             {
              m = l+n+k+offset2;
              out_tensor[i][j][k]=in_vector[m];  
#if defined (__verbose__)
        if (check_validity2(i,j,k,in_vector[m]) == 2) stop=1; 
#endif
             }
        }
    }
#if defined (__verbose__)
        if (stop==1) std_error("There were NaNs after integration (see above)!"); 
#endif
}


