/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
**                                                                    **
***********************************************************************/
#include <math.h>
#include "struct.h"
#include <stdio.h>

void warn_negative(real act_time,long var_num,real svar,char *message)
{
int var;
int __box;
int __box1=-1,__box2=-1,offset1,offset2;
long int _2D_var,__boxes,seq_number;

offset1=num_0D_states;
if (var_num <=num_0D_states) {
    printf("Warning: Detected negative state variable  with rate ZERO in method:%s assign=%d time=%g %s=%g \n",
                message,(int) assign, (float) act_time,_0D_state_names[var_num],(float) svar);
} else if (var_num <=offset1+num_1D_states*l_comp) {
        __box= (int) (var_num%l_comp);
        if (__box==0) __box=l_comp;
        var=(int) (1+(var_num-__box)/l_comp);
        
        printf("Warning: Detected negative state variable with rate ZERO in method:%s assign=%d time=%g %s[%d]=%g \n",
                message,(int) assign, (float) act_time,_1D_state_names[var],i_com[__box],(float) svar);
} 
else
{
        /* hier fangen die 2D-Variablen an */
        offset2=offset1+num_1D_states*l_comp;
        /* dies ist die Nummer der Variablen bezogen auf num_2D_states innerhalb der grids von g_comp1 x g_comp2 */
        _2D_var = var_num-offset2;
        /* Anzahl der "boxen" fuer eine 2D-Variable */
        __boxes = g_comp1*g_comp2;
        /* jetzt die Nummer der Variablen bestimmen (ab 1 gezaehlt) */
        var = 1+ _2D_var/__boxes;
        /* Index, wenn man die Matrix einer Variablen zum Vektor ausklappt  (var-1), weil hier wieder ab Null gerechnet wird*/
        seq_number=_2D_var-(var-1)*__boxes;
        /* und nun die Indizes in der Matrix bestimmen */
        __box1= ceil(seq_number/g_comp2);
	__box2= seq_number;
/* hier nun 'mal wieder der index-richtige Ersatz für die eigentlich gewollte Modulo-Funktion */
	while (__box2 > g_comp2) __box2 -= g_comp2;
        
        /* geschafft..... */
               printf("Warning: Detected negative state variable  with rate ZERO in method:%s assign=%d time=%g %s[%d][%d]=%g \n",
                message,(int) assign, (float) act_time,_2D_state_names[var],__box1,__box2,(float) svar);
}
fflush(stdout);
}

