/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
**                                                                    **
***********************************************************************/
#include <stdio.h> 
#include "struct.h"
void write_info(string filename) 
{

 FILE *info_file;
 int i,j,k;

 if ((info_file=fopen(filename,"wb")) == (FILE *) NULL )
 {
   printf("Cannot open : %s \nNo valid info-file written!\nRead only file (system)?\n",filename);
   fflush(stdout);
   return;
 }
 fprintf(info_file,"/*0D State Variables */\n");
 make_global_0D_states();
 for (j=1;j<=num_0D_states;j++)
   fprintf(info_file,"%s=%g;\n",_0D_state_names[j],(double) KKK[j]);
fprintf(info_file,"\n");


fprintf(info_file,"/*1D State Variables */\n");
 for (j=1;j<=num_1D_states;j++)
   {
   fprintf(info_file,"%s[1-%d]={",_1D_state_names[j],n_comp);
   for (i=1;i<n_comp;i++) 
    {
    fprintf(info_file,"%g,",(float) CCC[j][i]);
    if (i%5 == 0) fprintf(info_file,"\n");
    }
   fprintf(info_file,"%g};\n",(float) CCC[j][n_comp]);
   }
fprintf(info_file,"\n");

fprintf(info_file,"/*2D State Variables */\n");
for (k=1;k<=num_2D_states;k++)
     for (i=1;i<=g_comp1;i++)
        for (j=1;j<=g_comp2;j++)
             fprintf(info_file,"%s[%d][%d]=%g;\n",_2D_state_names[k],i,j,(double) DDD[k][i][j]);
fprintf(info_file,"\n");

 fclose(info_file);
}
