/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
**                                                                    **
** last change 2013/05/19 -> corrected prototyping fpr r3_tensor_submatrix /fh                 **
**                                                                    **
***********************************************************************/
#ifndef __CONSTRUCTS_H
#define __CONSTRUCTS_H
#include "types.h"

extern void std_error(const char error_text[]);
extern real *vector(long first, long last);
extern float *fvector(long first, long last);
extern int *ivector(long first, long last);
extern unsigned char *cvector(long first, long last);
extern unsigned long *lvector(long first, long last);
extern double *dvector(long first, long last);
extern float **fmatrix(long first_row, long last_row, long first_col, long last_col);
extern real **matrix(long first_row, long last_row, long first_col, long last_col);
extern double **dmatrix(long first_row, long last_row, long first_col, long last_col);
extern int **imatrix(long first_row, long last_row, long first_col, long last_col);
extern long int **lmatrix(long first_row, long last_row, long first_col, long last_col);
extern float **submatrix(float *in_ptr, long old_first_row, long old_last_row, long old_first_col, long old_last_col,long new_first_row, long new_first_col);
extern float **convert_matrix(float in_ptr, long first_row, long last_row, long first_col, long last_col);
extern float ***f3tensor(long first_row, long last_row, long first_col, long last_col, long first_lay, long last_lay);
extern double ***d3tensor(long first_row, long last_row, long first_col, long last_col, long first_lay, long last_lay);
extern real ***r3tensor(long first_row, long last_row, long first_col, long last_col, long first_lay, long last_lay);
extern int ***i3tensor(long first_row, long last_row, long first_col, long last_col, long first_lay, long last_lay);
extern real **r3tensor_submatrix(real ***in_ptr, long newr, long first_col, long last_col, long first_lay, long last_lay);
extern int **i3tensor_submatrix(int **in_ptr, long newr, long first_col, long last_col, long first_lay, long last_lay);
extern void free_vector(real *v, long first, long last);
extern void free_fvector(float *v, long first, long last);
extern void free_ivector(int *v, long first, long last);
extern void free_cvector(unsigned char *v, long first, long last);
extern void free_lvector(unsigned long *v, long first, long last);
extern void free_dvector(double *v, long first, long last);
extern void free_matrix(real **m, long first_row, long last_row, long first_col, long last_col);
extern void free_fmatrix(float **m, long first_row, long last_row, long first_col, long last_col);
extern void free_dmatrix(double **m, long first_row, long last_row, long first_col, long last_col);
extern void free_imatrix(int **m, long first_row, long last_row, long first_col, long last_col);
extern void free_lmatrix(long int **m, long first_row, long last_row, long first_col, long last_col);
extern void free_submatrix(float **b, long first_row, long last_row, long first_col, long last_col);
extern void free_convert_matrix(float **b, long first_row, long last_row, long first_col, long last_col);
extern void free_f3tensor(float ***t, long first_row, long last_row, long first_col, long last_col,long first_lay, long last_lay);
extern void free_i3tensor(int ***t, long first_row, long last_row, long first_col, long last_col,long first_lay, long last_lay);
extern void free_tensor(real ***t, long first_row, long last_row, long first_col, long last_col,	long first_lay, long last_lay);
#endif /* __CONSTRUCTS_H */
