/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
**                                                                    **
***********************************************************************/
#define total_vars 20000
#define one_var 10000
#define _BUFSIZE_ 262144
#define rem1 "/*"
#define rem2 "*/"

#define auto_header "/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/\n/*!!! This file was automatically generated !!! Do not edit it !!!*/\n/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/\n\n"

#define _keyword_ "%"
#define unused_boxes "%boxes_not_active"
#define change_id "%change"				         /* type 0  */

/* 0-D-Erweiterung for beginners */
#define _0D_state_id "%0D_states"                                       /* type 1  */
#define _0D_glob_id "%0D_globals"                                       /* type 2  */
/*#define int_param_id "%int_ind_par"*/                      /* type 3  */
/*#define flt_param_id "%real_ind_par" */                    /* type 4  */
/*#define flt_const "%real_par"*/                                    /* type 5  */
/*#define int_const "%int_par"  */                                   /* type 6  */
/*#define _0D_derives "%0D_real_derived_from_states"*/              /* type 7  */ 
/*#define _0D_features "%0D_int_derived_from_states"*/               /* type 8  */
/*#define _0D_ fluxes "%0D_global_derived_from_states"*/           /* type 9  */

/* Typ-Enumeration 0D*/
#define _0D_STATE 1  
#define _0D_GLOBAL 2   
/* #define _0D_INT_PARAM 3    */
/* #define _0D_REAL_PARAM 4   */
/* #define _0D_REAL_CONST 5   */
/* #define _0D_INT_CONST 6    */
/* #define _0D_DERIVES 7      */
/* #define _0D_FEATURES 8   */
/* #define _0D_FLUXES 9 */


/* CEMoS und ERSEM klassisch 1D */
#define state_id "%states"					 /* type 11  */
#define glob_id "%globals"					 /* type 12  */
#define int_param_id "%int_ind_par"			 /* type 13  */
#define flt_param_id "%real_ind_par"			 /* type 14  */
#define flt_const "%real_par"   				 /* type 15  */
#define int_const "%int_par"					 /* type 16  */
#define derives "%real_derived_from_states"	         /* type 17  */
#define features "%int_derived_from_states"		 /* type 18  */
#define fluxes "%global_derived_from_states"	 /* type 19  */

/* Typ-Enumeration 1D*/
#define STATE 11  
#define GLOBAL 12   
#define INT_PARAM 13   
#define REAL_PARAM 14  
#define REAL_CONST 15  
#define INT_CONST 16   
#define DERIVES 17     
#define FEATURES 18  
#define FLUXES 19  

/* Erweiterung auf_2D-Gitter */
#define _2D_state_id "%2D_states"                                      /* type 21  */
#define _2D_glob_id "%2D_globals"                                      /* type 22  */
#define _2D_int_param_id "%2D_int_ind_par"                     /* type 23  */
#define _2D_flt_param_id "%2D_real_ind_par"                    /* type 24  */
/* #define _2D_flt_const "%2D_real_par" */                                  /* type 25  */
/*#define _2D_int_const "%2D_int_par" */                                  /* type 26  */
#define _2D_derives "%2D_real_derived_from_states"         /* type 27  */
#define _2D_features "%2D_int_derived_from_states"          /* type 28  */
#define _2D_fluxes "%2D_global_derived_from_states"	        /* type 29  */

/* Typ-Enumeration 2D*/
#define _2D_STATE 21  
#define _2D_GLOBAL 22   
#define _2D_INT_PARAM 23   
#define _2D_REAL_PARAM 24  
/* #define _2D_REAL_CONST 25   */
/* #define _2D_INT_CONST 26    */
#define _2D_DERIVES 27     
#define _2D_FEATURES 28  
#define _2D_FLUXES 29

/* Erweiterung auf 3D-Gitter */
#define _3D_state_id "%3D_states"                                      /* type 31  */
#define _3D_glob_id "%3D_globals"                                      /* type 32  */
#define _3D_int_param_id "%3D_int_ind_par"                     /* type 33  */
#define _3D_flt_param_id "%3D_real_ind_par"                    /* type 34  */
/* #define _3D_flt_const "%3D_real_par" */                                  /* type 35  */
/* #define _3D_int_const "%3D_int_par" */                                  /* type 36  */
#define _3D_derives "%3D_real_derived_from_states"         /* type 37  */
#define _3D_features "%3D_int_derived_from_states"          /* type 38  */
#define _3D_fluxes "%3D_global_derived_from_states"	        /* type 39  */

/* Typ-Enumeration 3D*/
#define _3D_STATE 31  
#define _3D_GLOBAL 32   
#define _3D_INT_PARAM 33   
#define _3D_REAL_PARAM 34  
/*#define _3D_REAL_CONST 35  
#define _3D_INT_CONST 36   */
#define _3D_DERIVES 37     
#define _3D_FEATURES 38  
#define _3D_FLUXES 39


#define _ljapunov_ "%with_ljapunov"			 /* type -1 */
#define _use_slave_ "%with_slave"			         /* type -2 */

#define _simu_par_ "%simulation_par"
#define _integ_par_ "%integration_par"
#define _slave_ "%slave_model"
#define _interface_box_ "%interface"
#define _store_0D_ "%0D_store"
#define _store_ "%store"
#define _store_2D_ "%2D_store"

