/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
**                                                                    **
***********************************************************************/
#define __USE_FIXED_PROTOTYPES__
#define _VALUES_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef __USE_XOPEN
   #define __USE_XOPEN 1
#endif

#include <math.h>
#include <ctype.h>
#ifndef __def_tools
  #define __def_tools 1
  #include "tools.h"
#endif

#include "netcdf.h"

/*#include <fpu_control.h>*/

#ifdef DOS
	#ifndef M_E
		# define M_E			2.7182818284590452354	/* e */
	#endif
	#ifndef M_LOG2E
		# define M_LOG2E		1.4426950408889634074	/* log_2 e */
	#endif
	#ifndef M_LOG10E
		# define M_LOG10E		0.43429448190325182765	/* log_10 e */
	#endif
	#ifndef M_LN2
		# define M_LN2		0.69314718055994530942	/* log_e 2 */
	#endif
	#ifndef M_LN10
		# define M_LN10		2.30258509299404568402	/* log_e 10 */
	#endif
	#ifndef M_PI
		# define M_PI			3.14159265358979323846	/* pi */
	#endif
	#ifndef M_PI_2
		# define M_PI_2		1.57079632679489661923	/* pi/2 */
	#endif
	#ifndef M_PI_4
		# define M_PI_4		0.78539816339744830962	/* pi/4 */
	#endif
	#ifndef M_1_PI
		# define M_1_PI		0.31830988618379067154	/* 1/pi */
	#endif
	#ifndef M_2_PI
		# define M_2_PI		0.63661977236758134308	/* 2/pi */
	#endif
	#ifndef M_2_SQRTPI
		# define M_2_SQRTPI	1.12837916709551257390	/* 2/sqrt(pi) */
	#endif
	#ifndef M_SQRT2
		# define M_SQRT2		1.41421356237309504880	/* sqrt(2) */
	#endif
	#ifndef M_SQRT1_2
		# define M_SQRT1_2	0.70710678118654752440	/* 1/sqrt(2) */
	#endif
#endif

#ifndef FLT_MAX
#   ifdef MAXFLOAT
#	define FLT_MAX MAXFLOAT
#   else
#	define FLT_MAX 3.402823466E+38F
#   endif
#endif
#ifndef FLT_MIN
#   ifdef MINFLOAT
#	define FLT_MIN MINFLOAT
#   else
#	define FLT_MIN 1.175494351E-38F
#   endif
#endif

#ifndef MAXFLOAT
#   define MAXFLOAT FLT_MAX
#endif
#ifndef MINFLOAT
#   define MINFLOAT FLT_MIN
#endif


#define PARAMFILE "./.tmp/.parfile.tmp"

#define __netcdf 1


