/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
**                                                                    **
***********************************************************************/
#include "stdinc.h"
#include "constructs.h"
#include "prepare.h"
#include "types.h"
int find_changes(char *,long_name *,real **,int *,int );

int find_changes(char *filename,long_name *names,real **pointer,int *types,int number )
{
FILE *startfile;
char *input_buf,*line_buf,*list,*change_buf,*message,komma[2];
char *dummy __attribute__ ((unused));
long_name test_name,left_part;
int bp1,bp2,i,k,cp,*flags;
real *ptr_real;
int *ptr_int,scan_int;
int found_change=0;

sprintf(komma,"%s",",");
flags=ivector(1,one_var);
for(i=1;i<=one_var;i++) flags[i]=0;

line_buf=(char *) malloc(_BUFSIZE_*sizeof(char));
message=(char *) malloc(_BUFSIZE_*sizeof(char));
change_buf=(char *) malloc(_BUFSIZE_*sizeof(char));
input_buf=(char *) malloc(_BUFSIZE_*sizeof(char));
list=(char *) malloc(_BUFSIZE_*sizeof(char));

startfile=fopen(filename,"rb");

/* Suche nach "%change" */
while ( (k=fgetc(startfile)) != EOF )
  {
  ungetc(k,startfile);
  input_buf=fgets(input_buf,100,startfile);
  if (strpos(input_buf,_keyword_) == 0)
     if (strpos(input_buf,change_id)>=0) break;
  }
/* "%change" gefunden, eine Zeile einlesen */

while ( (k=fgetc(startfile)) != EOF )
 {
 ungetc(k,startfile);
 input_buf=fgets(input_buf,100,startfile);

 while(strlen(input_buf)<3) 
  {
  k=fgetc(startfile);
  if (k == EOF ) goto stop_label;
   
  ungetc(k,startfile);
  input_buf=fgets(input_buf,100,startfile);
  }

 sprintf(line_buf,"%s",input_buf);

/* Zeile komplettieren */
  bp1=strpos(line_buf,"{");
  bp2=strpos(line_buf,"}");
  if (bp1>0)
   {
   while (bp2<0)
    {
    dummy=fgets(input_buf,100,startfile);
    line_buf=strcat(line_buf,input_buf);
    bp2=strpos(line_buf,"}");
    }
   }

 strtrim(line_buf);
 sprintf(message,"%s",line_buf);

/* Eingelesene Zeile in einzelne Kommandos zerlegen */
 while(strlen(line_buf)>0)
  {
  cp=strpos(line_buf,";");
  bp1=strpos(line_buf,"=");
  if (cp < 0 && bp1 > 0) 
  {
    printf("Error in line containing: %s\n",line_buf);
    std_error("Missing delimiter (fc0)");
  }
  sprintf(change_buf,"%s",strmid(line_buf,0,cp+1));
  sprintf(line_buf,"%s",strmid(line_buf,cp+1,(int) strlen(line_buf)-cp-1));

/* Fuehrende white-space abschneiden */
/*  while(strpos(change_buf," ")==0) 
     sprintf(change_buf,"%s",strmid(change_buf,1,(int) strlen(change_buf)-1));*/
  strtrim(change_buf);
  if (strlen(change_buf)==0) break;

/* Nach passender Variablen suchen */
     for (i=0; i<number; i++)
       {
       sprintf(test_name,"%s",names[i]);
       bp1 = strpos(change_buf,"=");
       bp2 = strpos(change_buf,"[");

       if (bp1<0 && bp2<0) break;
       if ( bp2<0 ) cp = bp1; else cp = bp2;

       sprintf(left_part,"%s",strmid(change_buf,0,cp));
       if (strpos(left_part,test_name) == 0 &&
           strlen(test_name)==strlen(left_part))
        {
        if (types[i]>0) 
         {
         printf("Change: %s\n",change_buf);
         found_change=1;
         fflush(stdout);
         }

/* Typen:
   1: integer constant
   2: real constant
   3: integer array
   4: real array
*/
        switch (abs(types[i]))
         {
          case INT_CONST:
          case FEATURES:
          case _2D_FEATURES:
                 bp1=strpos(change_buf,"=");
                 bp2=strpos(change_buf,";");
                 if (bp1 < 0 || bp2 < 0)
                 {
                    printf("Error in line containing: %s\n",change_buf);
                    std_error("Missing delimiter (fc1)");
                 }
                 sprintf(list,"%s",strmid(change_buf,bp1+1,bp2-bp1-1));
                 sscanf(list,"%d",(int*)pointer[i]);
                 break;
          case REAL_CONST:
          case DERIVES:
          case _2D_DERIVES:
                 bp1=strpos(change_buf,"=");
                 bp2=strpos(change_buf,";");
                 if (bp1 < 0 || bp2 < 0)
                 {
                    printf("Error in line containing: %s\n",change_buf);
                    std_error("Missing delimiter (fc2)");
                 }
                 sprintf(list,"%s",strmid(change_buf,bp1+1,bp2-bp1-1));
                 *pointer[i]=my_sscan(list);
                 break;

          case INT_PARAM:
                 bp1=strpos(change_buf,"[");
                 bp2=strpos(change_buf,"]");
                 if (bp1<0 || bp2<0) 
                 {
                    printf("Error in line containing: %s\n",change_buf);
                    std_error("Brackets missing or no indices");
                 }
                 sprintf(list,"%s",strmid(change_buf,bp1+1,bp2-bp1-1));
                 set_flags(list,flags);
                 bp1=strpos(change_buf,"{");
                 bp2=strpos(change_buf,"}");
                 /* nur ein Wert fuer eine indizierte Variable */
                 if (bp1+bp2<0)
                  {
                  bp1=strpos(change_buf,"=");
                  bp2=strpos(change_buf,";");
                  }
                 sprintf(change_buf,"%s",strmid(change_buf,bp1+1,bp2-bp1-1));
          /* Listenelemente abarbeiten und Werte auf die Pointer schreiben */
                 for (k=1;k<=one_var;k++)
                  {
                  if (flags[k] != 0)
                   {
                   flags[k]=0;
                   sprintf(list,"%s","");
                   bp1=strpos(change_buf,komma);
                   if ( bp1 > 0 )
                    { 
                    sprintf(list,"%s",strmid(change_buf,0,bp1));
                    sprintf(change_buf,"%s",
                            strmid(change_buf,bp1+1,(int) strlen(change_buf)-bp1-1));
                    }
                   else
                    {
                    sprintf(list,"%s",change_buf);
                    sprintf(change_buf,"%s","");
                    }
                   if (strlen(list) == 0)
                  {
                     printf("Error in line containing: %s\n",message);
                     std_error("Number of list elements does not match number of values (fc1)");
                   }
                   sscanf(list,"%d",&scan_int);
                   ptr_int=(int*) pointer[i];
                   ptr_int[k]=scan_int;
                   }
                  }
                  if (strlen(change_buf) != 0)
                 {
                    printf("Error in line containing: %s\n",message);
                    std_error("Number of list elements does not match number of values (fc2)");
                 }

                   break;

          case REAL_PARAM:
                 bp1=strpos(change_buf,"[");
                 bp2=strpos(change_buf,"]");
                 if (bp1<0 || bp2<0) 
                 {
                    printf("Error in line containing: %s\n",change_buf);
                    std_error("Brackets missing or no indices");
                 }
                 sprintf(list,"%s",strmid(change_buf,bp1+1,bp2-bp1-1));
                 set_flags(list,flags);
                 bp1=strpos(change_buf,"{");
                 bp2=strpos(change_buf,"}");
                 /* nur ein Wert fuer eine indizierte Variable */
                 if (bp1+bp2<0)
                  {
                  bp1=strpos(change_buf,"=");
                  bp2=strpos(change_buf,";");
                  }
                 sprintf(change_buf,"%s",strmid(change_buf,bp1+1,bp2-bp1-1));
          /* Listenelemente abarbeiten und Werte auf die Pointer schreiben */
                 for (k=1;k<=one_var;k++)
                  {
                  if (flags[k] != 0)
                   {
                   flags[k]=0;
                   bp1=strpos(change_buf,komma);
                   sprintf(list,"%s","");
                   if ( bp1 > 0 )
                    { 
                    sprintf(list,"%s",strmid(change_buf,0,bp1));
                    sprintf(change_buf,"%s",
                            strmid(change_buf,bp1+1,(int) strlen(change_buf)-bp1-1));
                    }
                   else
                    {
                    sprintf(list,"%s",change_buf);
                    sprintf(change_buf,"%s","");
                    }
                   if (strlen(list) == 0) 
                   {
                      printf("Error in line containing: %s\n",message);
                      std_error("Number of list elements does not match number of values (fc3)");
                   }
                   ptr_real=pointer[i];
                   ptr_real[k]=my_sscan(list);
                   }
                  }
                  if (strlen(change_buf)!=0)
                 {
                     printf("Error in line containing: %s\n",message);
                    std_error("Number of list elements does not match number of values (fc4)");
                  }
                  break;


         } /* Ende von switch(type[i]) */
           break; /* wenn gefunden, Variablenliste beenden */

        } /* Ende von if(strpos(change_buf,list)==0) */

       } /* Ende von for (i=0;i<number;i++) */

  } /* Ende von while strlen(line_buf)>0 */
 } /* Ende von while != EOF */

stop_label:
fclose(startfile);
free(line_buf);
free(input_buf);
free(change_buf);
free(list);
free(message);
free(flags);
return(found_change);
}


   
