/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
**                                                                    **
***********************************************************************/
#include "stdinc.h"
#include "constructs.h"
#include "prepare.h"



void get_int(char *filename,char *search,char *par_name,int *value)
{
   FILE *para_file;
   char *helpstr, *input, *dummy __attribute__ ((unused));
   string list;
   int bp1,bp2,ip1,ip2,i,k,comment,number;
   int found=-1,*flags;

   input=(char *) malloc(_BUFSIZE_*sizeof(char));
   helpstr=(char *) malloc(100*sizeof(char));

   para_file=fopen(filename,"rb");

/* Parameternamen suchen */
   while (found < 0)
      {
      if (fgets(helpstr,100,para_file) == 0) goto stop_label;
      found=strpos(helpstr,par_name);
      }
      ip1=strpos(helpstr,"[");
      ip2=strpos(helpstr,"]");
      number=1;
      /* maximalen Index bestimmen */
      if (ip2>ip1) number=atoi(strmid(helpstr,ip1+1,ip2-ip1-1));
      flags=ivector(1,number);
      for (i=1;i<=number;i++) flags[i]=0;

/* search-Block suchen */
   found=-1;
   rewind(para_file);
   while (found < 0)
      {
      if (fgets(helpstr,100,para_file) == 0) goto stop_label;
      found=strpos(helpstr,search);
      }

/* Nach Variablen suchen, deren Inhalt geaendert werden soll */

   while (fgets(helpstr,100,para_file) != 0)
     {
     comment=strpos(helpstr,rem1);
     while (comment >= 0)
       {
       if (strpos(helpstr,rem2) >= 0) comment=-1;
       if (fgets(helpstr,100,para_file) == 0) goto stop_label;
       } /* ende von comment>=0 */
       i=strpos(helpstr,par_name);
       if (i >= 0)
          {
          sprintf(input,"%s",strmid(helpstr,i,(int) strlen(helpstr)-i));
          k=strpos(input,";");
          if (k>0) sprintf(input,"%s",strmid(input,0,k+1));

          ip1=strpos(input,"[");
          ip2=strpos(input,"]");
          if (ip2>ip1)
          /* Parameter aus Array lesen und auf die Elemente setzen */
           {
            sprintf(list,"%s",strmid(input,ip1+1,ip2-ip1-1));
            set_flags(list,flags);

            bp1=strpos(input,"{");
            bp2=strpos(input,"}");
            if (bp1>0)
             {
             while (bp2 == -1)
               {
               dummy= fgets(helpstr,100,para_file);
               input=strcat(input,helpstr);
               bp2=strpos(input,"}");
               }
             }
             else
             {
             bp1=strpos(input,"=");
             bp2=strpos(input,";");
             if (bp1 < 0 || bp2 < 0)
             {
                printf("Error in line containing: %s\n",input);
                std_error("Missing delimiter (gi1)");
             }

             }

             sprintf(input,"%s",strmid(input,bp1+1,bp2-bp1-1));

            for (k=1;k<=number;k++)
              if (flags[k]!=0)
               {
               bp1=strpos(input,",");
               if ( bp1 > 0 )
                {
                sprintf(helpstr,"%s",strmid(input,0,bp1));
                sprintf(input,"%s",strmid(input,bp1+1,(int) strlen(input)-bp1-1));
                }
               else
                {
                sprintf(helpstr,"%s",input);
                }
               sscanf(helpstr,"%d",&value[k]);
#if defined (__verbose__)
               printf("%s: %s[%d]= %f \n",search,par_name,k,(float) value[k]);
               fflush(stdout);
#endif
               }
           }
           else
           {
          /* einzelnen Parameter lesen und auf die Variable setzen */
           bp1=strpos(input,"=");
           bp2=strpos(input,";");
           if (bp1 < 0 || bp2 < 0)
           {
              printf("Error in line containing: %s\n",input);
              std_error("Missing delimiter (gi2)");
           }
           sscanf(strmid(input,bp1+1,bp2-bp1-1),"%d",value);
#if defined (__verbose__)
           printf("%s: %s = %d \n",search,par_name,*value);
           fflush(stdout);
#endif
           }
         goto stop_label;
         }
      }
    stop_label:
    free(input);
    free(helpstr);
    fclose(para_file);
}

