/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
**                                                                    **
***********************************************************************/
#include "struct.h"
/*
Evaluation of time series without interpolation.
The parameter leftright determines, whether the switch between the values shall take place
at the left 'border' of a given time interval or at the right 'border' (__RIGHTSLOPE, __LEFTSLOPE)
*/
real no_interpolation_2(int leftright,real iptime,real *itime,real *values,int *number)
{
int i,j,k1,k2,ip_dis=0,num;
real ipv;
real ipyear,ipmonth,ipday;
real min_year=100000.,max_year=-100000.;

/* Falls die Zeitdaten im Format YYMMDD angegeben sind, werden sie
** auf Simulationstage umgerechnet, dies erfolgt beim ersten Aufruf dieser
** Routine und wird durch Vorzeichenwechsel der Variable number markiert.
*/

num = abs(*number);
k2=1;
k1=num;

if (itime[1] > 9999.)
 {
 for (i=1;i<=*number;i++)
   {
   ipyear=floor(itime[i]/10000.);
   min_year=fmin(min_year,ipyear);
   max_year=fmax(max_year,ipyear);
   }

 for (i=1;i<=*number;i++)
   {
   iptime=itime[i];
   ipyear=floor(iptime/10000.);
   ipmonth=floor((iptime-10000.*ipyear)/100.);
   ipday=iptime-10000.*ipyear-100.*ipmonth;

   itime[i]=cycle*(ipyear-min_year)+cycle/12.*(ipmonth-1.)+ipday-1.;
   if (ipyear<correct_year(year) || (ipyear-endtim/cycle)<correct_year(year)) ip_dis=1; else ip_dis=0;
   }
 *number*=-1;
 if (ip_dis==1)
  {
  if (min_year>max_year || min_year<max_year) printf("Timeseries for years %d to %d does not fit the simulation time!!\n",
                         (int) min_year,(int) max_year);
  else
                         printf("Timeseries for year %d does not fit the simulation time!!\n",
                         (int) min_year);
  }
 }

/* Passende Werte suchen */


/* Auf den Zyklus der gegebenen Daten fitten... */
if (cycle > 0.0) {
  while (iptime >= itime[num]) iptime-=cycle;
  while (iptime < itime[1]) iptime+=cycle;
}

for (i=1;i<=num;i++)
  {
  j = i+1;
  if (j > num) j=1;
  if (iptime>=itime[i] && iptime<itime[j])
   {
   k1=i;
   k2=j;
   break;
   }
  }

/* Interpolationswert berechnen (lineare Interpolation) */
/*ipv=values[k1]+((values[k2]-values[k1])*(iptime-itime[k1])/(itime[k2]-itime[k1]));*/

if (leftright==__RIGHTSLOPE)
{
    ipv=values[k2];
}
else
{
    ipv=values[k1];
}
return(ipv);
}
