# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
proc myls {dir {ext *}} {

set files [glob -nocomplain $dir/$ext]

set help {}
foreach file $files {
 if ![file isdirectory $file] {lappend help [file tail $file]}
}
return $help
}

proc mylst {dir} {

set files [exec ls -Lt $dir]

set help {}
foreach file $files {
 if {[file extension $file] == ".a" || \
     [file extension $file] == ".c"}  {
                        lappend help [file tail $file]}
}
return $help
}

proc copy {list targ} {
foreach file $list {
#  file copy -force $file $targ
exec cp $file $targ
}
}

proc cat2 {file1 file2 targ} {
exec cat $file1 $file2 > $targ
}

proc cat3 {file1 file2 file3 targ} {
exec cat $file1 $file2 $file3 > $targ
}

proc move {list targ} {
global log

foreach file $list {
#  file copy -force $file $targ
#  file delete $file
if [file exists $file] {
   exec mv $file $targ
} else {
   $log insert end "$file doesn't exist !\n"
}
}
}

proc remove {list} {
foreach file $list {
  if [file exists $file] {
  #file delete $file
  exec rm $file
  } 
}
}

proc put {line {newline 1}} {
global log tclstop

if [info exist log] {
     if {$newline==1} {   
     $log insert end $line\n
    } else {
     $log insert end $line
    }

     $log see end
     if [string match Change* $line] {
         $par insert end $line\n
         $par see end
     }
     update
      if {$tclstop == 1} {
         $log insert end "process terminated\n"
         $log see end
         set tclstop 0
         uplevel #0 return
      }
} else {
  puts $line
}
}
