# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
#--------------------
# Rename Best
#--------------------
proc cev_gui_rename_best {} {
global lfont sourcename name pwd simtype cev_resultdir

.topp.misc.ren configure -state disabled
toplevel .lab

wm title .lab {Rename Best File}
wm geometry .lab "+270+470"
wm protocol .lab  WM_DELETE_WINDOW {bestcancel}
wm attributes .lab -topmost yes

frame .lab.up
pack .lab.up

label .lab.up.label0 -font $lfont -text "Files will be copied to $pwd/cevosruns" -anchor w -fg darkgreen
pack .lab.up.label0 -padx 20

set sourcename "$cev_resultdir/best"

entry .lab.up.text -width 50 -textvariable sourcename -font $lfont
pack .lab.up.text -side left

button .lab.up.choose -font $lfont -text {Browse}\
       -command {set sourcename [fileselect "File to change" $simtype $cev_resultdir open];
		         if [winfo exist .lab] { raise .lab}}
pack .lab.up.choose -side left

bind  .lab.up.text <Return> "focus .lab.down.text"

frame .lab.down
pack .lab.down

label .lab.down.label -font $lfont -text "New name" -anchor w -width 15
pack .lab.down.label -side left -padx {25 0}

entry .lab.down.text -width 50 -textvariable name -font $lfont
pack .lab.down.text -side left

bind  .lab.down.text <Return> ".lab.but.close invoke"

focus .lab.down.text



frame .lab.but
pack .lab.but

button .lab.but.cancel -font $lfont -text {cancel} -command {bestcancel}
pack .lab.but.cancel -side left

button .lab.but.close -font $lfont -text {ok} -command {renamebestOK}
pack .lab.but.close -side left
}





proc renamebestOK {} {
global name simtype lfont sourcename
global pwd

if ![file exist $pwd/cevos_runs] {exec mkdir $pwd/cevos_runs}
set newdir $pwd/cevos_runs


if {[file extension $sourcename] != ""} {
    set sourcename [file rootname $sourcename]
}

set i_name $newdir/$name.info
set l_name $newdir/$name.log
set r_name $newdir/$name.$simtype
set p_name $newdir/$name.bat
set c_name $newdir/$name.cin
set d_name $newdir/$name.dist


set i_sourcename $sourcename.info
set l_sourcename $sourcename.log
set r_sourcename $sourcename.$simtype
set p_sourcename $sourcename.bat
set c_sourcename $sourcename.cin
set d_sourcename $sourcename.dist



if [file exists $r_sourcename] {
    exec cp $r_sourcename $r_name
    put "$r_sourcename \n renamed to \n $r_name"
} else {
    put "no file $r_sourcename"
}

if [file exists $i_sourcename] {
    exec cp $i_sourcename $i_name
} 

if [file exists $l_sourcename] {
    exec cp $l_sourcename $l_name
} 

if [file exists $p_sourcename] {
    exec cp $p_sourcename $p_name
}
 
if [file exists $c_sourcename] {
    exec cp $c_sourcename $c_name
} 

if [file exists $d_sourcename] {
    exec cp $d_sourcename $d_name
} 


set name {}
destroy .lab
.topp.misc.ren configure -state normal
}

proc bestcancel {} {
global name	
set name {}
destroy .lab
.topp.misc.ren configure -state normal
}

