# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
#--------------------
# L2 Compare Results
#--------------------
proc cev_compare_results_l2 {file2} {
global rndstop cev_reference_file
global cemhome changecounter
global difftype

set file1 $cev_reference_file    
set name3 [file rootname $file1]
if ![string match *pk $name3] {
   set file3  $name3\_pk.outc
} else {
  set file3 $file1
}
set dist -9999

if [file exist $file1] {
# Testen, ob vom Referenzlauf die Spektren vorliegen
	if ![file exist $file3] {
			set logfile $name3\_transform.log
			set command  "$cemhome/cprog/transform_result $cev_reference_file -1.0 -1.0 > $logfile"
			set dummy [eval exec $command]
			put "Fourier transforming of reference file, this will take some time ..."
	}
	if {[file exist $file2]}  {
	# Spektren des letzten Simulationlaufs erzeugen
			set name2 [file rootname $file2]
			set logfile $name2\_transform.log
			set command  "$cemhome/cprog/transform_result $file2 -1.0 -1.0 > $logfile"
			set dummy [eval exec $command]
	# Distanz berechnen
			set dist  [exec $cemhome/cprog/compare_result-L2 $file3 $name2\_pk.outc [expr $difftype-10]]
   }
} else {
        put "**********************************************************" 
        put "Reference file $cev_reference_file not found !!" 
        put "**********************************************************" 
        set rndstop 1
}
return $dist
}


