# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg

proc cev_setvars {} {
global cev_resultdir 
global cev_file cin_file cev_reference_file

global difftype
global smallchange bigchange
global maxruns maxsteps
global posval groupchange
global SA T Trem rate


# Referenz-Datei
set cev_reference_file ""

# cevos-Datei
set cev_file $cev_resultdir/cevos.cev


# cin-Datei

set cin_file ""

#Optimierung
# SA=0 exakter Vergleich EX
#SA=1 Threshold Acceptance TA
#SA=2 Simulated Annealing SA

set SA 0

# Variationrate der Parameter
set smallchange 0.1
# grosse Variation der Parameter (nur SA=0)
set bigchange 1.0

# Anzahl Runs bis zulaessige Aenderung erhöht wird EX
# Anzahl bis Temperatur erniedrigt wird TA, SA
set maxsteps 10

#  Anzahl Runs bis zur Neuinitialisierung
set maxruns 100

# Distanzen (Kostenfunktionen)
set difftype 1

# posval=0 alle Parameterwerte annehmen
# posval=1 nur positive Parameterwerte annehmen
set posval 1

# groupchange=0 nur einen der aktiven Parameter veraendern
# groupchange=1 alle aktiven Parameter veraendern
set groupchange 0

# Initialisierung des Simulated Annealing and Threshold Acceptance
#Anfangstemperatur SA bzw  Anfangsschwellenwert TA
set T 1

#Veringerungsrate SA und TA
set rate 0.9


##########################################################################
##########################################################################

# Reading cevos.init

set name $cev_resultdir/cevos.init

if [file exist $name] {
  puts "Reading settings from cevos.init"
  set id [open $name r]

   while {[gets $id line] >=0} {

   eval $line
   }
   close $id
}
set Trem $T
#puts $difftype


}


