/* CEMOS/CEMTK 4.0 Copyright (C) 2007, Cora Kohlmeier, Frank Hamberg */

#include "stdinc.h"
long int numharm;

int main(int argc, char *argv[])
{
 real L2_norm(int,real*);
 real L2_normsum(int,real*,real*);
 real L2_normdiff(int,real*,real*);
  real L2_scalar(int,real*,real*);

 void *readheader(FILE*,header*,int);
 
 string in_name1,in_name2,out_name,shortname,para,var1,var2,helpname;
 long int numharm1,numharm2;

 int i,j,k,l,n,m,found,method,cp;
 int namelength,namelength1, namelength2;
 int years1,years2;

 unsigned int nvars;

 void *names1,*names2;
 long_name *out_names,one_name;

 float *dat;
 float dist,val;
 unsigned int *index1, *index2, count;

  real **all_data1,**all_data2;
  real *target_data,*input1,*input2;
  real *normfac;
  real __zero = 1e-14;
  real y1,y2,y3;

  FILE *in_file1, *in_file2, *out_file;

  header oh,oh1,oh2;


  sprintf(in_name1,"%s",argv[1]);
  sprintf(in_name2,"%s",argv[2]);

  sprintf(para,"%s",argv[3]);
  sscanf(para,"%d",&method);
/*  printf("Method = %d\n",method);*/

  in_file1=fopen(in_name1,"rb");
  in_file2=fopen(in_name2,"rb");

  if (in_file1 == NULL)
  {
     std_error("COMPARE_RESULT: Error when opening result file 1 for reading");
  }

  if (in_file2 == NULL)
  {
     std_error("COMPARE_RESULT: Error when opening result file 2 for reading");
  }

  cp = strpos(in_name2,"/");
  while (cp >= 0)
  {
    sprintf(in_name2,"%s",strmid(in_name2,cp+1,strlen(in_name2)-cp-1));
    cp = strpos(in_name2,"/");
  }

   if (strpos(in_name1,".outb") > 0) {
      namelength1 = sizeof(name12);
   } else {
      namelength1 = sizeof(long_name);
   }
   names1 = readheader(in_file1,&oh1,namelength1);

  if (strpos(in_name2,".outb") > 0) {
      namelength2 = sizeof(name12);
   } else {
      namelength2 = sizeof(long_name);
   }
   names2 = readheader(in_file2,&oh2,namelength2);

/*    Ausgabenamen zusammenbauen und dabei die Extension ".outb" oder ".outc" abschneiden */
   i=strpos(in_name1,".out");
   sprintf(in_name1,"%s",strmid(in_name1,0,i));
   i=strpos(in_name2,".out");
   sprintf(in_name2,"%s",strmid(in_name2,0,i));
   sprintf(out_name,"%s_%s_m%s.L2dist",in_name1,in_name2,argv[3]);


  if (oh1.outdelt != oh2.outdelt)
  {
     std_error("COMPARE_RESULT: outdelts of pk-files are not compatible");
  }

 namelength = sizeof(long_name)+1;

 numharm1 = oh1.maxdelt;
 numharm2 = oh2.maxdelt;
 numharm = IMIN(numharm1,numharm2);

/* Variablennamen einlesen */

/* Variablennamen fuer die Ausgabe vorbereiten */

/* mehr als die kleinere Anzahl von Variablen koennen es nicht werden*/
  oh.nvars = IMIN(oh1.nvars,oh2.nvars);
  out_names = malloc(oh.nvars*namelength);

  index1 = malloc(oh1.nvars*sizeof(unsigned int));
  index2 = malloc(oh2.nvars*sizeof(unsigned int));

  count = 0;

/*Variable-Liste zusammenbauen und die entsprechenden Spalten-Indizes dieser Daten merken */
  for (i=0;i<oh1.nvars;i++)
  {
     sprintf(var1,"%s",strtolower(strmid(names1,i*namelength1,namelength1)));
     for (j=0;j<oh2.nvars;j++)
     {
        sprintf(var2,"%s",strtolower(strmid(names2,j*namelength2,namelength2)));
	found = 0;
        if ( strpos(var1,var2) == 0)
	{
           sprintf(helpname,"%s",strmid(var1,0,namelength1));

           for (m=(int)strlen(helpname);m<namelength;m++) helpname[m]= (char) 32;

           sprintf(out_names[count],"%s",strmid(helpname,0,namelength));
           strtrim(out_names[count]);

/*           printf("%d %s\n",count,out_names[count]); */

           index1[count] = i+1;
	   index2[count] = j+1;
	   count++;
	   found = 1;
	}
     }
  }

  oh.nvars=   count;

/* Speicherplatz fuer gesamten binaeren Datenanteil reservieren ('mal sehen wie lange es geht...) */
  all_data1   = matrix(1,oh1.nvars,1,numharm1);
  all_data2   = matrix(1,oh2.nvars,1,numharm2);
  target_data = vector(1,oh.nvars);
  input1 = vector(1,numharm);
  input2 = vector(1,numharm);
/* Simulationsdaten einlesen */

/* Resultfile 1*/
/* Speicherplatz fuer einen Satz von Resultfile 1*/
  dat = fvector(1,oh1.nvars);

/*   printf("Reading data of %s..\n",argv[1]); */
  fflush(stdout);
/* Hauptschleife ueber alle Variablen */
  for (k=1;k<=numharm1;k++)
     {
/* Einen "Tag" einlesen */
      fread(&dat[1],sizeof(float),oh1.nvars,in_file1);

      for (i=1;i<=oh1.nvars;i++)
        {
        all_data1[i][k] = (real) dat[i];
        }
     }
  fclose(in_file1);
  free_fvector(dat,1,oh1.nvars);

/* Resultfile 2*/
/* Speicherplatz fuer einen Satz von Resultfile 2*/
  dat = fvector(1,oh2.nvars);

/*   printf("Reading data of %s..\n",argv[2]); */
  fflush(stdout);
/* Hauptschleife ueber alle Variablen */
  for (k=1;k<=numharm2;k++)
     {
/* Einen "Tag" einlesen */
      fread(&dat[1],sizeof(float),oh2.nvars,in_file2);

      for (i=1;i<=oh2.nvars;i++)
        {
        all_data2[i][k] = (real) dat[i];
        }
     }
  fclose(in_file2);
  free_fvector(dat,1,oh2.nvars);

/* Berechnung ausfuehren  */
/*   printf("Analysing data with method %d\n",method); */
  fflush(stdout);

for (i=1;i<=oh.nvars;i++)
{
    for (j=1;j<=numharm;j++)
    {
        input1[j] = all_data1[i][j];
        input2[j] = all_data2[i][j];
    }
/* Default-Distanz setzen, fuer den Fall, dass weiter unten irgendwo falscherweise eine Distanz Null berechnet wird */
    target_data[i]=1.0e12;
    switch (method)
	{
/*PV-Wave Funktionen
1 ||f-g||/||f+g||
2 ||f-g||/min(||f||,||g||)
3 ||f-g||/(||g||+||f||-||f-g||)
4 1-<f,g>/(||f||||g||)
5 (||f||||g||-<f,g>)/(||f||||g||+<f,g>)
6 arccos(<f,g>)/(||f||||g||))
7|ln(||f||/||g||)|
8 max(||f||/||g||,||g||/||f||)-1
9 No. 6 + No. 7
*/


        case 1: y1=L2_normdiff(numharm,input1,input2);
                      y2=L2_normsum(numharm,input1,input2);
                     if (y2>0.0)  target_data[i]=y1/y2; 
                     break;

        case 2: y1 = L2_normdiff(numharm,input1,input2);
                     y2 = rmin(L2_norm(numharm,input1),L2_norm(numharm,input1));
                     if (y2>0.0) target_data[i]=y1/y2; 
                     break;

        case 3: y1 = L2_normdiff(numharm,input1,input2);
                     y2 = L2_norm(numharm,input1);
                     y3 = L2_norm(numharm,input2);
                     if ((y2+y3-y1)>0.0) target_data[i]=y1/(y2+y3-y1);
                     break;

        case 4: y1 = L2_scalar(numharm,input1,input2);
                     y2 = L2_norm(numharm,input1);
                     y3 = L2_norm(numharm,input2);
                     if ((y2*y3)>0.0) target_data[i]=1.0 - y1/(y2*y3);
                     break;

        case 5: y1 = L2_scalar(numharm,input1,input2);
                     y2 = L2_norm(numharm,input1);
                     y3 = L2_norm(numharm,input2);
                     if (((y2*y3)-y1)*((y2*y3)+y1)>0.0) target_data[i]= ((y2*y3)-y1)*((y2*y3)+y1);
                     break;

        case 6: y1 = L2_scalar(numharm,input1,input2);
                     y2 = L2_norm(numharm,input1);
                     y3 = L2_norm(numharm,input2);
                     if ((y2*y3)>0.0) target_data[i]= acos(y1/(y2*y3));
                     break;

        case 7: y2 = L2_norm(numharm,input1);
                     y3 = L2_norm(numharm,input2);
                     if ((y2*y3)>0.0) target_data[i]= rabs(log(y2*y3));
                     break;

         case 8:y2 = L2_norm(numharm,input1);
                     y3 = L2_norm(numharm,input2);
                     if (y2>0.0 && y3>0.0) target_data[i]= rmax((y2/y3),(y3/y2))-1.0;
                     break;

         case 9:y1 = L2_scalar(numharm,input1,input2);
                     y2 = L2_norm(numharm,input1);
                     y3 = L2_norm(numharm,input2);
                     if ((y2*y3)>0.0) target_data[i]= acos(y1/(y2*y3)) + rabs(log(y2*y3));
                     break;


	default: printf("COMPARE_RESULT-L2: method=%d\n",method+1);
                       std_error("COMPARE_RESULT-L2: Undefined method");
	}
        }
     
  

//   stoert nur
//   out_file=fopen(out_name,"wb");

/* Daten schreiben*/
    dist=0.0;  
     for (i=1;i<=oh.nvars;i++) 
     {
          dist+=target_data[i];
//           fprintf(out_file,"%s , %f\n",out_names[i-1],target_data[i]);
     }

 /*printf("numharm %d\n", numharm);
 printf("vars %d\n", oh.nvars);*/

   printf("%f\n", dist/(1.0*oh.nvars));
//    fprintf(out_file,"Distance %d, %f\n", method, dist/(1.0*oh.nvars));
//    fclose(out_file);

/*   printf("Ready\n"); */
  fflush(stdout);
/* return(dist/numharm/oh.nvars); */
  return(0);
}






