/* MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */

#include "stdinc.h"

void matr_vect_mult(real **in_matrix,real *in_vector,real *out_vector,int start_line,int end_line,int start_row,int end_row,
                                    int start_in, int end_in,int start_out,int end_out)
{
/* Input :  real **in_matrix	Pointer to input matrix dimension num_cols,num_rows
                real *in_vector		Pointer to input vector dimension vec_len

   Output: real *out_vector      Pointer to output vector dimension vec_len
*/
int i,j;
int num_rows,vec_len;
real a,b;

num_rows = end_row - start_row;
vec_len      = end_in - start_in;
if (num_rows != vec_len) std_error("MATR_VEC_MULT: Input matrix and input vector are not compatible");

for (i=start_line; i<=end_line; i++)
    {
    out_vector[start_out-start_line+i]=0.0;
    for (j=start_row; j<=end_row; j++)
        {
        a = in_matrix[i][j];
	b = in_vector[start_in-start_row+i];

	out_vector[start_out-start_line+i] += in_matrix[i][j] * in_vector[start_in-start_row+j];
	}
    }
}

