# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
proc dirbrowse {{dir .}} {
global binddir pwd
global targ
global targetdir

set binddir $dir

toplevel .browse
wm title .browse "Select directory"
wm geometry .browse +400+200

frame .browse.list
pack .browse.list

scrollbar .browse.list.scroll -command ".browse.list.list yview"
pack .browse.list.scroll -side right -fill y
listbox .browse.list.list -yscroll ".browse.list.scroll set" -relief sunken -width 20 -height 10 \
	-setgrid yes
pack .browse.list.list -fill both -expand yes


proc refreshdir {dir} {
global binddir targ

   .browse.list.list delete  0 end

   proc browse {dir file} {
                         cd $file
                         set file [pwd]

    refreshdir $file

   }

   set files ".. [glob -nocomplain $dir/*]"
   foreach i $files {
   if [file isdirectory $i] {.browse.list.list insert end [file tail $i]}
   }

   set binddir $dir
   bind all <Control-c> {destroy .browse}
   bind .browse.list.list <Button-1> \
                     {set targ [pwd]/[%W get [%W nearest %y]]}

   bind .browse.list.list <Double-Button-1> \
                     {browse $binddir [selection get]}
}

frame .browse.but
pack .browse.but

button  .browse.but.cancel -text {cancel} \
         -command {cd $pwd;set targetdir {};destroy .browse}
pack  .browse.but.cancel  -side left -fill x

button  .browse.but.ok -text {OK} \
         -command {if [info exist targ] {
                      cd $pwd
                      set targetdir $targ
                      destroy .browse
                    }
                  }
pack  .browse.but.ok  -side left -fill x

refreshdir $dir

tkwait variable targetdir
return $targetdir
}
