# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg

proc customtool {} {
global  pwd ismacosapp
global can
global filename cemhome
global toolflag data
global colorscheme
global filename allbuts logwindows sfont lfont
global defaulteditor
global simtype

toplevel .custom

wm title .custom {Tiger Graphics CEMTK Options}
set pos  [split [wm geometry .] +x]
wm geometry .custom "+[expr [lindex $pos 2]+100]+[expr [lindex $pos 3]+100]"

#wm sizefrom .custom user
set toolflag custom
set defaulteditor ""

readdefaults

set pady 5
set width 50
set bfs [lindex [split $lfont " "] 1]
set tfs [lindex [split $sfont " "] 1]

# Initializing of the buttons
##############################
frame .custom.c1
pack .custom.c1 -pady 20

label .custom.c1.edtext -text " Editor" -font $lfont
pack .custom.c1.edtext -side left -pady $pady

entry .custom.c1.ed -width $width -bd 2 -textvariable defaulteditor -font $lfont
pack  .custom.c1.ed -side left

button  .custom.c1.sed -text {  Browse  } -font $lfont\
-command { set defaulteditor [fileselect  "Select Editor Program" "*.exe" $home open];raise .custom }
pack  .custom.c1.sed -side left

button  .custom.c1.empty -text {  Reset  } -font $lfont -command { set defaulteditor ""}
pack  .custom.c1.empty -side left

##############################
frame .custom.fonts
pack .custom.fonts -pady 5

#~ button .custom.fonts.fontsel1 -text { Select Button/Label Font }  -font $lfont \
           #~ -command {set cemtkfont [Font_Select "Buttons/Labels" $lfont]; if {$cemtkfont !=""} {set lfont $cemtkfont}}
#~ pack .custom.fonts.fontsel1 -side left

#~ button .custom.fonts.fontsel2 -text { Select Info Window Font } -font $lfont \
           #~ -command {set cemtkfont [Font_Select "Info Window" $sfont]; if {$cemtkfont !=""} {set sfont $cemtkfont}}
#~ pack .custom.fonts.fontsel2 -side left
menubutton .custom.fonts.fontsel1  -relief raised -font $lfont -text "Button/Label Font Size: $bfs" -menu .custom.fonts.fontsel1.menu
set m [menu .custom.fonts.fontsel1.menu -tearoff 0]
foreach item "6 8 9 10 11 12 13 14 15 16 18" {
    $m add radio -label $item -font $lfont -variable bfs -command {set lfont "-size [list $bfs]"}
}    
menubutton .custom.fonts.fontsel2  -relief raised -font $lfont -text "Info Window Font Size: $tfs" -menu .custom.fonts.fontsel2.menu
set m [menu .custom.fonts.fontsel2.menu -tearoff 0]
foreach item "6 8 9 10 11 12 13 14 15 16 18" {
    $m add radio -label $item -font $lfont -variable tfs -command {set sfont "-size [list $tfs]"}
}    
pack .custom.fonts.fontsel1 -side left -padx 1
pack .custom.fonts.fontsel2 -side left -padx 1

##############################
# Color Scheme
frame .custom.color
pack .custom.color -pady 2

label .custom.color.text  -font $lfont -text "GUI Color Scheme"
pack .custom.color.text -side left -pady 2 

foreach but "classic blue grey steel" {
	radiobutton .custom.color.$but  -font $lfont -variable colorscheme \
              -text $but  -value $but
	pack .custom.color.$but -side left -pady 2
}

#############################
frame .custom.simtype
pack .custom.simtype -pady 5

label .custom.simtype.text -text "Output Type" -font $lfont
pack .custom.simtype.text -side left -pady 5


radiobutton .custom.simtype.outc -variable simtype -font $lfont \
              -text "ERSEM (.outc)"  -value "outc"
radiobutton .custom.simtype.outa -variable simtype -font $lfont \
              -text "CSV (.outa)"  -value "outa"
radiobutton .custom.simtype.nc -variable simtype -font $lfont \
              -text "netCDF (.nc)"  -value "nc"

pack .custom.simtype.outc -side left -pady 2
pack .custom.simtype.outa -side left -pady 2
pack .custom.simtype.nc -side left -pady 2

#############################

frame .custom.button
pack .custom.button -side bottom

button  .custom.button.reset -text {Reset to Defaults} -command {
	file copy -force $cemhome/cem5defaults $home/.cem5defaults
	if {$ismacosapp==1} {
		set command "open -a CEMTK -n --args $pwd/cemos.par"
		eval exec $command
		exit
	} else {
	destroy .custom
	destroy .
		set command "exec $cemhome/cem $pwd/cemos.par"
		catch $command
	}
}
pack .custom.button.reset -side left


button  .custom.button.cancel -text {  Cancel } -font $lfont -command {
destroy .custom
activate $allbuts
activate_start}
pack  .custom.button.cancel -side left

button  .custom.button.exit -text {Apply & Exit} -font $lfont -command {
	writedefaults
	if {$ismacosapp==1} {
		set command "open -a CEMTK -n --args $pwd/cemos.par"
		eval exec $command
		exit
	} else {
		destroy .custom
		destroy .
		set command "exec $cemhome/cem $pwd/cemos.par"
		catch $command
	}
}

pack  .custom.button.exit -side left

update idletasks
}

