# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
proc setmenu {} {
global modelhome pwd

.topp.mod.pwd config -text  "Current Directory: $pwd"
.topp.mod.moh config -text  "Model Directory:  $modelhome"

setendmenu
setoutmenu
setstrmenu
setmaxmenu
#setminmenu
setmetmenu
setaccmenu
#setrramenu
#setrchmenu
}

proc setendmenu {} {
global mend endtime
global lfont
set labels {7 10 15 30 50 60 90 100 120 200 360 365 366 500 720 730 1000 1080 1095 1440 1460 1800 1825 3600 3650 7200 7300}

$mend delete 0 end


if {[lsearch -exact $labels $endtime]==-1} {
  $mend add radio -font $lfont -label $endtime -variable endtime \
               -command {WritePar}
}

foreach lab $labels {
  $mend add radio -font $lfont -label $lab -value $lab -variable endtime \
               -command {WritePar}
}

}

proc setoutmenu {} {
global mout outdelt
global lfont
set labels {0.01 0.1 1.0 2.0 5.0 10.0 30.0 360.0}
$mout delete 0 end

if {[lsearch -exact $labels $outdelt]==-1} {
  $mout add radio -font $lfont -label $outdelt -variable outdelt \
               -command {WritePar}
}

foreach lab $labels {
  $mout add radio -font $lfont -label $lab -variable outdelt \
               -command {WritePar}
}

}

proc setstrmenu {} {
global mstr storetim
global lfont
set labels {0.0 100.0 360.0 400.0 720.0 900.0 1080.0 1440.0 1800.0 3240.0 3600.0}
$mstr delete 0 end

if {[lsearch -exact $labels $storetim]==-1} {
  $mstr add radio -font $lfont -label $storetim -variable storetim \
               -command {WritePar}
}

foreach lab $labels {
  $mstr add radio -font $lfont -label $lab -variable storetim \
               -command {WritePar}
}

}



proc setmaxmenu {} {
global mmaxsub mmax maxsub maxdelt
global multi maxmulti
global lfont
set labels {1.0 0.1 0.01 0.001}

$mmax delete 0 end

for {set i 1} {$i <= $maxmulti} {incr i} {
  if [info exist maxsub($i)] {
     if [winfo exist $maxsub($i)] {destroy $maxsub($i)}
  }
}

if {$multi > 1} {
 for {set i 1} {$i <= $multi} {incr i} {
   set mmaxsub($i) [$mmax add cascade -label "method $i" \
                    -menu $mmax.sub($i) -font $lfont]

   set maxsub($i) [menu $mmax.sub($i) -tearoff 0]
   if {[lsearch -exact $labels $maxdelt($i)]==-1} {
     $maxsub($i) add radio -font $lfont -label $maxdelt($i) -variable maxdelt($i) \
               -command {WritePar}
   }

   foreach lab $labels {
     $maxsub($i) add radio -font $lfont -label $lab -variable maxdelt($i) \
               -command {WritePar}
   }
 }
} else {
   if {[lsearch -exact $labels $maxdelt(1)]==-1} {
     $mmax add radio -font $lfont -label $maxdelt(1) -variable maxdelt(1) \
               -command {WritePar}
   }
   foreach lab $labels {
     $mmax add radio -font $lfont -label $lab -variable maxdelt(1) \
               -command {WritePar}
   }
}
}

proc setminmenu {} {
global mminsub mmin minsub mindelt
global multi maxmulti
global lfont
set labels {0.001 0.0001 0.00001 0.000001}

$mmin delete 0 end

for {set i 1} {$i <= $maxmulti} {incr i} {
  if [info exist minsub($i)] {
     if [winfo exist $minsub($i)] {destroy $minsub($i)}
  }
}

if {$multi > 1} {
for {set i 1} {$i <= $multi} {incr i} {
   set mminsub($i) [$mmin add cascade -font $lfont -label "method $i" \
                    -menu $mmin.sub($i)]

   set minsub($i) [menu $mmin.sub($i) -tearoff 0]
   if {[lsearch -exact $labels $mindelt($i)]==-1} {
    $minsub($i) add radio -font $lfont -label $mindelt($i) -variable mindelt($i) \
               -command {WritePar}
   }
   foreach lab $labels {
     $minsub($i) add radio -font $lfont -label $lab -variable mindelt($i) \
               -command {WritePar}
   }
}
} else {
   if {[lsearch -exact $labels $mindelt(1)]==-1} {
    $mmin add radio -font $lfont -label $mindelt(1) -variable mindelt(1) \
               -command {WritePar}
   }
   foreach lab $labels {
     $mmin add radio -font $lfont -label $lab -variable mindelt(1) \
               -command {WritePar}
   }
}
}

proc setmetmenu {} {
global mmetsub mmet metsub method
global multi maxmulti
global lfont
set labels { "No Integration"\
             Fixstep\
             Euler \
            "Runge-Kutta 2nd order, pos." \
            "Runge-Kutta 4th order, pos."\
            "Runge-Kutta Cash-Karp, pos."\
            "Runge-Kutta 2nd order"\
            "Runge-Kutta 4th order"\
            "Runge-Kutta Cash-Karp"\
            "Reverse Euler"\
}

set values "99 0 1 2 3 4 -2 -3 -4 9"
$mmet delete 0 end

for {set i 1} {$i <= $maxmulti} {incr i} {
  if [info exist metsub($i)] {
     if [winfo exist $metsub($i)] {destroy $metsub($i)}
  }
}

if {$multi > 1} {
for {set i 1} {$i <= $multi} {incr i} {
   set mmetsub($i) [$mmet add cascade -font $lfont -label "method $i" \
                    -menu $mmet.sub($i)]

   set metsub($i) [menu $mmet.sub($i) -tearoff 0]
   foreach lab $labels {
     set which [lsearch -exact $labels $lab]
     $metsub($i) add radio -font $lfont -label $lab -variable method($i) \
                                       -value [lindex $values $which] \
               -command {WritePar}
   }
}
} else {
   foreach lab $labels {
    set which [lsearch -exact $labels $lab]
    $mmet add radio -font $lfont -label $lab -variable method(1) \
                                       -value [lindex $values $which] \
               -command {WritePar}
   }
}
}


proc setaccmenu {} {
global maccsub macc accsub accuracy
global multi maxmulti
global lfont
set labels {0.0 1.0 0.1 0.01 0.001 0.0001 0.00001}

$macc delete 0 end

for {set i 1} {$i <= $maxmulti} {incr i} {
  if [info exist accsub($i)] {
     if [winfo exist $accsub($i)] {destroy $accsub($i)}
  }
}

if {$multi > 1} {
for {set i 1} {$i <= $multi} {incr i} {
   set maccsub($i) [$macc add cascade -font $lfont -label "method $i" \
                    -menu $macc.sub($i)]

   set accsub($i) [menu $macc.sub($i) -tearoff 0]
   if {[lsearch -exact $labels $accuracy($i)]==-1} {
     $accsub($i) add radio -font $lfont -label $accuracy($i) -variable accuracy($i) \
               -command {WritePar}
   }
   foreach lab $labels {
     $accsub($i) add radio -font $lfont -label $lab -variable accuracy($i) \
               -command {WritePar}
   }
}
} else {
   if {[lsearch -exact $labels $accuracy(1)]==-1} {
     $macc add radio -font $lfont -label $accuracy(1) -variable accuracy(1) \
               -command {WritePar}
   }
   foreach lab $labels {
     $macc add radio -font $lfont -label $lab -variable accuracy(1) \
               -command {WritePar}
   }
}
}


proc setrramenu {} {
global mrrasub mrra rrasub relrate
global multi maxmulti
global lfont
set labels {1.0 0.5 0.25}

$mrra delete 0 end

for {set i 1} {$i <= $maxmulti} {incr i} {
  if [info exist rrasub($i)] {
     if [winfo exist $rrasub($i)] {destroy $rrasub($i)}
  }
}

if {$multi > 1} {
for {set i 1} {$i <= $multi} {incr i} {
   set mrrasub($i) [$mrra add cascade -font $lfont -label "method $i" \
                    -menu $mrra.sub($i)]

   set rrasub($i) [menu $mrra.sub($i) -tearoff 0]
   if {[lsearch -exact $labels $relrate($i)]==-1} {
    $rrasub($i) add radio -font $lfont -label $relrate($i) -variable relrate($i) \
               -command {WritePar}
   }
   foreach lab $labels {
     $rrasub($i) add radio -font $lfont -label $lab -variable relrate($i) \
               -command {WritePar}
   }
}
} else {
   if {[lsearch -exact $labels $relrate(1)]==-1} {
    $mrra add radio -font $lfont -label $relrate(1) -variable relrate(1) \
               -command {WritePar}
   }
   foreach lab $labels {
     $mrra add radio -font $lfont -label $lab -variable relrate(1) \
               -command {WritePar}
   }
}
}

proc setrchmenu {} {
global mrchsub mrch rchsub relchange
global multi maxmulti
global lfont
set labels {1.0 0.5 0.25 0.125}

$mrch delete 0 end

for {set i 1} {$i <= $maxmulti} {incr i} {
  if [info exist rchsub($i)] {
     if [winfo exist $rchsub($i)] {destroy $rchsub($i)}
  }
}

if {$multi > 1} {
for {set i 1} {$i <= $multi} {incr i} {
   set mrchsub($i) [$mrch add cascade -font $lfont -label "method $i" \
                    -menu $mrch.sub($i)]

   set rchsub($i) [menu $mrch.sub($i) -tearoff 0]
   if {[lsearch -exact $labels $relchange($i)]==-1} {
    $rchsub($i) add radio -font $lfont -label $relchange($i) -variable elchange($i) \
               -command {WritePar}
   }
   foreach lab $labels {
     $rchsub($i) add radio -font $lfont -label $lab -variable relchange($i) \
               -command {WritePar}
   }
}
} else {
   if {[lsearch -exact $labels $relchange(1)]==-1} {
    $mrch add radio -font $lfont -label $relchange(1) -variable elchange(1) \
               -command {WritePar}
   }
   foreach lab $labels {
     $mrch add radio -font $lfont -label $lab -variable relchange(1) \
               -command {WritePar}
   }
}
}
