# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
proc startbatch {{resnum 0} {cinflag 0}} {
global batname simname tclstop bg allbuts pwd outputtype
global toolflag GUI
global batdirrem
global rundir moc_batname cev_resultdir cin_file
 
if ![info exist batdirrem] {set batdirrem $pwd}
if ![info exist cin_file] {set cin_file ""}
if ![info exist outputtype] {set outputtype outc}
set series 0
set cinrun 0

switch $toolflag {

      cemtk {
        set my_pwd $pwd
        
        if {$GUI==1} {       
            if {![info exist batname]} {
               set batname [fileselect "Select Batch File" bat $batdirrem open]
            }
         }
         puts $batname 

        }
      mocos {
        set my_pwd $pwd/mocos
        set batname $my_pwd/$moc_batname
        }
      
      cevos {
        set my_pwd $pwd/cevos
        set batname $my_pwd/sensitivity.bat
        set bg 0
        }
}

if [file exists $batname] {
  set batdirrem [file dir $batname]
  set batin [open $batname r]
  gets $batin line

  if {[string match %series $line]} {
# Serie
     set series 1
     set resnum 0
     gets $batin line

     set batlist [split $line :]
     set name [lindex $batlist 0]
     set von  [lindex $batlist 1]
     set bis  [lindex $batlist 2]
     set step [lindex $batlist 3]

     set batrun $my_pwd/.series.bat
     set batrunid [open $batrun w]

     for {set i $von} {$i<=$bis} {set i [format "%8.4f" [expr $i+$step]]} {
        puts $batrunid "$name=$i;"
     }
    close $batrunid
    
    if {$cinflag == 0} {
       set rundir $my_pwd/$name\_sens
       if ![file exist $rundir] {exec mkdir $rundir}
    }
  } else {

#   keine Serie
    set series 0
    set batrun $batname

# bei cemtk wird ein Verzeichnis angelegt, dass wie die batchdatei heisst
   if {$toolflag=="cemtk" || $toolflag=="mocos" } {
    if {$cinflag == 0} {
          set rundir [file dirname $batname]/[file rootname [file tail $batname]]
          if ![file exist $rundir] {exec mkdir $rundir}
     }
    } else { 
# bei cevos wird direkt in das Verzeichnis geschrieben   
         set rundir $my_pwd  
    }
  }
close $batin


set batid [open $batrun r]
if {$series==1} {
  set playlist [open $rundir/$name.lst w]
}

set linecounter 0
while {[gets $batid line] >0} {
        incr linecounter
        set resdirset 0
        set sensid [open $pwd/.sensitivity.def w]
        puts $sensid "\%change"
		if {$toolflag == "cevos"} {puts $sensid "resulttype outc"}
        if {$cin_file !=""} {
            set cin_id [open $cin_file r]
             while {[eof $cin_id]==0} {
                 gets $cin_id cin_line
                puts $sensid $cin_line
             }
            puts $sensid "\n"
            close $cin_id

        }
        puts $sensid "\n"
        puts $sensid "\%change"
        if ![string match \/\/* $line] {
          set line2 [split $line \;]
          foreach item $line2 {
               if ![string match \#include* $item] {puts $sensid $item\;} else {puts $sensid $item}
          }
        }
        close $sensid

        if {$toolflag=="cemtk" && ![string match \/\/* $line]} {
            regsub -all {\#include } $line "" help
            regsub -all {\"} $help "" help
            regsub -all {\ } $help "" help
            set cinname $help
            set cinrun [regsub -all {\.cin} $help "" help]
            regsub -all {\.} $help "" help
            regsub -all {\=} $help "" help
            regsub -all {\;} $help "" help
            regsub -all {\{} $help "" help
            regsub -all {\}} $help "" help
            regsub -all {\[} $help "" help
            regsub -all {\]} $help _ help
            regsub -all {\-} $help to help
            regsub -all {\,} $help _ help
            regsub -all {\ } $help "" help
            regsub -all {\/\*(.*?)\*\/} $help "" help
            set help [string trimright $help]

# Wenn Name zu lang wird umgesetzt

             if {[string length $help] > 100}  {

                 set help [file tail $rundir]$linecounter

             }

            if {$cinrun == 0} {
               set simname $rundir/$help
            } else {
# Resultdir ist .cin-File gesetzt, also weiter unten keinen absoluetn Pfad erzeugen!
               set resdirset [filegrep $cinname result_dir]
               if {$resdirset==1} {
                   getresultdir $cinname
                   set simname [file tail $help]
               } else {
                   set simname $help
               }
            }
        } else {
#             mocos/cevos
            set simname $rundir/result$resnum
            incr resnum
        }
      
        if {$series==1} {
            puts $playlist $simname
        }

        if {$cinrun==1 && [file exist $cinname] || $cinrun==0} {
                #put "$simname $outputtype"
                if {$bg==1} {
                   cem_run .sensitivity.par -bg
                   if {$GUI==1} {activate $allbuts}
                } else {
                   cem_run .sensitivity.par
                   if {$GUI==1} {vwait tclstop}
               }
        }
}
close $batid

#set dummy [exec rm -f .sensitivity.def]

} else {

  put "ERROR: File sensitivity.bat doesn't exist !"
  put "No simulation started "
}

if [info exist batname] {unset batname}
if {$series == 1} {
  exec rm -f $batrun
  close $playlist
}

# Ueberfluessiges Verzeichnis löschen
if [info exist rundir] {
if [file isdirectory $rundir] {
set help [glob -nocomplain -directory $rundir *]
	 if {$help==""} {
		  puts "Empty  Directory $rundir deleted"
		  file delete $rundir

	 }
}
}
}
