# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
proc startsim {} {
global lfont simname simtype outputtype rename resultdir pwd browsedir


set outputtype $simtype

toplevel .res

wm title .res {Set Result Filename}
set pos  [split [wm geometry .] +x]

wm geometry .res "+[expr [lindex $pos 2]+100]+[expr [lindex $pos 3]+100]"
wm group .res .topp.sim
wm transient .res .topp.sim

frame .res.down
pack .res.down

label .res.down.resel -text "Set new name" -anchor w -width 20 -font $lfont
pack .res.down.resel -side left

set lab [entry .res.down.text -width 30 -textvariable simname -font $lfont]
pack .res.down.text -side left

if [info exist resultdir] {
   set browsedir $resultdir
   } else {
   set browsedir $pwd
}

button .res.down.browse -text {Browse} \
-command {set simname [file rootname [fileselect "File to write" "outc" $browsedir open]];raise .res} -font $lfont
pack .res.down.browse -side left

bind  .res.down.text <Return> ".res.but.close invoke"
focus .res.down.text

frame .res.but
pack .res.but

button .res.but.cancel -text {cancel} -command {set rename -1} -font $lfont
pack .res.but.cancel -side left

button .res.but.close -text {store under new name} -command {set rename 1} -font $lfont
pack .res.but.close -side left
#.res.but.close config -state disabled

button .res.but.overwr -text "store as result" -command {set rename 2} -font $lfont
pack .res.but.overwr -side left

radiobutton .res.but.outc -variable outputtype -font $lfont \
              -text ".outc"  -value "outc" -command {set simtype outc}
radiobutton .res.but.outa -variable outputtype -font $lfont \
              -text ".outa"  -value "outa" -command {set simtype outa}
radiobutton .res.but.nc -variable outputtype -font $lfont \
              -text ".nc"  -value "nc" -command {set simtype nc}

pack .res.but.outc -side left
pack .res.but.outa -side left
pack .res.but.nc -side left

set rename 0

tkwait variable rename
if {$rename==-1} {cancelsim}
if {$rename==1} {newname}
if {$rename==2} {defaultname}

}

proc newname {} {
global simname outputtype resultdir

if {[file extension $simname] == $outputtype} { set simname [file rootname $outputtype] }

if {$simname == {} } {
   textinfo "No filename given" 1
   textinfo "Simulation canceled" 1
   cancelsim

} else {

  if {[file dirname $simname]=="." &&  $resultdir != {} } { set simname $resultdir/$simname}
  if [file exists $simname.$outputtype] {overwrite}
  if [winfo exist .res] {destroy .res}
}
}


proc overwrite {} {
global overwrite
global lfont

toplevel .ovwres

wm title .ovwres {Overwrite}
wm geometry .ovwres "+370+170"

frame .ovwres.down
pack .ovwres.down

label .ovwres.down.resel -text "Filename already exists! Overwrite ?" -anchor w -font $lfont
pack .ovwres.down.resel -side left

frame .ovwres.but
pack .ovwres.but

button .ovwres.but.cancel -text {   no   } -command {set overwrite -1} -font $lfont
pack .ovwres.but.cancel -side left

button .ovwres.but.close -text {   yes   } -command {set overwrite 1} -font $lfont
pack .ovwres.but.close -side left


set overwrite 0

tkwait variable overwrite
if {$overwrite==-1} {cancelsim;textinfo "Simulation canceled";destroy .ovwres}
if {$overwrite==1} {destroy .ovwres}

}

proc defaultname {} {
global simname resultdir
if { $simname != ""} {
   textinfo "New Filename given !!"
   textinfo "Simulation canceled !!"
   cancelsim
} else {
   set simname $resultdir/result
   destroy .res
}
}

proc cancelsim {} {
global simname resultdir
global cancel
set cancel 1
set simname $resultdir/result
Stop
destroy .res
}
