/* MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */

#include "stdinc.h"
#include "netcdf.h"

int main(int argc, char *argv[])
{
 char *resultname;
 char *var;
 int casesen;
 int first,last;

 long int timnum=0;
 float *dat;
 float ymin=1.0e15;
 float ymax=-1.0e15;
 float yrange;
 float colmin,colmax,colrange;
 float factor,value;

  int i,ncid, varid,status;
  int ndims, numvars, ngatts, xdimid;
  long index[]={0};
  size_t start[]={0};
  size_t end[]={0};

  float startim;
  float endtim;
  float outdelt;

  resultname=argv[1];
  var=argv[2];
  sscanf(argv[3],"%d",&casesen);
  sscanf(argv[4],"%d",&first);
  sscanf(argv[5],"%d",&last);
  sscanf(argv[6],"%f",&ymin);
  sscanf(argv[7],"%f",&ymax);
  sscanf(argv[8],"%f",&colmin);
  sscanf(argv[9],"%f",&colmax);

  yrange = ymax - ymin;
  colrange = colmax -colmin;
  if (fabs(yrange) <= fabs(ymax*1e-10)) yrange = 1;
  factor=colrange/yrange;

  ncid=ncopen(resultname,NC_NOWRITE);

  varid = ncvarid(ncid,"starttime");
  status= ncvarget1(ncid,varid,index,(void*) &startim);
  if (status != NC_NOERR) std_error("Error in readfast_nc");
  varid = ncvarid(ncid,"endtime");
  status= ncvarget1(ncid,varid,index,(void*) &endtim);
  if (status != NC_NOERR) std_error("Error in readfast_nc");

  varid = ncvarid(ncid,"outdelt");
  status= ncvarget1(ncid,varid,index,(void*) &outdelt);
  if (status != NC_NOERR) std_error("Error in readfast_nc");

  timnum = (long int) (0.5+(endtim-startim)/outdelt)+1;
  end[0]=timnum;
  dat=malloc(sizeof(float)*timnum+1);
  status= nc_inq_varid(ncid, var, &varid);
  if (status != NC_NOERR) {
     printf("not_stored\n");
     return(0);
  }

  status= nc_get_vara_float(ncid,varid,start,end,dat);
  for (i=first;i<=last;i++) {
         value=colmax - (dat[i]-ymin)*factor;
         value=FMAX(colmin,FMIN(value,colmax));
         printf("%d ",(int) value);
  }
  printf("\n");
 return(0);
}


