/* MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */

#include "stdinc.h"

#define rem1 "/*"
#define rem2 "*/"

int main(int argc, char *argv[]);

int main(int argc, char *argv[])
{
void writeheader(FILE *, header*, long_name80*, int);

 char *csvname, *outbname, *input, *helpstr;
 string input_file,output_file,helpname;
 int timnum=0, timeflag=0;
 int cp,len,m,namelength;

 unsigned int nvars=0;
 int count;
 float startim;
 float outdelt;

 long_name80 *all_var_names;
 long_name svar;
 float *dat;
 float argu;

  FILE *in_file, *out_file;

  header oh;

  helpstr= (char *) malloc( (_BUFSIZE_ +128)*sizeof(char));
  input=   (char *) malloc( _BUFSIZE_*sizeof(char));
  namelength=sizeof(long_name80);
  oh.sdir = malloc(sizeof(char)*namelength);

/* Check the csv file and get the ranges */
  csvname=argv[1];
  outbname=argv[2];

  sprintf(input_file,"%s",csvname);
  sprintf(output_file,"%s_csv.outc",outbname);

  in_file=fopen(input_file,"rb");

  if (in_file == NULL)
  {
     std_error("CSV2RESULT: Error when opening data file for reading");
  }

  /* Output File oeffnen  */
  out_file=fopen(output_file,"wb");
  if (out_file == NULL)
  {
     std_error("CSV2RESULT: Error when opening result file for writing");
  }

/*  Erste Zeile mit dem Header lesen*/
  if ( fgets(input,_BUFSIZE_,in_file) == 0)
  {
     std_error("CSV2RESULT: Error no data in input file");
  }
/* Header analysieren    */

/* Speicherplatz fuer die Variablen-Namen reservieren */

   sprintf(helpstr,"%s ,",input); /*Eine Variable gibt es mindestens*/
   nvars = numchar(helpstr,",");
   all_var_names = malloc(nvars*sizeof(long_name80));
   nvars = 0; /*aber es soll noch mal genau gezaehlt werden*/

   strtrim(helpstr);
   cp = strpos(helpstr,",");
   while ( cp >= 0)
   {
      len= strlen(helpstr);
      sprintf(helpname,"%s",strmid(helpstr,0,cp));

      strtrim(helpname);
      sprintf(helpstr,"%s",strmid(helpstr,cp+1,len-cp));
      cp = strpos(helpstr,",");

      if ( strpos(helpname,"(") == -1 &&
          (strpos(helpname,"time") == 0 ||
	   (strpos(helpname,"t") == 0 && strlen(helpname)==1)))
      {
        timeflag = 1;
      }
      else
      {
        if (strpos(helpname,"(") == -1) sprintf(helpname,"%s(1)",helpname);
        sprintf(svar,"%s",helpname);
	strtrim(helpname);
        sprintf(helpname,"%s",strmid(svar,0,namelength));
        for (m=(int)strlen(helpname);m<namelength;m++) helpname[m]= (char) 32;
        helpname[namelength]= (char) 0;
        sprintf(all_var_names[nvars],"%s",helpname);
        nvars++;
      }

     }

/*Vorlaeufigen Header schreiben  */
  oh.nvars= nvars;
  oh.startim = 0.0;
  oh.endtim = 0.0;
  oh.maxdelt = 0.0;
  oh.outdelt = 0.0;
  oh.year = (float) 360.0;
  oh.cycle = (float) 360.0;
  sprintf(helpname,"from_csv");
  for (m=(int)strlen(helpname);m<namelength;m++) helpname[m]= (char) 32;
  strncpy(oh.sdir,helpname,namelength);

/*  Header schreiben*/
  writeheader(out_file,&oh,all_var_names,namelength);

/* Vektor zur Aufnahme der Daten fuer einen Zeitschritt anlegen */
  dat = malloc(nvars*sizeof(float));
/* Steuervariablen setzen*/
  if (timeflag == 1)
  {
    startim = -1.0;
    outdelt = -1.0;
  }
  else
  {
    startim = 0.0;
    outdelt = 1.0;
  }

/* Daten einlesen */
  timnum = 0;
  while ( fgets(input,_BUFSIZE_,in_file) != 0)
  {
    sprintf(helpstr,"%s ,",input); /*Eine Variable gibt es mindestens*/
    strtrim(helpstr);
    cp = strpos(helpstr,",");
    count = 0;
    while ( cp > 0)
    {
       len= strlen(helpstr);
       sprintf(helpname,"%s",strmid(helpstr,0,cp));
       strtrim(helpname);
       sprintf(helpstr,"%s",strmid(helpstr,cp+1,len-cp));
       cp = strpos(helpstr,",");

       argu = my_sscan(helpname);

       if (timeflag == 1)
       {
          if (startim == -1) startim = argu;
	  if (outdelt == -1 && timnum != 0) outdelt = argu - startim;
       }

       if (count >= timeflag)
       {
          dat[count - timeflag] = argu;
       }
       count ++;
    }
     if (count > 0) 
     {
        fwrite(&dat[0],sizeof(float),nvars,out_file);
/*
        for (i=0;i<nvars;i++) printf("%f ",dat[i]);
        printf("\n");
*/
        timnum++;
      }
   }

  fflush(out_file);
  fclose(in_file);

/*  Header korrigieren*/
  if (startim < outdelt) timnum--;
  oh.nvars= nvars;
  oh.startim = startim;
  oh.endtim = outdelt * timnum + startim;
  oh.maxdelt = outdelt;
  oh.outdelt = outdelt;
  oh.year = (float) 0.0;
  oh.cycle = (float) ((outdelt*timnum));

  /* Output File nochmal oeffnen  */
  rewind(out_file);
/* Korrigierten Header schreiben*/
  writeheader(out_file,&oh,all_var_names,namelength);

  fclose(out_file);

  printf("Ready :) \n");
  fflush(stdout);

  return(0);
}
