/* MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */

#include "stdinc.h"
#include "matrix.h"

#define rem1 "/*"
#define rem2 "*/"

int main(int argc, char *argv[])
{
 int get_data(char*,char*,char* ,real *);
 void data_analyse(int ,float*, int , real*,real*,real*);
 void writeheader(FILE *, header*, long_name80*, int);

 char *symbname, *input, *helpstr;
 string input_file,output_file,para;
 int timnum=0;
 int i,j,k,l,m,n,cp,len;
 int num_of_years,harmonics,base_vecs;
 unsigned int nvars=0;
 int *num_data,count;

 float t_cycle;

  int check1,check2,check3,check4,namelength;
  int item,dyear,month,day,hour,minute;
  long_name svar,last_var,helpname;
  long_name80 *all_var_names;
  float *dat,varianz;
  real argu;
  real *var_dat,*var_ymd,*var_tid,*var_tim,*time_vec;
  real **all_data,**target_data;
  real *var_coeff, *base_data;

  FILE *in_file, *out_file;

  header oh;

  namelength=sizeof(long_name80);
  oh.sdir = malloc(sizeof(char)*namelength);

  input=   (char *) malloc( _BUFSIZE_*sizeof(char));
  helpstr=(char *) malloc( _BUFSIZE_*sizeof(char));

/* Vorl�fig 'mal was fr die Variablen-Namen reservieren */
  all_var_names = malloc(one_var*namelength);
  num_data = malloc(one_var*sizeof(int));
  last_var[0] = (char) 0;

/* Check the symb file and get the ranges */

  symbname=argv[1];

  sprintf(input_file,"%s.symb",symbname);
  sprintf(output_file,"%s_dpk.outc",symbname);

  in_file=fopen(input_file,"r");

  if (in_file == NULL)
  {
     std_error("Error when opening data file for reading");
  }
/*
  Es k�nen Vorgabewerte fr folgende Daten im Header des *_pk.outb-Files angegeben werden:
  cycle     : Zyklusvorgabe fr die Synthese
  outdelt   : Vorgabe fr das outdelt der Synthese
  varianz   : "Varianz" der Synthese (kleines varianz -> gro� Varianz/Dynamik)
  harmonics : Zahl der zu berechnenden Oberwellen

  Wird nichts bergeben, gilt:
  cycle     = 360.0
  outdelt   = 1.0
  varianz   wird in data_analyse berechnet
  harmonics wird berechnet (so viele wie m�lich)
*/
  oh.cycle     = 360.0;
  oh.outdelt   = 1.0;
  varianz   = -1.0;
  harmonics = -1;

  if (argc > 1)
  {
/*   Vorgabe fr cycle einlesen    */
     sprintf(para,"%s",argv[2]);
     sscanf(para,"%f",&oh.cycle);

/*   Vorgabe fr outdelt einlesen    */
     sprintf(para,"%s",argv[3]);
     sscanf(para,"%f",&oh.outdelt);

/*   Vorgabe fr "Varianz" einlesen    */
     sprintf(para,"%s",argv[4]);
     sscanf(para,"%f",&varianz);

/*   Vorgabe fr Zahl der Oberwellen einlesen    */
     sprintf(para,"%s",argv[5]);
     sscanf(para,"%d",&harmonics);
   }

  while ( fgets(input,_BUFSIZE_,in_file) != 0 )
  {
     cp = -1;
     sprintf(helpstr,"%s",input);
     len= strlen(helpstr);
     if (len > 3) {
	     cp = strpos(strmid(helpstr,len-2,1),",");
	     count = numchar(helpstr,",");
	     while ( cp >= 0)
	     {
	        fgets(helpstr,_BUFSIZE_,in_file);
	        len= strlen(helpstr);
	        cp = strpos(strmid(helpstr,len-2,1),",");
		count += numchar(helpstr,",");
	     }
	     cp = strpos(input,")");
	     if ( cp > 0)
	     {
	        sprintf(svar,"%s",strmid(input,0,cp+1));
	        if (strpos(last_var,svar) < 0)
		{
	           sprintf(helpname,"%s",strmid(svar,0,namelength));
	           for (m=(int)strlen(helpname);m<namelength;m++) helpname[m]= (char) 32;
	           sprintf(all_var_names[nvars],"%s",strmid(helpname,0,namelength));
	           sprintf(last_var,"%s",svar);
		   num_data[nvars] = count+1;  /*Anzahl der Werte ist Anzahl der Kommas + 1 */
	           timnum = IMAX(timnum,count+1);
		   nvars++;
		}
	     }
}  }
  fclose(in_file);



/*  for (i=0;i<nvars;i++) printf("%d: %s[%d] \n",i+1, all_var_names[i],num_data[i]);
  fflush(stdout);
*/
/* Speicherplatz fr eine Variable (wird auf Maximall�ge angelegt) */
/* Daten*/
   var_dat =vector(1,timnum);
/* YearMonthDay*/
   var_ymd=vector(1,timnum);
/* Uhrzeit  */
   var_tid=vector(1,timnum);
/* Zeit in Zahlen */
   var_tim=vector(1,timnum);

/* Zeitvektor fr Transformation */
   time_vec=vector(1,timnum);


  base_vecs = IMAX(2,(int) (2*timnum/2)-1);
  if (harmonics == -1) harmonics = base_vecs/2;

/* Feld fr Spektren anlegen */
  target_data = matrix(1,nvars,0,base_vecs);
  var_coeff     = vector(0,base_vecs);

/* Messdaten einlesen */
/* Hauptschleife ber alle Variablen */
printf("Reading input data\n");
fflush(stdout);
  for (k=1;k<=nvars;k++)
  {
    sprintf(svar,"%s",strmid(all_var_names,(k-1)*namelength,namelength));
    strtrim(svar);
/* Eine Variable einlesen und aufpassen, dass ab Index 1 geschrieben wird*/
     check1=get_data(input_file,svar,"val",&var_dat[1]);
     check2=get_data(input_file,svar,"ymd",&var_ymd[1]);
     check3=get_data(input_file,svar,"tid",&var_tid[1]);
     check4=get_data(input_file,svar,"tim",&var_tim[1]);
printf("Checks done\n");
fflush(stdout);
    
/*
�erprfen ob die Datenmengen stimmen, check3 wird ausgewertet, wenn Uhrzeiten verwertet werden
*/
     if ((check2!=0 && (check1 != check2 || check1 != num_data[k-1] || check2 != num_data[k-1] )) || (check2 == 0 && check1 != check4) )
                       std_error("Number of data and time samples are different");
printf("Data are ok\n");
fflush(stdout);
/*Eigentlicher Indexz�ler j (hier wird verhindert, dass die ausgezeichneten Daten var_dat[i]=-99 bercksichtigt werden, welche mit m gez�lt werden) */
      j = 1;
      m = 0;
      for (i=1;i<=num_data[k-1];i++)
      {
         if (var_dat[i]!=-99)
         {
	   if (check4!=num_data[k-1])
	   {
/*      Jahr, Monat und Tag aus den Datensatz holen*/
             item		= (int) var_ymd[i];
             dyear		= (int) item/10000;
	     item		-=10000*dyear;
	     month		= (int) item/100;
	     item		-= 100*month;
	     day		= item;
/*Wenn in var_tid keine Werte angekommen sind, wird auf 12:00 gesetzt	 */
	     hour		= 12;
	     minute		= 0;
	     if ( check3 == check1 )
	     {
	        item 		= (int) var_tid[i];
	        hour		= (int) item/100;
	        item		-= 100*hour;
	        minute	= item;
	     }
	     time_vec[j] = 2.0 * M_PI *(30.0 * (month-1) + day + hour/24.0 + minute/1440.0)/360.0;
          }
	  else
	  {
	    time_vec[j] = 2.0 * M_PI * var_tim[i] / oh.cycle;
	  }
	 var_dat[j] = var_dat[i];
	 j++;
	 }
	 else
	 {
	 m++;
	 }
       }
/*Koeffizienten l�chen*/
printf("Preparing variables\n");
fflush(stdout);
       for (i=0;i<base_vecs;i++) var_coeff[i]=0.0;
/*Daten analysieren*/
   sprintf(helpname,"%s",strmid(all_var_names,(i-1)*namelength,namelength));
   strtrim(helpname);
   printf("transforming %s [total=%d, invalid=%d, valid=%d] stage:",helpname,num_data[k-1],m,j-1);
   fflush(stdout);

/*Die wirkliche Anzahl Datens�ze ist j
  varianz wird hier bergeben und in data_analyse berechnet */
   data_analyse(harmonics,&varianz,j-1,time_vec,var_dat,var_coeff);

   printf("\n");
   printf("Value for epsi is %f\n",varianz);
   fflush(stdout);


/*Daten sichern*/
   for (i=0;i<base_vecs;i++) target_data[k][i] = var_coeff[i];
  }

  dat = malloc(nvars*sizeof(float));
/* Header fuer output file setzen */

  oh.nvars= nvars;
  oh.startim = (float) 0.0;
  oh.endtim = (float) oh.cycle;
  oh.maxdelt = (float) base_vecs;
  oh.year = (float) 1.0;
  strncpy(oh.sdir,"fourier     ",12);
  for (m=12;m<namelength;m++) oh.sdir[m]= (char) 32;
  oh.sdir[namelength-1]= (char) 0;

  out_file=fopen(output_file,"wb");

 /* Header schreiben */
  writeheader(out_file,&oh,all_var_names,namelength);

  for (j=0;j<=base_vecs;j++)
     {
     for (i=1;i<=nvars;i++) dat[i-1] = (float) target_data[i][j];
     fwrite(&dat[0],sizeof(float),nvars,out_file);
     }

  fclose(out_file);

}
