/* MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */

#include "stdinc.h"

#define rem1 "/*"
#define rem2 "*/"

int main(int argc, char *argv[]);

int main(int argc, char *argv[])
{
void writeheader(FILE *, header*, long_name80*, int);

 char *csvname, *outbname, *input, *helpstr;
 string input_file,output_file,helpname;
 int timnum=0, timeflag=0;
 int cp,len,m,namelength;

 unsigned int nvars=0;
 int count;
 
 long_name80 *all_var_names;
 long_name svar;
 float *dat;
 float argu;

  FILE *in_file, *out_file;

  header oh;

  helpstr= (char *) malloc( (_BUFSIZE_ +128)*sizeof(char));
  input=   (char *) malloc( _BUFSIZE_*sizeof(char));
  namelength=sizeof(long_name80);
  oh.sdir = malloc(sizeof(char)*namelength);

/* Check the csv file and get the ranges */
  csvname=argv[1];
  outbname=argv[2];

  sprintf(input_file,"%s",csvname);
  sprintf(output_file,"%s.outc",outbname);

  in_file=fopen(input_file,"rb");

  if (in_file == NULL)
  {
     std_error("OUTA2RESULT: Error when opening data file for reading");
  }

  /* Output File oeffnen  */
  out_file=fopen(output_file,"wb");
  if (out_file == NULL)
  {
     std_error("OUTA2RESULT: Error when opening result file for writing");
  }
/* Header analysieren    */
/*  Die ersten neun Zeilen auswerten */
// nvars
   fgets(input,_BUFSIZE_,in_file);
   strtrim(input);
   cp = strpos(input,":");
   len=strlen(input);   
   sprintf(helpstr,"%s",strmid(input,cp+1,len-cp));
   oh.nvars = (unsigned int) my_sscan(helpstr);
   nvars=oh.nvars;
// StartTime
   fgets(input,_BUFSIZE_,in_file);
   strtrim(input);
   cp = strpos(input,":");
   len=strlen(input);   
   sprintf(helpstr,"%s",strmid(input,cp+1,len-cp));
   oh.startim = my_sscan(helpstr);
// EndTime
   fgets(input,_BUFSIZE_,in_file);
   strtrim(input);
   cp = strpos(input,":");
   len=strlen(input);   
   sprintf(helpstr,"%s",strmid(input,cp+1,len-cp));
   oh.endtim =  my_sscan(helpstr);
// Outdelt
   fgets(input,_BUFSIZE_,in_file);
   strtrim(input);
   cp = strpos(input,":");
   len=strlen(input);   
   sprintf(helpstr,"%s",strmid(input,cp+1,len-cp));
   oh.outdelt =  my_sscan(helpstr);
   oh.maxdelt =  oh.outdelt;
// Year
   fgets(input,_BUFSIZE_,in_file);
   strtrim(input);
   cp = strpos(input,":");
   len=strlen(input);   
   sprintf(helpstr,"%s",strmid(input,cp+1,len-cp));
   oh.year =  my_sscan(helpstr);
// Cycle
   fgets(input,_BUFSIZE_,in_file);
   strtrim(input);
   cp = strpos(input,":");
   len=strlen(input);   
   sprintf(helpstr,"%s",strmid(input,cp+1,len-cp));
   oh.cycle =  my_sscan(helpstr);
// ModelDir
   sprintf(helpname,"main");
   for (m=(int)strlen(helpname);m<namelength;m++) helpname[m]= (char) 32;
   strncpy(oh.sdir,helpname,namelength);

/* Speicherplatz fuer die Variablen-Namen reservieren */
   all_var_names = malloc(oh.nvars*sizeof(long_name80));
   nvars = 0; /*aber es soll noch mal genau gezaehlt werden*/
   fgets(helpstr,_BUFSIZE_,in_file);
//Ein Komma anhängen, damit der letze Eintrag auch mitgenommen wird
    sprintf(helpstr,"%s,",helpstr);
    strtrim(helpstr);
    cp = strpos(helpstr,",");
    while ( cp >= 0)
    {
      len= strlen(helpstr);
      sprintf(helpname,"%s",strmid(helpstr,0,cp));

      strtrim(helpname);
      sprintf(helpstr,"%s",strmid(helpstr,cp+1,len-cp));
      cp = strpos(helpstr,",");

      if ( strpos(helpname,"(") == -1 &&
          (strpos(helpname,"time") == 0 ||
	   (strpos(helpname,"t") == 0 && strlen(helpname)==1)))
      {
        timeflag = 1;
      }
      else
      {
        if (strpos(helpname,"(") == -1) sprintf(helpname,"%s(1)",helpname);
        sprintf(svar,"%s",helpname);
		strtrim(helpname);
        sprintf(helpname,"%s",strmid(svar,0,namelength));
        for (m=(int)strlen(helpname);m<namelength;m++) helpname[m]= (char) 32;
        helpname[namelength]= (char) 0;
        sprintf(all_var_names[nvars],"%s",helpname);
        nvars++;
      }
}
  if (nvars!=oh.nvars)  {
     std_error("OUTA2RESULT: Error in data file. Inconsistent data");
  }
/*  Header schreiben*/
  writeheader(out_file,&oh,all_var_names,namelength);

/* Vektor zur Aufnahme der Daten fuer einen Zeitschritt anlegen */
  dat = malloc(nvars*sizeof(float));
/* Daten einlesen */
  timnum = 0;
  while ( fgets(input,_BUFSIZE_,in_file) != 0)
  {
    sprintf(helpstr,"%s ,",input); /*Eine Variable gibt es mindestens*/
    strtrim(helpstr);
    cp = strpos(helpstr,",");
    count = 0;
    while ( cp > 0)
    {
       len= strlen(helpstr);
       sprintf(helpname,"%s",strmid(helpstr,0,cp));
       strtrim(helpname);
       sprintf(helpstr,"%s",strmid(helpstr,cp+1,len-cp));
       cp = strpos(helpstr,",");

       argu = my_sscan(helpname);

       if (count >= timeflag)
       {
          dat[count - timeflag] = argu;
       }
       count ++;
    }
     if (count > 0) 
     {
        fwrite(&dat[0],sizeof(float),nvars,out_file);
        timnum++;
      }
   }

  fflush(out_file);
  fclose(in_file);
  fclose(out_file);

  printf("Ready :) \n");
  fflush(stdout);

  return(0);
}
