/* MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */

#include "stdinc.h"

int main(int argc, char *argv[]);

int main(int argc, char *argv[])
{
void *readheader(FILE*,header*,int);
header oh;
char *resultname;
char *var;
long int timnum;
int i;
int pos,namelength;
int casesen;
int harm;
int eval_harm;
int numharm;
unsigned int t;

void *all;
float *dat, *coeff;
FILE *unit;
string help;
float sum,timewin,t_synth;


  resultname=argv[1];
  var=argv[2];
  sscanf(argv[3],"%d",&casesen);
  sscanf(argv[4],"%d",&harm);

 unit=fopen(resultname,"rb");
 if (unit != NULL)
 {
   if (strpos(resultname,".outb") > 0) {
      namelength = sizeof(name12);
   } else {
      namelength = sizeof(long_name80);
   }
   all = readheader(unit,&oh,namelength);
  numharm = oh.maxdelt;
  timewin = (oh.endtim - oh.startim)/oh.outdelt;
  timnum  = (long int) (0.5 + timewin);

/*   fuer Kompatibilitaet mit alten pk-Files */
  if (oh.year < 1.0) oh.year = 1.0;
  
  dat = malloc(sizeof(float)*oh.nvars);
  coeff = malloc(sizeof(float)*(numharm+1));

  for (i=0;i<oh.nvars;i++)
  {
     strncpy(help,strmid(all,i*namelength,namelength),namelength);
     help[namelength]=(char) 0;

     if (casesen == 0) sprintf(help,"%s",strtolower(help));

     if (strpos(help,var) == 0)
     {
       pos=i;
       break;
     }
     else pos=-1;
  }

  if (pos>=0) {
     for (i=0;i<=numharm;i++)
     {
       fread(dat,sizeof(float),oh.nvars,unit);
       coeff[i]=dat[pos];
     }
     eval_harm = numharm/2;
     if (harm!=0) eval_harm = IMIN(harm,eval_harm);

     for (t=0;t<=timnum;t++)
     {
       sum=coeff[0];
       for (i=1;i<=eval_harm;i++)
       {
          t_synth= 2.0*M_PI*((t*(i-oh.year+1)))*oh.outdelt/(oh.cycle*oh.year);
          sum += coeff[2*i-1]*cos(t_synth)+coeff[2*i]*sin(t_synth);
       }
       printf("%.24g ",sum);
     }
     printf("\n");
  }
  else printf("not_stored\n");

  fclose(unit);
 }
else
  printf("Error in readdata \n");

 free(all);
 free(dat);
 return(0);
}


