/* MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */

//last change 160818 Bugfix startim CK
#include "stdinc.h"

int main(int argc, char *argv[])
{

 void *readheader(FILE*,header*,int);

 string in_name1,resultname,out_name,shortname,para;

 long int timnum,timnum1,timnum2;

 int i,j,k,l,n,m,found,exact,cp,namelength;

 int years1,years2;

 unsigned int nvars;

 void *names1;
 long_name *out_names,one_name,var1,var2,helpname;
 
 float *dat;
 unsigned int *index1, count;

  real inp1,inp2,outp,sum,diff;
  real **all_data1,**all_data2,**target_data;

  FILE *in_file1, *out_file;

/* Zahl der Parameter, bevor die Variablennamen kommen*/
  int num_para = 3;

  header oh1;

  sprintf(resultname,"%s",argv[1]);
  sprintf(out_name,"%s.outa",argv[2]);

  if (strpos(resultname,".outb") > 0) {
    namelength = sizeof(name12);
  } else {
    namelength = sizeof(long_name80);
  }
  sprintf(in_name1,"%s",resultname);

  /*    Ausgabenamen zusammenbauen und dabei die Extension ".outb" oder ".outc" abschneiden */
  i=strpos(resultname,".out");

  sprintf(para,"%s",argv[2]);
  if (strpos(para,"exact") == 0) exact = 1; else exact = 0;

  nvars = argc - num_para;

  in_file1=fopen(in_name1,"rb");

  if (in_file1 == NULL)
  {
     std_error("RESULT2OUTA: Error when opening result file 1 for reading");
  }

/* Header der Quelldatei einlesen */
  names1 = readheader(in_file1,&oh1,namelength);

  if ( exact == 0 ) nvars = 1;

  timnum1 = 1 + (long int) (0.5 + (oh1.endtim-oh1.startim)/oh1.outdelt);
  years1 = (int) (oh1.endtim-oh1.startim)/oh1.cycle;

/* Speicherplatz fuer gesamten binaeren Datenanteil reservieren ('mal sehen wie lange es geht...) */
  all_data1   = matrix(1,oh1.nvars,1,timnum1);
/* Speicherplatz fuer einen Satz von Resultfile 1*/
  dat = fvector(1,oh1.nvars);

/* Variablennamen einlesen */
    out_names = malloc((oh1.nvars+1)*sizeof(long_name));
    index1 = malloc((oh1.nvars+1)*sizeof(unsigned int));
/* Variablennamen fuer die Ausgabe vorbereiten */
  count = 1;
  sprintf(helpname,"%s","time");
  for (m=(int)strlen(helpname);m<namelength;m++) helpname[m]= (char) 32;
  sprintf(out_names[0],"%s",strmid(helpname,0,namelength));
 
 /*Variable-Liste zusammenbauen und die entsprechenden Spalten-Indizes dieser Daten merken */
  for (i=0;i<oh1.nvars;i++)
  {
     sprintf(var1,"%s",strmid(names1,i*namelength,namelength));
     for (j=0;j<nvars;j++)
     {
	found = 0;
	if ( exact == 1 ) sprintf(var2,"%s",argv[num_para+j]);
	if ( exact == 1 && strpos(var1,var2) == 0) found = 1;

	if ( exact == 0 ) found = 1;

	if (found == 1)
	{
           sprintf(helpname,"%s",strmid(var1,0,namelength));
           for (m=(int)strlen(helpname)-1;m<namelength;m++) helpname[m]= (char) 32;
           sprintf(out_names[count],"%s",strmid(helpname,0,namelength));
           index1[count] = i+1;
	   count++;
	}
     }
  }

  nvars = count-1;
/*Header fuer Ausgabe festlegen  */

/* Simulationsdaten einlesen */

/* Resultfile*/

  printf("Reading data of %s..\n",in_name1);
  fflush(stdout);
/* Hauptschleife ueber alle Variablen */
  for (k=1;k<=timnum1;k++)
     {
/* Einen "Tag" einlesen */
      fread(&dat[1],sizeof(float),oh1.nvars,in_file1);

      for (i=1;i<=oh1.nvars;i++)
        {
        all_data1[i][k] = (real) dat[i];
        }
     }
  fclose(in_file1);

/* Output file schreiben */
  printf("Writing to %s\n",out_name);
  fflush(stdout);

  out_file=fopen(out_name,"w");

/* outa-Header schreiben */
	  fprintf(out_file,"Stored Variables:%u\n", oh1.nvars);
	  fprintf(out_file,"Start Time:%f\n",oh1.startim);
	  fprintf(out_file,"End Time:%f\n",oh1.endtim);
//	  fprintf(out_file,"Maxdelt:%f\n",oh1.maxdelt);
	  fprintf(out_file,"Outdelt:%f\n",oh1.outdelt);
	  fprintf(out_file,"Year:%f\n",oh1.year);
	  fprintf(out_file,"Cycle:%f\n",oh1.cycle);
//	  fprintf(out_file,"ModelDir:%s\n",oh1.sdir);
  for (i=0;i<nvars;i++)
  {
     sprintf(helpname,"%s",strmid(out_names[i],0,namelength));
     strtrim(helpname);
     fprintf(out_file,"%s ,",helpname);
  }
  sprintf(helpname,"%s",strmid(out_names[nvars],0,namelength));
  strtrim(helpname);
  fprintf(out_file,"%s \n",helpname);

/* Daten schreiben*/
  for (j=1;j<=timnum1;j++)
     {
/*   Zeitinformation*/
     fprintf(out_file,"%f, ", (j-1) * oh1.outdelt+oh1.startim);
/*     Zeile mit den Daten fortsetzen*/

     for (i=1;i<nvars;i++) fprintf(out_file,"%.24g , ",all_data1[index1[i]][j]);
     fprintf(out_file,"%f \n",all_data1[index1[nvars]][j]);

/*
     for (i=1;i<nvars;i++) fprintf(out_file,"%f , ",all_data1[i][j]);
     fprintf(out_file,"%f \n",all_data1[nvars][j]);
*/


     }

  fclose(out_file);

  printf("Ready :) \n");
  fflush(stdout);
}




