/* MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */

#include "stdinc.h"

int main(int argc, char *argv[])
{
 void *readheader(FILE*,header*,int);
 void writeheader(FILE *, header*, long_name80*, int);

 string message,out_name,shortname,para,var1,var2,helpname;
 long int timnum,timnum1,timnum2;

 int i,j,k,l,n,m,med_index1,med_index2,num_files,cp;
 int namelength,namelength1, namelength2;
 int years1,years2;

 unsigned int nvars;

 char *names1,*names2;
 long_name80 *out_names, *symb_names;
 long_name one_name;
 float *dat,*target_data;
 unsigned int *index1, *index2, count;

  double mean,stddev,med;
  real **all_data,  *median;
  real **mean_data,**std_data;
  FILE **in_files, *out_file, *symb_file;

  header outheader,*inheaders;

  num_files=argc-1;
  
/* Hier werden schon mal für die Ermittlung des Median benötigten Indizes festgelegt */
/* Die Nummerierung der Files geht bei Null los */
  if (num_files%2 == 0)
  {
/* bei gerader Anzahl ist der Median durch den Mittelwert der beiden um die Mitte plazierten Daten gegeben */
     med_index1= num_files/2;
     med_index2= med_index1-1;
  } else {
/* bei ungerader Anzahl ist es das mitteler Element */
     med_index1= (int) ceil(num_files/2.0) -1;
     med_index2= med_index1;
  }

  in_files      =malloc(num_files * sizeof(FILE*));
  inheaders=malloc(num_files * sizeof(header));

  for (i=0;i<num_files;i++)
  {
     in_files[i]=fopen(argv[i+1],"rb");
     if (in_files[i] == NULL)
     {
        sprintf(message,"STATISTIC_RESULTS: Error when opening result file:%s for reading",argv[i+1]);
        std_error(message);
     } 
     namelength=sizeof(long_name80);
     if (strpos(argv[i+1],".outb") > 0) {
        namelength1 = sizeof(name12);
     } else {
        namelength1 = sizeof(long_name80);
     }

     if (i==0) {
         names1 = readheader(in_files[i],&inheaders[0],namelength1);
         timnum1 = (long int) (0.5+(inheaders[0].endtim-inheaders[0].startim)/inheaders[0].outdelt) + 1;
         years1 = (int) (inheaders[0].endtim-inheaders[0].startim)/inheaders[0].cycle;
     } else {
         names2 = readheader(in_files[i],&inheaders[i],namelength1);

/* Fehlerbehandlung Anzahl der Variablen */
         if (inheaders[0].nvars != inheaders[i].nvars)
         {
          sprintf(message,"STATISTIC_RESULTS: mismatch of number of variables cause by file:%s",argv[i+1]);
          std_error(message);
         } 
/* Fehlerbehandlung outdelt */
         if (inheaders[0].outdelt != inheaders[i].outdelt)
         {
          sprintf(message,"STATISTIC_RESULTS: outdelt of resultfile %s is mismatching",argv[i+1]);
          std_error(message);
         }

/* Fehlerbehandlung timnum */
         timnum2 = (long int) (0.5+(inheaders[i].endtim-inheaders[i].startim)/inheaders[i].outdelt) + 1;
         if (timnum1 != timnum2)
         {
          sprintf(message,"STATISTIC_RESULTS: length of file:%s is mismatching",argv[i+1]);
          std_error(message);
         }
      }
  }
  timnum = timnum1;

/* Ausgabe im Format "*.symb" für Mittelwerte und Standardabweichungen vorbereiten */
/* zunächst werden die berechneten Daten zwischengespreichert */
/* Variablennamen   */
  symb_names = malloc(inheaders[0].nvars*namelength);
/* Datenstrukturen */
  mean_data = matrix(1,inheaders[0].nvars,1,timnum);
  std_data = matrix(1,inheaders[0].nvars,1,timnum);
  
/* Variablennamen fuer die Ausgabe vorbereiten */

/* für Mittelwert, Median und Standardabweichung werden je Variable je eine neue erzeugt*/
  outheader.nvars = 3 * inheaders[0].nvars;
  out_names = malloc(outheader.nvars*namelength);

/*Variable-Liste zusammenbauen und die entsprechenden Spalten-Indizes dieser Daten merken */
count=0;
  for (i=0;i<inheaders[0].nvars;i++)
  {
/*  für das .symb-File */
      sprintf(helpname,"%s",strmid(names1,i*namelength1,namelength1));
      strtrim(helpname);
      sprintf(symb_names[i],"%s",helpname);

/*  für die Mittelwerte  */
      sprintf(helpname,"mean_%s",strmid(names1,i*namelength1,namelength1));
      strtrim(helpname);
      for (m=(int)strlen(helpname);m<namelength;m++) helpname[m]= (char) 32;
      sprintf(out_names[count],"%s",strmid(helpname,0,namelength));
      count++;

/*  für die Mediane  */
      sprintf(helpname,"median_%s",strmid(names1,i*namelength1,namelength1));
      strtrim(helpname);
      for (m=(int)strlen(helpname);m<namelength;m++) helpname[m]= (char) 32;
      sprintf(out_names[count],"%s",strmid(helpname,0,namelength));
      count++;

/*  für die Standardabweichung  */
      sprintf(helpname,"stddev_%s",strmid(names1,i*namelength1,namelength1));
      strtrim(helpname);
      for (m=(int)strlen(helpname);m<namelength;m++) helpname[m]= (char) 32;
      sprintf(out_names[count],"%s",strmid(helpname,0,namelength));
      count++;
   }
  
/*Header fuer Ausgabe festlegen  */
  outheader.nvars=   count;
  outheader.startim= inheaders[0].startim;
  outheader.endtim=  inheaders[0].endtim;
  outheader.maxdelt= inheaders[0].maxdelt;
  outheader.outdelt= inheaders[0].outdelt;
  outheader.year=    inheaders[0].year;
  outheader.cycle=   inheaders[0].cycle;
  outheader.sdir=malloc(namelength*sizeof(char));
  sprintf(outheader.sdir,"MoViE-Statistics");
  for (m=(int)strlen(outheader.sdir);m<namelength;m++) outheader.sdir[m]= (char) 32;
  outheader.sdir[namelength-1]= (char) 0;

 sprintf(out_name,"statistics.outc");
 out_file=fopen(out_name,"wb");

/* Header schreiben */
  writeheader(out_file,&outheader,out_names,namelength);

/* ============================================================================================= */

/* Speicherplatz fuer für eine Zeitschritt aller Input-Files und einen Zeitschrit des Output-Files anlegen */
  all_data        = matrix(1,inheaders[0].nvars,1,num_files);
  target_data = fvector(1,outheader.nvars);

/* Speicherplatz für eine Variable über alle Files */
  median=vector(1,num_files);

/* Simulationsdaten einlesen */
  printf("Reading data.\n");
  fflush(stdout);
/* Speicherplatz fuer einen Zeitschritt*/
  dat = fvector(1,inheaders[0].nvars);

  fflush(stdout);
/* Hauptschleife ueber alle Variablen */
  for (k=1;k<=timnum;k++)
  {
/* Einen Zeitschritt einlesen */
    for (j=0;j<num_files;j++)
    {
      fread(&dat[1],sizeof(float),inheaders[0].nvars,in_files[j]);

      for (i=1;i<=inheaders[0].nvars;i++)
        {
        all_data[i][j+1] = (real) dat[i];
        }
     }

/* Berechnung ausfuehren  */
/* Schleife über die Variablen */
count=1;
  for (i=1;i<=inheaders[0].nvars;i++)
  {
/*   Mittelwert */
     mean=0.0;
     for (j=1;j<=num_files;j++)
     {
        mean += all_data[i][j];
     }
     mean /= num_files;
/*  Standardabweichung  */
     stddev=0.0;
     for (j=1;j<=num_files;j++)
     {
        stddev += (all_data[i][j] - mean) * (all_data[i][j] - mean) ;
     }
     stddev /= (num_files - 1);
     stddev =  sqrt((double) stddev);

/*   Median */
      for (j=1;j<=num_files;j++)
      {
         median[j] = all_data[i][j];
       }
       sort(median,num_files);
       med=(median[med_index1]+median[med_index2])/2.0;

/* Daten für *.outc */
        target_data[count] =  mean;
        count++;
        target_data[count] =  med;  
        count++;
        target_data[count] =  stddev;
        count++;

/* Daten für *.symb  */
        mean_data[i][k] = mean;
        std_data[i][k] = stddev;
    }
     
     fwrite(&target_data[1],sizeof(float),outheader.nvars,out_file);
     }
/* *.outc und alle Inputs schliessen */
  fclose(out_file);
  for (i=0;i<num_files;i++) fclose(in_files[i]);

/* jetzt .symb-Files öffnen und schreiben */
 sprintf(out_name,"statistics.symb");
 out_file=fopen(out_name,"w");
 
  for (i=1;i<=inheaders[0].nvars;i++)
  {
/*      Zeitinformation */
     fprintf(out_file,"%s/tim/: ",symb_names[i-1]);
     for (k=1;k<timnum;k++)
     {
       fprintf(out_file,"%f, ",(k-1)*inheaders[0].outdelt); 
     }
     fprintf(out_file,"%f\n",timnum*inheaders[0].outdelt); 

/*      Mittelwert */
     fprintf(out_file,"%s/val/: ",symb_names[i-1]);
     for (k=1;k<timnum;k++)
     {
       fprintf(out_file,"%f, ",mean_data[i][k]); 
     }
     fprintf(out_file,"%f\n",mean_data[i][timnum]); 
/*      Standardabweichung */
     fprintf(out_file,"%s/std/: ",symb_names[i-1]);
     for (k=1;k<timnum;k++)
     {
       fprintf(out_file,"%f, ",std_data[i][k]); 
     }
     fprintf(out_file,"%f\n",std_data[i][timnum]); 

  }
  fclose(out_file);

  printf("Ready\n");
  fflush(stdout);
}

