/* MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */

#include <math.h>
#include <stdio.h>
#include "stdinc.h"

void interpolate(real *result,real starttime,real outdelt,int num_steps, real *itime,real *values,int num_data)
{
real linear(real,real,real,real,real);
int i,j,k=1,k1,k2;
real time,start_val,val_time;

/* Hauptschleife fuer die Anzahl der zu erzeugenden Abtastwerte */
for (i=0;i<=num_steps;i++)
{
        time = starttime + outdelt * (real) i;
/*         Sonderfall: a) noch keine Werte (am Anfang der Datenreihe) */
/*         Sonderfall: b) keine Werte mehr (am Ende der Datenreihe) */
        if (time < itime[1] || time > itime[num_data])
        {
            result[i]=-9999.0;
        } else {
           k1=k;
           k2=num_data;
           for (k=1;k<=num_data;k++)
           {
              j = k+1;
              if (time>=itime[k] && time<=itime[j])
              {
               k1=k;
               k2=j;
               break;
              }
            }
            if (k1 != k2)
            {
                 result[i] = linear(values[k1],itime[k1],values[k2],itime[k2],time);
            }
            else
            {
                result[i]=-9999.0;
            }
        }   
}

}

real linear(real start_val,real start_t,real end_val, real end_t,real inter_t)
{
   real x;
   x=start_val+(end_val-start_val)*(inter_t-start_t)/(end_t-start_t);
   return(x);
}

