# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc dist_control {} {

global toolflag
global calc_l2dist distshow ttt
global multiset
global eraseallsets eraseallgraphs
global varbut boxbut
global distnum

set distlabels { "d0=||f-g||" \
                "d1=||f-g||/||f+g||" \
		"d2=||f-g||/min(||g||,||f||)" \
		"d3=||f-g||/(||g||+||f||-||f-g||)" \
		"d4=1-<g,f>/(||g||*||f||)" \
		"d5=(||g||*||f|-<g,f>)/(||g||*||f||+<g,f>)" \
		"d6=arccos(<g,f>/(||g||*||f||)" \
		"d7=|ln(||g||/||f||)|" \
		"d8=max(||g||/||f||,||f||/||g||)-1" \
		"d9=d6+d7" }

set distnum [llength $distlabels]

if {$calc_l2dist==0} {
   destroy .dist
   destroy .dv
} else {

  set multiset 0
  set eraseallsets 1

  if [winfo exist .ovc.left.set.newset] {.ovc.left.set.newset configure -state disabled}
  if [winfo exist .ovc.left.set.eraseset] {.ovc.left.set.eraseset configure -state disabled}
  if [winfo exist .ovc.left.set.eraseallsets] {.ovc.left.set.eraseallsets configure -state disabled}

  for {set i 0} {$i<=$distnum} {incr i} {
     set distshow($i) 1
  }

  toplevel .dist

  wm title .dist {L2-Distances}
  wm geometry .dist "+450+500"

  
# Distance Buttons

  frame .dist.but
  pack .dist.but -side left
  set i 0
  foreach lab $distlabels {
    frame .dist.but.$i
    pack .dist.but.$i -fill x
    checkbutton .dist.but.$i.lab -text $lab -variable distshow($i) -anchor w \
                -command {makecommand -1 -1}
    pack .dist.but.$i.lab -side left
    incr i
  }

# Output window

  frame .dist.dv
  pack .dist.dv
  set ttt [ScrolledText .dist.dv 50 15]
  
# Control
  frame .dist.cont
  pack .dist.cont

  button .dist.cont.print -text print -command {printout distance}
  pack .dist.cont.print -side left
  
  button .dist.cont.close -text close -command {set calc_l2dist 0; destroy .dist}
  pack .dist.cont.close

}


}


