# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc GetData {a} {
global moviehome pwd
global datanamerem
global dataname defaultdata
global datadir datalist
global maxfiles

set name $dataname($a)

if { $name != {} } {

  if {[file extension $name]==".csv"} {
     set symbname $pwd/[file tail [file root $name]]_csv.symb

     makesymb $name $symbname
     textinfo "$name converted to $symbname"

     set name $symbname
  }
  
  if {[file extension $name]==".mcsv"} {
     set symbname $pwd/[file tail [file root $name]]_mcsv.symb

     mcsv2symb $name $symbname
     textinfo "$name converted to $symbname"

     set name $symbname
  }

   set dataname($a) $name
   set defaultdata($a) $name
   textinfo "Read: $name"
   set datanamerem $name
   ReadData
   DataInfo $dataname($a)
} else {
   if ![info exists dataname($a)] {
      set dataname($a) $datanamerem
   }


}

}



proc ReadData {} {
global datadir datalist dataname
global defaultdata
global maxfiles

set datalist ""

   for {set i 1} {$i<=$maxfiles} {incr i} {
    
     if [info exist defaultdata($i)] {
       if [file exists $defaultdata($i)] {
          set dataname($i) $defaultdata($i)
        }
     }

     if [info exist dataname($i)] {
       if [file exist $dataname($i)] {
         lappend datalist $i
         DataInfo $dataname($i)
       }
     }
   }
}



proc DataInfo {file} {

textinfo "Datafile: $file"

set infofile [file rootname $file].info
if {[file exist $infofile]} {
  set unit [open $infofile r]
  while {[eof $unit] != 1} {
  gets $unit line
  textinfo $line
}
close $unit
}

textinfo ""
set varlist ""
set unit [open $file r]
set k 0

while {[eof $unit] != 1} {
   gets $unit line
   set pos [string first /val/ $line]

   if {$pos!=-1} {
     lappend varlist [string range $line 0 [expr $pos-1]]
     incr k
   }
   if {$k==5} {
   textinfo "$varlist"
   set varlist ""
   set k 0
}
}
if ($k>0) {textinfo "$varlist"}

close $unit

textinfo ""
}

