# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc readvalu {a i item_in} {
global dataname
global gc
global valtime valdata
global valtid
global valinb valint valper valstd
global valdep
global timflag
global profile_data
global showbars doffset
global logflag
global netcdf
global year cycle allyear allboxes alldataboxes comboxlist

set monthlen(1) 31
set monthlen(2) 28
set monthlen(3) 31
set monthlen(4) 30
set monthlen(5) 31
set monthlen(6) 30
set monthlen(7) 31
set monthlen(8) 31
set monthlen(9) 30
set monthlen(10) 31
set monthlen(11) 30
set monthlen(12) 31

# a: file  i:graph  item: variable name
set timflag($a) 0

if {$netcdf==1} {
   set item [string tolower $item_in]
} else {
   set item $item_in
}

if [string match {[+*/]} $item] {continue}

set unit [open $dataname($a) r]

if [info exist val] {unset val}
if [info exist ymd] {unset ymd}
if [info exist tim] {unset tim}
if [info exist inb] {unset inb}
if [info exist int] {unset int}
if [info exist std] {unset std}
if [info exist per] {unset per}
if [info exist valt] {unset valt}
if [info exist tid] {unset tid}
if [info exist dep] {unset dep}

if [info exist valtime($a,$i)] {unset valtime($a,$i)}
if [info exist valdata($a,$i)] {unset valdata($a,$i)}
if [info exist valinb($a,$i)] {unset valinb($a,$i)}
if [info exist valint($a,$i)] {unset valint($a,$i)}
if [info exist valstd($a,$i)] {unset valstd($a,$i)}
if [info exist valper($a,$i)] {unset valper($a,$i)}
if [info exist valtid($a,$i)] {unset valtid($a,$i)}
if [info exist valdep($a,$i)] {unset valdep($a,$i)}

set itemlist ""
# Auswertung der ausgewählten Box
if {$allboxes==0} {
   set itemlist $item
} else {
#Auswertung aller gespeicherten Boxen
        if {$alldataboxes==0} {
                foreach number $comboxlist {
                        regsub {[(][0-9]+[)]} $item  ($number) boxitem
                        lappend itemlist $boxitem 
                }      
        } else {
# Auswertung bis zur box allboxes, auch wenn nicht gespeichert
                for {set number 1} {$number<=$alldataboxes} {incr number} {
                        regsub {[(][0-9]+[)]} $item  ($number) boxitem
                        lappend itemlist $boxitem
                }
        }
}

while {[eof $unit] != 1} {
   gets $unit act

   foreach item $itemlist {
                append val [extractval $unit $item /val/ $act]
                if {$val==""} {unset val} 
                append ymd [extractval $unit $item /ymd/ $act]
                if {$ymd==""} {unset ymd}
                append tim [extractval $unit $item /tim/ $act]
                if {$tim==""} {unset tim}
                append inb [extractval $unit $item /inb/ $act]
                if {$inb==""} {unset inb}
                append int [extractval $unit $item /int/ $act]
                if {$int==""} {unset int}
                append std [extractval $unit $item /std/ $act]
                if {$std==""} {unset std}
                append per [extractval $unit $item /per/ $act]
                if {$per==""} {unset per}
                append tid [extractval $unit $item /tid/ $act]
                if {$tid==""} {unset tid}
                append dep [extractval $unit $item /dep/ $act]
                if {$dep==""} {unset dep}  
   }
}
close $unit


if [info exists val] {

   if [info exists ymd] {
      foreach item $ymd {
       scan [string range $item 0 1] %d dyear
       scan [string range $item 2 3] %d month
       scan [string range $item 4 5] %d day
       set montim 0
       for {set j 1} {$j<$month} {incr j} {set montim [expr $montim+$monthlen($j)]}
       if {$allyear==1} {
          set yeartim 0
       } else {

          if {$dyear>70} {set dyear [expr $dyear+1900]} else {set dyear [expr $dyear+2000]} 
          set yeartim [expr ($dyear-abs($year(1)))*$cycle(1)]
       }
       lappend valt [expr $yeartim+$montim+$day]
      }
   } else {
       if {$doffset($a) ==""} {set voffset 0} else {set voffset $doffset($a)}
       foreach item $tim {
         lappend valt [expr $item+$voffset]
       }
   }

   if [info exists tid] {
      set index 0
      set list ""
      foreach item $tid {
       scan [string range $item 0 1] %d hour
       scan [string range $item 2 3] %d min
       set sum [expr [lindex $valt $index] +($hour+$min/60.0)/24.0]
       lappend list $sum
       incr index
      }
    set valt $list
   }

  set valtime($a,$i) $valt
  if [info exists tim] {set timflag($a) 1}

  if {$logflag==0} {
    set valdata($a,$i) $val
    if {[info exists inb] && $showbars==1} {set valinb($a,$i) $inb}
    if {[info exists int] && $showbars==1} {set valint($a,$i) $int}
    if {[info exists std] && $showbars==1} {set valstd($a,$i) $std}
    if {[info exists per] && $showbars==1} {set valper($a,$i) $per}
    if {[info exists dep] && $showbars==1} {set valdep($a,$i) $dep}
  } else {
    #Log Darstellung
    set valdata($a,$i) [llog $val]
  
  }

}
}


proc extractval {unit item what act} {
#Variablenname in symb-Files werden unabhaengig von case-sensitive result als lower-case behandelt.
#item wird uebergeordnet auf lower case gewandelt, act muss dann hier gewandelt werden, damit alle passenden Eintraege im symb-File gefunden werden koennen.

#act enthaelt den Namen und den gesamten Datensatz
set act [string tolower $act]
if {[string match $item [lindex [split $act /] 0]]!=0} {
  if {[string first $what $act]!=-1} {

      set act [string trimright $act]
      set out $act
      set last [string index $act end]

      while {$last==","} {
             gets $unit act
             append out $act
              set last [string index $act end]
      }

       regsub -all " " $out "" out
       set out [split $out :,]
       set out [lrange $out 1 end]
       set out "$out "
  }
}

if [info exist out] {return $out}
}


