# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc SelectData {} {
global dataname datalist defaultdata
global remdataname

global maxfiles pwd valu
global buttonFont
global ovc valu

set valu_rem $valu

if {$valu==1} {$ovc.left.toggle.val invoke}

if [winfo exists .chd] {destroy .chd}
toplevel .chd
wm title .chd {Select Data File}
wm geometry .chd "+630+300"


for {set i 1} {$i<=$maxfiles} {incr i} {

  if ![info exists dataname($i)] { set dataname($i) empty}
    
   set remdataname($i) $dataname($i)

   frame .chd.ff$i 
   pack .chd.ff$i  -fill x
   button .chd.ff$i.filename -text $dataname($i) -font $buttonFont\
                            -command "set defaultdata($i) empty;GetDataname $i;raise .chd"
   button .chd.ff$i.empty -text Release -font $buttonFont\
                            -command "set dataname($i) empty; set defaultdata($i) empty;
                                      .chd.ff$i.filename config -text empty;raise .chd"
  
  pack .chd.ff$i.filename -side left -fill x
  pack .chd.ff$i.empty   -side right

}

button .chd.f99 -text {Release all} -font $buttonFont\
       -command { 
                .chd.ff1.filename config -state normal
                .chd.ff2.filename config -state normal

                for {set i 1} {$i<= $maxfiles} {incr i} {
                  if [info exists dataname($i)] {set dataname($i) empty; set datalist ""}
                  if [info exists defaultdata($i)] {set defaultdata($i) empty}
                  .chd.ff$i.filename config -text empty
		 }

		 ReadData
		 if [winfo exist $ovc] {
		 set valu 0
		 valuset
		 }
                 textinfo "No data file active"
                 }
pack .chd.f99 -fill x

frame .chd.f100
pack  .chd.f100 -pady {0 5}

button .chd.f100.cancel -text {Cancel} -font $buttonFont\
       -command "eval_datalist 0; if {$valu_rem==1} {$ovc.left.toggle.val invoke}; destroy .chd" 
pack .chd.f100.cancel -fill x -side left

button .chd.f100.ok -text {OK} -font $buttonFont\
       -command "eval_datalist 1;if {$valu_rem==1} {$ovc.left.toggle.val invoke}; destroy .chd" 
pack .chd.f100.ok -fill x -side left

}


proc eval_datalist {{ok 1}} {
global maxfiles
global remdataname dataname datalist
global ovc

set datalist ""

for {set i 1} {$i<=$maxfiles} {incr i} {
   if {$ok==0} {set dataname($i) $remdataname($i)}

   if {$dataname($i) != "empty" } {
      lappend datalist $i
      GetData $i
   }
}

#if [winfo exist $ovc] {valuset}

}


proc GetDataname {a} {
global moviehome pwd
global remdataname
global dataname defaultdata
global datadir datalist

set dataname($a) [fileselect "Select data file" symb $datadir open]
if ![file exist $dataname($a)] {set dataname($a) empty}
if { $dataname($a) == "" } {set dataname($a) empty} else {set datadir [file dirname $dataname($a)] }
.chd.ff$a.filename config -text  $dataname($a)
return $dataname($a)
}



