# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc SelectResult {} {
global filename
global timewinrem timewin
global maxfiles
global buttonFont
global getresult filenum

if [info exists timewinrem] {set timewin $timewinrem}

if [winfo exists .chf] {destroy .chf}
toplevel .chf
wm title .chf {Select Result File}
wm geometry .chf "+630+300"
wm group .chf .
wm transient .chf .
wm protocol .chf WM_DELETE_WINDOW {set getresult 1; destroy .chf}

for {set i 1} {$i<=$maxfiles} {incr i} {
  if [info exists filename($i)] {set text $filename($i)} else {set text empty}
  button .chf.f$i -text $text -font $buttonFont -command "set filenum $i;GetFile $i;set getresult 1;destroy .chf"
  pack .chf.f$i -fill x

}

for {set i $maxfiles} {$i>=1} {set i [expr $i-1]}  {
   .chf.f$i configure -state disabled
   set next [expr $i+1]
   if [info exists filename($i)] {
        .chf.f$i configure -text $filename($i)
        .chf.f$i configure -state normal
        if {$next <= $maxfiles} {.chf.f$next configure -state normal}
    } else {
      .chf.f$i configure -text empty
    }
}

set text "Release 2 - $maxfiles"

button .chf.f99 -text $text -font $buttonFont\
       -command {for {set i 2} {$i<= $maxfiles} {incr i} {
                  if [info exists filename($i)] {unset filename($i)}
                  .chf.f$i configure -text empty
		 }
		 ReadFile $filename(1) 1
		 ReadData
		 set getresult 1
         destroy .chf} 
pack .chf.f99 -fill x

button .chf.f100 -text {Cancel} -font $buttonFont\
       -command {set getresult 1;destroy .chf}
pack .chf.f100 -fill x
update idletasks

}



