# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc valuplot {j row setnum} {

global colorlist mf
global plotFont boldFont
global graph gl
global barchart
global filelist
global legendtext
global dataname datalist
global vertoff
global valinb
global valint
global valper valstd
global vtim vdat
global vint vinb vper vstd
global xvgr_flag matlab_flag gnu_flag
global valushow showline
global allboxes
global runmean

set c $mf.left.plot 

set graph [lindex $gl $j]

set wid 4
set pint 4
set pinb 4

set colorindex [max 3 [lindex $filelist end]]

foreach a $datalist {

if {$runmean>0} {
 set vdatrm [running_mean_data $vtim($a,$j) $vdat($a,$j)]
}

 if {$valushow($a)==1} {

  if [info exists vtim($a,$j)] {
     set color [lindex $colorlist $colorindex]
     set len [llength $vtim($a,$j)]
     
# Merken, um Linie zu zeichnen
      set ptimerem [nnx [lindex $vtim($a,$j) 0]]
      if {$runmean==0} {
        set pdatarem [nnyj [lindex $vdat($a,$j) 0] $j] 
      } else {
        set pdatarem [nnyj [lindex $vdatrm 0] $j]
      }
      
    for {set k 0} {$k<$len} {incr k} {
      set ptime [nnx [lindex $vtim($a,$j) $k]]
       if {$runmean==0} {
          set pdata [nnyj [lindex $vdat($a,$j) $k] $j]
      } else {
          set pdata [nnyj [lindex $vdatrm $k] $j]
      }     
 

# Value itself
     
     if {$showline==0} {
         #set item [eval $c create line  [expr $ptime-4] $pdata [expr $ptime+4] $pdata -width 2 -fill $color]         
         set item [eval $c create text  $ptime $pdata -text "*" -anchor center -width 2 -fill $color]
         
         
         $c addtag $graph withtag $item
      } else {      
           set item [eval $c create line  $ptimerem $pdatarem $ptime  $pdata  -width 1 -fill $color] 
           $c addtag $graph withtag $item     
           set ptimerem $ptime
           set pdatarem $pdata
      }

      if {$runmean<=0} {
            if [info exists valper($a,$j)] {
                set wid [nnx0 [expr [lindex $vper($a,$j) $k]/2.0]]}

            if [info exists valint($a,$j)] {
                set pint [nnyj [lindex $vint($a,$j) $k] $j]
                # Int Bar
                set item [eval {$c create line} \
                            [expr $ptime-$wid] $pint [expr $ptime+$wid] $pint \
                            {-width 1 -fill $color}]
                $c addtag $graph withtag $item
            } else {
                #if {$showline==0} { set pint [expr $pdata-4]}  else {set pint $pdata}
                set pint [expr $pdata]
                
            }

            if [info exists valinb($a,$j)] {
                set pinb [nnyj [lindex $vinb($a,$j) $k] $j]
                #Inb Bar
                set item [eval {$c create line} \
                            [expr $ptime-$wid] $pinb [expr $ptime+$wid] $pinb \
                            {-width 1 -fill $color}]
                $c addtag $graph withtag $item
            } else {
                #if {$showline==0} { set pinb [expr $pdata+4]}  else {set pinb $pdata}
                set pinb [expr $pdata]

            }
            
        # Standardabweichung uebersteuert andere Balken

            if [info exists valstd($a,$j)] {

                set pint  [nnyj [expr [lindex $vdat($a,$j) $k] + [lindex $vstd($a,$j) $k]] $j]
                # Int Bar
                set item [eval {$c create line} \
                            [expr $ptime-$wid] $pint [expr $ptime+$wid] $pint \
                            {-width 1 -fill $color}]
                $c addtag $graph withtag $item


                set pinb  [nnyj [expr [lindex $vdat($a,$j) $k] - [lindex $vstd($a,$j) $k]] $j]
            #Inb Bar
                set item [eval {$c create line} \
                            [expr $ptime-$wid] $pinb [expr $ptime+$wid] $pinb \
                            {-width 1 -fill $color}]
                $c addtag $graph withtag $item
            }


        # Error bar
            set item [eval {$c create line}  $ptime $pint $ptime $pinb \
                            {-width 1 -fill $color}]
            $c addtag $graph withtag $item
      }

    }
   # Plotting of legend
   #-------------------
   set row [expr $row+$vertoff]
   if {$j >= 0} {

    set text [file rootname [file tail $dataname($a)]]
    set item [$c create text 450 $row -text $text \
             -font $plotFont -fill $color -anchor w]
    $c addtag $color$graph withtag $item
    $c addtag legend$graph withtag $item
    $c addtag $graph withtag $item

    $c bind legend$graph <1> "complegendDown $c %x %y legend$graph;\
                           $c itemconfig legend$graph -font {$boldFont}
"
    $c bind legend$graph <ButtonRelease-1> "complegendMove $c %x %y;\
                           $c dtag selected;\
                           $c itemconfig legend$graph -font {$plotFont}"
    set compleg(lastX) 0
    set compleg(lastY) 0
   }

   if {$xvgr_flag ==1} {
      if [info exist vtim($a,$j)] {
        if [info exist vint($a,$j)] {

          xv_init_valu $j $setnum [file rootname [file tail $dataname($a)]] $setnum \
                       $vtim($a,$j) $vdat($a,$j) $vint($a,$j) $vinb($a,$j)
        } else {

          xv_init_valu $j $setnum [file rootname [file tail $dataname($a)]] $setnum $vtim($a,$j) $vdat($a,$j)
        }
      }
   }

   if {$matlab_flag ==1} {
      if [info exist vtim($a,$j)] {
        if [info exist vint($a,$j)] {

          matlab_init_valu $j $setnum [file rootname [file tail $dataname($a)]] $setnum \
                       $vtim($a,$j) $vdat($a,$j) $vint($a,$j) $vinb($a,$j)
        } else {

          matlab_init_valu $j $setnum [file rootname [file tail $dataname($a)]] $setnum $vtim($a,$j) $vdat($a,$j)
        }
      }
   }

   if {$gnu_flag ==1} {
      if [info exist vtim($a,$j)] {
        if [info exist vint($a,$j)] {

          gnu_set_valu $j $setnum [file rootname [file tail $dataname($a)]]  \
                       $vtim($a,$j) $vdat($a,$j) $vint($a,$j) $vinb($a,$j)
        } else {
          gnu_set_valu $j $setnum [file rootname [file tail $dataname($a)]]  $vtim($a,$j) $vdat($a,$j)
        }
      }

   }

   incr setnum
   incr colorindex
  }
}

}
}


