# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

#########################################
# Main Contour procedure called from mov
#########################################
proc ContControl {} {
global can ovc
global actstart timewin
global time startbox boxwindow
global starttime endtime outd
global boxlist
global buttonFont
global filmmin filmmax

#setvars
#createcontrol

set coltab prism
set filmmin ""
set filmmax ""

control_bindings
makeslider

#startbox
set boxinterval [expr ([lindex $boxlist(1) end] - [lindex $boxlist(1) 0]) / 5]
scale $ovc.left.startbox   -font $buttonFont -from [lindex $boxlist(1) 0] -to [expr [lindex $boxlist(1) end] -1]\
      -variable startbox \
      -orient horizontal -label "Select startbox" \
      -tickinterval $boxinterval -showvalue true -resolution 1 \
      -bigincrement 5 -length 150

pack $ovc.left.startbox -fill x
bind $ovc.left.startbox <ButtonRelease-1> "corrBoxwin"

#boxwindow
set boxwindow [expr [lindex $boxlist(1) end] -1]

scale $ovc.left.boxwindow   -font $buttonFont -from 0 -to [expr $boxwindow-$startbox+1]  -variable boxwindow \
      -orient horizontal -label "Set box window" \
      -tickinterval $boxinterval -showvalue true -resolution 1 \
      -bigincrement 5

pack $ovc.left.boxwindow -fill x
bind $ovc.left.boxwindow <ButtonRelease-1> "corrStartbox"


#frame $ovc.left.set
#pack $ovc.left.set -padx 10 -pady {0 5}


frame $ovc.left.graph
pack $ovc.left.graph -side bottom -padx 10 -pady {0 5}

frame $ovc.right
grid $ovc.right -row 0 -column 2 -sticky news

frame $ovc.right.fix
pack $ovc.right.fix -side top -anchor w


frame $ovc.right.misc
pack $ovc.right.misc -side top -anchor n

checkbutton $ovc.right.misc.elay   -font $buttonFont -text {eval layer} \
       -variable evallayer  -anchor w \
       -command {interpret}
pack $ovc.right.misc.elay  -fill x -anchor w


checkbutton $ovc.right.misc.lay   -font $buttonFont -text {show layervalue} \
       -variable layervalue  -anchor w \
       -command {interpret}
pack $ovc.right.misc.lay  -fill x -pady {5 0} -anchor w

checkbutton $ovc.right.misc.mz   -font $buttonFont -text {mark zero values} \
       -variable markzeros -anchor w -state normal
pack $ovc.right.misc.mz -fill x -pady {5 0} -anchor w


# col menu
#---------

menubutton $ovc.right.misc.col   -font $buttonFont -text "Color table" -menu $ovc.right.misc.col.menu
pack $ovc.right.misc.col 
set m [menu $ovc.right.misc.col.menu -tearoff 0]

set labels {black&white blue&white green&white "red temperature" prism}
foreach lab $labels {
  $m add radio -label $lab -variable coltab -command "makefilmcolor"
}
$ovc.right.misc.col.menu invoke $coltab


label $ovc.right.misc.axtext   -font $buttonFont -text "Maximum value"
pack $ovc.right.misc.axtext -anchor w
set t [entry $ovc.right.misc.ymax -width 15 -textvariable filmmax   -font $buttonFont ]

pack $ovc.right.misc.ymax  -anchor w -pady {0 5}
bind $ovc.right.misc.ymax <Return> "interpret"

label $ovc.right.misc.axtext0   -font $buttonFont -text "Minimum value"
pack $ovc.right.misc.axtext0 -anchor w
set t [entry $ovc.right.misc.ymin -width 15 -textvariable filmmin   -font $buttonFont ]

pack $ovc.right.misc.ymin -anchor w -pady {0 5}
bind $ovc.right.misc.ymin <Return> "interpret"

apply_button
right_buttons
#button $ovc.right.misc.ana   -font $buttonFont -text {Analysis} \
#       -command {analysis}
#pack $ovc.right.misc.ana -fill x

#button $ovc.right.misc.com   -font $buttonFont -text {Command} \
#       -command {command}
#pack $ovc.right.misc.com -fill x
 
#button $ovc.right.misc.ps   -font $buttonFont -text {PS print} \
#       -command {printout}
#pack $ovc.right.misc.ps -fill x
 
makeselector
corrBoxwin

}

