# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

#########################################
# Main  procedure called from mov
#########################################
proc tools {  } {
global toolflag tooltype
global moviehome iconpath pwd nicevarfile
global data defaultresult2 defaultresult3 tempdir
global can canvas ttt bc
global filename filenum filenamelist forcecompare remembertool
global stopflag loopstop initmov
global wx wy movieversion
global buttonFont
global onewindow ovc bs vs nvs bc mf
global getresult 
global canvascolor 
set getresult 0

readdefaults
# wenn nicht anders eingestellt, immer mit overview starten
if {$remembertool==0 && $initmov==1} {
	set toolflag overview
	set initmov 0
}
# hier das gespeicherte toolflag übersteuern, wenn zwei oder mehr Dateien im Aufruf übergeben wurden,
# aber nur einmal, damit in MoViE umgeschaltet werden kann
if {$forcecompare==1} {
	set toolflag compare
	set forcecompare 0
	writedefaults
}
#destroytool
readnameinfo
colorswitch
set_plotcolors

set movtitle "Tiger Graphics MoViE $movieversion"
# HAUPTFENSTER
switch $toolflag {
  overview {set title "$movtitle Overview Tool"}
  compare {set title "$movtitle Compare Tool"}
  contour {set title "$movtitle Contour Tool"}
  phase {set title "$movtitle Phase Tool"}
  profile {set title "$movtitle Profile Tool"}
  profcom {set title "$movtitle Profile Compare Tool"}
  text {set title "$movtitle Text Tool"}
  film {set title "$movtitle Film Tool"}
#   prepare {set title "$movtitle Prepare Tool"}
#   custom {set title "$movtitle Preferences"}
}
wm title . $title
# OBERE BUTTONLEISTE
set bc .top
frame $bc 
grid $bc -row 0 -column 0 -sticky news

set mf .mf
frame $mf -padx 10 -pady 10 -borderwidth 1 -relief groove
grid $mf -row 1 -column 0 -sticky news

# linker Bereich
labelframe $mf.left -padx 5 -pady 10 -borderwidth 1 -relief groove
grid $mf.left -row 0 -column 1 -sticky news 
# rechter Bereich
labelframe $mf.right -padx 5 -pady 10 -borderwidth 1 -relief groove
grid $mf.right -row 0 -column 2 -sticky ne

# CANVAS
if {$toolflag!="text"} {
  initplot
  set canvas $mf.left.plot

  if {$toolflag=="film"} {set bgcol [option get . background {}]} else {set bgcol $canvascolor}
  canvas $canvas  -bg $bgcol -width $can -height $can -borderwidth 1 -relief groove
  grid $canvas -row 0 -column 0 -sticky nw
  $canvas bind all <Shift-Button-3> {set id [$canvas find closest %x %y]
                                    $canvas delete $id}
} else {
# TEXT
  frame $mf.left.screen -borderwidth 1 -relief groove
  grid  $mf.left.screen  -row 0 -column 0 -sticky news
  switch $can {
    400 {set cols 60;set rows 30}
    500 {set cols 70;set rows 35}
    600 {set cols 80; set rows 40}
    700 {set cols 90; set rows 50}
    800 {set cols 110; set rows 60}
    1000 {set cols 110; set rows 60}
    1200 {set cols 110; set rows 60}
    1600 {set cols 110; set rows 60}
  }
  if {$onewindow==1} {set rows [min 45 $rows]}
  set text $mf.left.screen

  set ttt [ScrolledText $text $cols $rows]
  update
  update idletasks
  $ttt configure -height $rows
  $ttt configure -width $cols
}

#Boxselector
if {$onewindow==1} {
	set bs $mf.left.bsframe
	labelframe $bs -padx 5 -pady 10 -borderwidth 1 -relief groove -text "Boxes"
	grid $bs -row 1 -column 0 -sticky news
}
#if {$toolflag=="film"} {
#.ov.plot bind all <Button-1> "entercanvas %x %y "
#}

# Info window
ScrolledListbox $mf.right.msg -width 80 -font $buttonFont
grid $mf.right.msg -row 0 -column 0 -sticky news

# Bereich unter der Listbox
labelframe $mf.right.combo
grid $mf.right.combo -row 1 -column 0 -sticky news
#Variable selector
if {$onewindow==1} {
	set vs $mf.right.combo.vsframe
	labelframe $vs -padx 5 -pady 10 -borderwidth 1 -text "Variables" -relief groove
	grid $vs -row 1 -column 1 -sticky nw
}


# HAUPTBUTTONS OBEN
# Tool menu
switch $toolflag {
	overview {set tooltext Overview}
	compare {set tooltext Compare}
	film {set tooltext Film}
	text {set tooltext Text}
	profile {set tooltext Profile}
	profcom {set tooltext ProfCompare}
	phase {set tooltext Phase}
	contour {set tooltext Contour}
}
menubutton $bc.tool  -font $buttonFont -text "$tooltext-Tool" -menu $bc.tool.menu
set mm [menu $bc.tool.menu -tearoff 0]
toolmenu $mm

button  $bc.load -text {Load Results} -font $buttonFont -command {
    $bc.load configure -state disabled
    if [winfo exists $bs] {destroy $bs}
    if [winfo exists $vs] {destroy $vs}
    if {[info exist nvs] && [winfo exists $nvs]} {destroy $nvs}
    if [winfo exists $ovc] {destroy $ovc}

    update idletasks
    if {$toolflag=="compare" || $toolflag=="profcom" || $toolflag=="text"} {
        SelectResult
        vwait getresult
    } else {
        GetFile 1
    }
    destroytool
    tools
    createcontrol
    $bc.load configure -state normal
}

# Load Data
if {$toolflag=="compare" || $toolflag=="profcom"} {
  button  $bc.dload  -font $buttonFont -text {Load Data} -command {
    $bc.dload configure -state disabled
    SelectData
    $bc.dload configure -state normal
    }
}

# Print
menubutton $bc.print  -font $buttonFont -text "Export" -menu $bc.print.menu

set mm [menu $bc.print.menu -tearoff 0]
printmenu $mm

# Map
menubutton $bc.map  -font $buttonFont -text "Map" -menu $bc.map.menu
set mm [menu $bc.map.menu -tearoff 0 -relief flat]
mapviewmenu $mm

#Prepare
button  $bc.prepare -text {Prepare} -font $buttonFont -command {preparetool}

#Preferences
button  $bc.preferences -text {Options} -font $buttonFont -command {customtool}

# About
#menubutton $bc.about  -font $buttonFont -text "About" -menu $bc.about.menu
#set mm [menu $bc.about.menu -tearoff 0 -relief flat]
#aboutmenu $mm

# Tatze
menubutton  $bc.tatze -bitmap @$iconpath/tinylogo.pic -menu $bc.tatze.menu
set mm [menu $bc.tatze.menu -tearoff 0 -relief flat]
aboutmenu $mm
# Exit
button  $bc.exit  -font $buttonFont -text {Exit} -command {
destroytool
cleanuphiddendir
destroy .
}

# Single window
checkbutton  $bc.ow  -font $buttonFont -text {single window mode} -variable onewindow \
-command {destroytool;writedefaults;tools;createcontrol}

if {$toolflag!="film" && $toolflag!="profile" && $toolflag!="profcom" && $toolflag!="contour"} {
checkbutton  $bc.boxslid  -font $buttonFont -text {Box Slider} -variable boxslid -command {
if {$boxslid==1 } {boxslider} else {box_selector}
}
}
checkbutton  $bc.nicevar  -font $buttonFont -text {Nice VarSelector} -variable nicevar -command {
if {$nicevar==1 } {nicevarselector} else {var_selector}	
}

# READING DATAFILES
if {$toolflag=="compare" || $toolflag=="profcom"} {
 ReadData
}

set defaultresult1 "$pwd/result.outc"
#Setting default resultname, if filenamelist is empty
if {[llength $filenamelist]==0} {

   if ![file exists $defaultresult1] {
      $mf.right.msg.list insert end "$defaultresult1 doesn't exist"
      set defaultresult1 "$moviehome/../info/xxxx.outc"
      $mf.right.msg.list insert end "using $defaultresult1 instead"
   }
   set filenamelist $defaultresult1
}
# Setting default result files for comparing tools
#if [file exists $defaultresult2] {lappend filenamelist $defaultresult2}
#if [file exists $defaultresult3] {lappend filenamelist $defaultresult3}

if {$filenum == -1} {
  set filenum 0
  foreach item $filenamelist {
  if [file exists $item] {
      incr filenum
      set filename($filenum) $item
      ReadFile $item $filenum
    } else {
      $mf.right.msg.list insert end "$item doesn't exist"
    }
  }
}

pack $bc.tool -side left
pack $bc.load -side left
if {$toolflag=="compare" || $toolflag=="profcom"} {
	pack $bc.dload -side left 
}
pack $bc.map -side left
pack $bc.print -side left 

pack $bc.tatze -side right
pack $bc.exit -side right
pack $bc.preferences -side right
pack $bc.prepare -side right
#pack $bc.about -side right
pack $bc.ow -side right
#pack $bc.scrolled_sel -side right
if {[file exists $nicevarfile]} { 
	set nicevar 0
    pack $bc.nicevar -side right
}    
if {$toolflag!="film" && $toolflag!="profile" && $toolflag!="profcom" && $toolflag!="contour"} {
 pack $bc.boxslid -side right
}
. configure -background [option get . background {}]
update
update idletasks
}

