# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

#########################################
# called from customtool
#########################################
proc writedefaults {} {
global preferences
global moviehome home pwd
global colorscheme plotcolorlist
global onewindow
global defaultresult2 defaultresult3
global defaultdata
global defaultdatadir
global defaultcas
global defaultboxfont
global defaultplotfont
global defaultxax
global defaultcan

global dataname datadir
global casesensitive xax can
global defaulticonsize
global toolflag
global remembertool
# Font Settings
global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global boxFont textFont
global plotFont boldFont buttonFont

set empty \"\"

set file ~/.tkmovierc
set id [open $file w+]
puts $id "set preferences $preferences"
close $id

# "Werkeinstellungen"
if {$preferences=="global"} {
	set file ~/.config/tkmovie5defaults
} else {
	set file $pwd/.tkmovie5defaults 
}
set id [open $file w+]

puts $id "set defaultdatadir [list $defaultdatadir]"
puts $id "set defaultdata(1) [list $defaultdata(1)]"
puts $id "set defaultdata(2) [list $defaultdata(2)]"
puts $id "set defaultdata(3) [list $defaultdata(3)]"
puts $id "set defaultdata(4) [list $defaultdata(4)]"
puts $id "set defaultdata(5) [list $defaultdata(5)]"
puts $id "set defaultcas $defaultcas"
puts $id "set defaultboxfont  [list $defaultboxfont]"
puts $id "set defaultplotfont  [list $defaultplotfont]"
puts $id "set defaultxax $defaultxax"
puts $id "set defaultcan $defaultcan"
puts $id "set defaulticonsize $defaulticonsize"
puts $id "set onewindow $onewindow"
puts $id "set toolflag $toolflag"
puts $id "set remembertool $remembertool"
puts $id "set colorscheme $colorscheme"
puts $id "set plotcolorlist $plotcolorlist"

#Write Fonts
puts $id "set boxFont [list $boxFont]"
puts $id "set plotFontN [list $plotFontN]"
puts $id "set plotFontS [list $plotFontS]"
puts $id "set plotFontT [list $plotFontT]"
puts $id "set boldFontN [list $boldFontN]"
puts $id "set boldFontS [list $boldFontS]"
puts $id "set boldFontT [list $boldFontT]"
puts $id "set textFont [list $textFont]"
puts $id "set buttonFont [list $buttonFont]"

close $id
}

proc readdefaults {} {
global preferences
global moviehome pwd
global onewindow
global toolflag
global colorscheme plotcolorlist
global defaultresult2 defaultresult3
global defaultdata
global defaultdatadir
global defaultcas
global defaultboxfont
global defaultplotfont
global defaultxax
global defaultcan
global remembertool
global dataname datadir
global casesensitive xax can
global defaulticonsize

# Font Settings
global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global boxFont textFont
global plotFont boldFont buttonFont

# Default fonts, if nothing else is set
set boxFont {-size 11}
set plotFontN {-size 12 -weight normal}
set plotFontS {-size 10 -weight normal}
set plotFontT {-size 8 -weight normal}
set boldFontN {-size 12 -weight bold}
set boldFontS {-size 10 -weight bold}
set boldFontT {-size 8 -weight bold}
set textFont {-size 11}
set buttonFont {-size 11}

#set defaultresult2  ""
#set defaultresult3  ""
set defaultdatadir  ""
set defaultdata(1)    ""
set defaultdata(2)    ""
set defaultdata(3)    ""
set defaultdata(4)    ""
set defaultdata(5)    ""

set defaultcas      0
set defaultxax 0
set defaultcan 600
set defaulticonsize normal
set file ""
set toolflag overview

set file ~/.tkmovierc
if [file exists $file] {
   set id [open $file r]
   while {[gets $id line] >=0} {
    eval $line
   }
   close $id
}
if {$preferences=="global"} {
	set file ~/.config/tkmovie5defaults
} else {
	set file $pwd/.tkmovie5defaults 
	if ![file exist $file] {set file ~/.config/tkmovie5defaults}
}
if [file exists $file] {
    set id [open $file r]
    while {[gets $id line] >=0} {eval $line}
    close $id
}

# Standard settings for start
set boldFont $boldFontN
set plotFont $plotFontN

   set k 1
   if [file exists $defaultdatadir] {set datadir $defaultdatadir} else {set datadir $pwd}
   if [file exists $defaultdata(1)]   {set dataname($k) $defaultdata(1); incr k}
   if [file exists $defaultdata(2)]   {set dataname($k) $defaultdata(2); incr k}
   if [file exists $defaultdata(3)]   {set dataname($k) $defaultdata(3); incr k}
   if [file exists $defaultdata(4)]   {set dataname($k) $defaultdata(4); incr k}
   if [file exists $defaultdata(5)]   {set dataname($k) $defaultdata(5);incr k}

   for {set i 1} {$i <= 5} {incr i} {set defaultdata($i) ""}
   for {set i 1} {$i < $k} {incr i} {set defaultdata($i) $dataname($i)}

   set casesensitive  $defaultcas
   set xax $defaultxax
   if {$defaultcan!=""} {set can $defaultcan}
#   writedefaults

}

