# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc boxview {filmbox} {
global filename
global filmvar
global toolflag xvgr_flag gc sc smooth ovc
global xmin xmax ymin ymax xdelt ydelt fixymin fixymax
global can
global bvyminrem bvymaxrem bvxminrem bvxmaxrem bvxdeltrem bvydeltrem
global buttonFont

toplevel .bv
wm title .bv {Box Overview }
wm geometry .bv "+0+0"

# In film ymin, ymax are reals, in plot they are arrays
# Storing the reals

set bvxminrem $xmin
set bvxmaxrem $xmax

set bvyminrem $ymin
set bvymaxrem $ymax

set bvxdeltrem $xdelt
set bvydeltrem $ydelt


# Initializing of the drawing area
#---------------------------------
frame .bv.top
pack .bv.top -side top -fill x

frame .bv.bot
pack .bv.bot -side top -fill x

canvas .bv.top.plot -width $can -height [expr $can+40]
pack .bv.top.plot -side left

button  .bv.bot.ok -text {  OK  } -font $buttonFont -command {
          set toolflag film
          if [info exist ymin] {unset ymin}
          if [info exist ymax] {unset ymax}
		  set xmin $bvxminrem
		  set xmax $bvxmaxrem
          set ymin $bvyminrem
          set ymax $bvymaxrem
          set xdelt $bvxdeltrem
          set ydelt $bvydeltrem
          enablefilm
		  destroy .bv
#		  raisewindows
                  }
pack  .bv.bot.ok

disablefilm
set toolflag boxview
set xvgr_flag 0
set smooth 1
set gc 0
set fixymin ""
set fixymax ""

if [info exist ymin] {unset ymin}
if [info exist ymax] {unset ymax}
if ![info exist filmvar] {
   textinfo "No Variable selected" 1
} else {
   regsub {[(][0-9]+[)]} $filmvar "" help
   makecommand $help $filmbox
}
$ovc.right.misc.apply invoke
}

