# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
# last change: 2002/04/25 fh

proc extract_filmdata {} {
global moviehome
global filmdata
global casesensitive
global data filename
global command spectrum what
global filmvar filmvarrem
global comboxlist
global layer mm actbox upper lower
global filmmin filmmax
global tracer lastbox
global harm

global actstart actend
global starttime endtime outdelt year cycle timewin
global fmin fmax colmin colmax
global first last 

set lastbox [lindex $comboxlist end]

regsub {[(][0-9]+[)]} $command(0) "" filmvar

if [info exists filmvarrem] {
   if {$filmvarrem != $filmvar} {
      set filmmin ""
      set filmmax ""
   }
}

scan "1.0e+15" %f fmin
scan "-1.0e+15" %f fmax

set filmvarrem $filmvar

scan [expr ($actstart(1)-$starttime(1))/$outdelt(1)] %d first
scan [expr $first +$timewin/$outdelt(1)] %d last
puts $first
# In der ersten Schleife werden nur die Extrema bestimmt aber nur, wenn keine festen Vorgaben gemacht wurden
if {$filmmin == "" || $filmmax == ""} {
  for {set i 1} {$i<=$actbox} {incr i} {
    set help ""
    set k [expr $i-1]
    if { $layer == "upper"} {
      set j [lindex $upper $k]
    } else {
      set j [lindex $lower $k]
    }

    append help $filmvar ( $j )

    if {$what(1)=="fourier"} {
        set minmax [exec $moviehome/../cprog/readminmax_pk $filename(1) $help $casesensitive $harm $first $last]
    } else {
        if {$what(1)=="netcdf"} {
          set minmax [exec $moviehome/../cprog/readminmax_nc $filename(1) $help $casesensitive $first $last]
        } else {
          set minmax [exec $moviehome/../cprog/readminmax $filename(1) $help $casesensitive $first $last]
       }
    }
    if {$minmax =="not_stored"} {textinfo "Error: $help not stored in $filename(1)" 1;return 0}
    scan [lindex $minmax 0] %f fmin1
    scan [lindex $minmax 1] %f fmax1
    set fmin [min $fmin $fmin1]
    set fmax [max $fmax $fmax1]
  }
}
# Extremwertvorgaben auswerten
if {$filmmin != ""} {set fmin $filmmin}
if {$filmmax != ""} {set fmax $filmmax}

# Jetzt werden die Daten geholt, aber gleich auf fmin,fmax, colmin und colmax skaliert,
# sodass echte Farbindizes rueberkommen
for {set i 1} {$i<=$actbox} {incr i} {
  set help ""
  set k [expr $i-1]
  if { $layer == "upper"} {
    set j [lindex $upper $k]
  } else {
    set j [lindex $lower $k]
  }

  append help $filmvar ( $j )

#  set filmdata($i) [exec $moviehome/../cprog/readdata $filename(1) $help $casesensitive]
  if {$what(1)=="fourier"} {
      set filmdata($i) [exec $moviehome/../cprog/readfast_pk $filename(1) $help $casesensitive $harm $first $last $fmin $fmax $colmin $colmax]
  } else {
     if {$what(1)=="netcdf"} {
        set filmdata($i) [exec $moviehome/../cprog/readfast_nc $filename(1) $help $casesensitive $first $last $fmin $fmax $colmin $colmax]
     } else {
        set filmdata($i) [exec $moviehome/../cprog/readfast $filename(1) $help $casesensitive $first $last $fmin $fmax $colmin $colmax]
     }
}
}
if {$tracer == 1} {extract_tracer}
return 1
}

