# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

#########################################
# Main Overview procedure called from mov
#########################################
proc FilmControl {} {
global can ovc mf
global actstart timewin
global starttime endtime outd
global colnum actbox
global mapcoor upper lower whichmap obj
global layer mm
global comboxlist lastbox
global filmmin filmmax
global borders numbers markzeros
global varrem boxrem
global buttonFont 

set borders 0
set numbers 0
set markzeros 0

set coltab prism
set layer upper
set filmmin ""
set filmmax ""

control_bindings
makeslider

label $ovc.left.lmin  -font $buttonFont -text "Set minimum value"
pack $ovc.left.lmin -anchor w
set t [entry $ovc.left.min -width 15 -textvariable filmmin -font $buttonFont ]
pack $ovc.left.min -anchor w -pady {0 5}
bind $ovc.left.min <Return> "focus $ovc.left.max;disablestart"

label $ovc.left.lmax  -font $buttonFont -text "Set maximum value"
pack $ovc.left.lmax -anchor w
set t [entry $ovc.left.max -width 15 -textvariable filmmax -font $buttonFont ]
pack $ovc.left.max -anchor w -pady {0 5}
bind $ovc.left.max <Return> "focus $ovc.left.min;disablestart"


frame $ovc.right
grid $ovc.right -row 0 -column 2 -sticky news

frame $ovc.right.misc
pack $ovc.right.misc -side top -padx 5

# col menu
#---------
checkbutton $ovc.right.misc.bor  -font $buttonFont -text {show borderlines} \
       -variable borders -command "disablestart" -anchor w -state normal
pack $ovc.right.misc.bor -fill x

checkbutton $ovc.right.misc.num  -font $buttonFont -text {show box numbers} \
       -variable numbers -command "disablestart" -anchor w -state normal
pack $ovc.right.misc.num -fill x

checkbutton $ovc.right.misc.mz  -font $buttonFont -text {mark zero values} \
       -variable markzeros -anchor w -state normal
pack $ovc.right.misc.mz -fill x


menubutton $ovc.right.misc.col  -font $buttonFont -text "Color table" -menu $ovc.right.misc.col.menu
pack $ovc.right.misc.col 
set m [menu $ovc.right.misc.col.menu -tearoff 0]

set labels {black&white blue&white green&white "red temperature" prism}
foreach lab $labels {
  $m add radio -label $lab -font $buttonFont -variable coltab -command "makefilmcolor;disablestart"
}
$ovc.right.misc.col.menu invoke $coltab

# map menu
#---------
checkbutton $ovc.right.misc.trac  -font $buttonFont -text {Tracer} \
       -variable tracer  \
       -command {disablestart;$mf.left.plot  delete tracer} \
       -anchor w
pack $ovc.right.misc.trac  -fill x -pady {0 5} -anchor w

menubutton $ovc.right.misc.map  -font $buttonFont -text "choose map" -menu $ovc.right.misc.map.menu
pack $ovc.right.misc.map 
set mm [menu $ovc.right.misc.map.menu -tearoff 0]

filmmapmenu $mm
 
button $ovc.right.misc.up  -font $buttonFont -text {upper boxes} \
       -command {if {$layer == "upper"} { 
                    set layer lower
                    $ovc.right.misc.up config -text {lower boxes}
                } else {
                    set layer upper
                    $ovc.right.misc.up config -text {upper boxes}
                }
                 drawnum;disablestart
                }
pack $ovc.right.misc.up -fill x
 

button $ovc.right.misc.ana  -font $buttonFont -text {Analysis} \
       -command {analysis}


apply_button


#button $ovc.right.misc.start  -font $buttonFont -text {Start film} \
       -command {startfilm} -state disabled
#pack $ovc.right.misc.start -fill x
 
makeselector

set lastbox [lindex [lsort -integer $comboxlist] end]

switch $lastbox {
   15  {set whichmap "ERSEM 15"}
   25  {set whichmap "ERSEM 15"}
   130 {set whichmap "ERSEM 130"}
   155 {set whichmap "ERSEM 130"}
   50  {set whichmap "ECOTIM"}
   99  {set whichmap "ECOTIM"}
   100 {set whichmap "ECOTIM"}
   138 {set whichmap "COCOA"}
   159 {set whichmap "COCOA"}
   167 {set whichmap "COCOA"}
   2500 {set whichmap "SQUARE"}
   default {set whichmap "ERSEM 15"}
}
$mm invoke $whichmap
}

