# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc box_selector {} {
global DOS
global can
global varlist boxlist nicevarlist
global comvarlist comboxlist
global varrem boxrem
global boxwin varwin
global newset newgraph
global toolflag
global filename
global casesensitive
global boxFont
global varbut boxbut var_butwid_extra box_butwid_extra
global buttoncolor
global moviehome
global onewindow bs vs

if {($toolflag == "overview") || ($toolflag == "compare") || ($toolflag == "text") || $toolflag == "phase" } {
  if {[info exist bs] && [winfo exist $bs]} {
	set kids [winfo children $bs]
	foreach kid $kids {destroy $kid}
  }

set max_frameheight [expr [winfo screenheight .] -$can -200]
set max_framewidth [expr $can -10]

if {$onewindow==0} {
  if {[info exist bs] && [winfo exist $bs]} {destroy $bs}
  set bs .bs  
  if [winfo exist $bs] {destroy $bs}  
  toplevel $bs
  wm title $bs {Box Selector}
  wm geometry .bs "+50+[expr $can +150]"
  wm group $bs .
  wm transient $bs .
  wm protocol $bs WM_DELETE_WINDOW exit
  set max_frameheight [expr [winfo screenheight .] -50] 
} 

if [winfo exist $bs.bsm] {
	  destroy $bs.bsm
	  destroy $bs.vsb
	  destroy $bs.hsb
}

  scrolledframe $bs.bsm -xscroll [list $bs.hsb set] -yscroll [list $bs.vsb set] 
  scrollbar $bs.vsb -command [list $bs.bsm yview]
  scrollbar $bs.hsb -command [list $bs.bsm xview] -orient horizontal
  grid $bs.bsm -row 0 -column 0 -sticky nw
  grid $bs.bsm.scrolled -row 0 -column 0 -sticky nw
  grid $bs.vsb -row 0 -column 1 -sticky ns
  grid $bs.hsb -row 1 -column 0 -sticky ew
#  grid rowconfigure $bs 0 -weight 1
#  grid columnconfigure $bs 0 -weight 1
  set count 0
  set framecount 1

  frame $bs.bsm.scrolled.$framecount
  pack $bs.bsm.scrolled -side left
  pack $bs.bsm.scrolled.$framecount

# Number of columns
  set boxbut ""
  set fontsize [lindex [split $boxFont " "] 1]
  if {$fontsize>=10} {
	 set butwid [expr $box_butwid_extra + 3]
	} else {
     set butwid [expr $box_butwid_extra + 5]
	}

  set column [expr int($can/($butwid*$fontsize))]
  if {$DOS==2} {set butwid [expr $butwid -1]}
  
  foreach box $comboxlist {
   if {[winfo exists $bs.bsm.scrolled.$framecount.$box] == 0} {
  
     set butwid [expr [max $butwid [string length $box]]]

# Number of columns
     set offset [expr fmod($count,$column) ]
     set count [expr $count+1]
     if {$offset ==0} {
      set framecount [expr $framecount+1]
      frame $bs.bsm.scrolled.$framecount
      pack $bs.bsm.scrolled.$framecount  -fill x
     }
     button $bs.bsm.scrolled.$framecount.$box -text $box \
           -command "makecommand -1 $box" -font $boxFont 
     pack $bs.bsm.scrolled.$framecount.$box -side left -fill x -anchor nw

     lappend boxbut $bs.bsm.scrolled.$framecount.$box
     
     if {$toolflag == "overview" || $toolflag == "phase"} {
       bind $bs.bsm.scrolled.$framecount.$box <2> {tkButton2Down %W}
       bind $bs.bsm.scrolled.$framecount.$box <ButtonRelease-2> \
              "set newset 1;makecommand -1 $box;tkButton2Up %W"
     }


     if {$toolflag != "phase"} {
        bind $bs.bsm.scrolled.$framecount.$box <3> {tkButton3Down %W}
        bind $bs.bsm.scrolled.$framecount.$box <ButtonRelease-3> \
              "set newgraph 1;makecommand -1 $box;tkButton3Up %W"
     }
   }
  }
set butwid [expr $butwid + $box_butwid_extra]
  
#~ set ll [winfo children $bs.bsm.scrolled]
#~ if [info exists boxwin] {unset boxwin}

#~ foreach l $ll { append boxwin [winfo children $l] " "}
if {[llength $boxbut]==0} {textinfo "No common boxes" 1}
foreach but $boxbut {$but config -width $butwid -padx 1}

set req_frameheight [expr ($framecount-1)*[winfo reqheight [lindex $boxbut 0]]]
set req_framewidth [expr $column*[winfo reqwidth [lindex $boxbut 0]]]

set frameheight [min $req_frameheight $max_frameheight]
set framewidth [min $req_framewidth $max_framewidth]
#puts "max_frameheight:$max_frameheight req_frameheight:$req_frameheight frameheight:$frameheight"
#puts "max_framewidth:$max_framewidth req_framewidth:$req_framewidth framewidth:$framewidth"

if {$req_frameheight<$max_frameheight} {
	grid forget $bs.vsb
}
if {$req_framewidth<$max_framewidth} {
	grid forget $bs.hsb
}
$bs.bsm config -width $framewidth -height $frameheight
$bs.bsm.scrolled config -width $framewidth -height $frameheight
 
makecommand [lindex $comvarlist 0] [lindex $comboxlist 0]
set boxwin $boxbut
}
}

