# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc extract_one_set {a item} {
global command sc gc what
global moviehome
global filename spectrum distance
global casesensitive
global toolflag
global not_stored
global harm
# puts $item

# spectrum only valid in compare
if [info exist spectrum] {set spec $spectrum} else {set spec 0}
if [info exist distance] {if {$distance==1} {set spec 1}}

set not_stored($item) 0
set rem_item $item

set error 0
set numvars 0
set result 1
set count 0
while {$result==1 && $count < 200} {
   set result [regexp {[A-Za-z][A-Za-z0-9_]*[(][0-9]+[)]?} $item test]
   if {$result ==1} {
     incr numvars
     incr count
     set variables($numvars) $test
     set replace($numvars) place$numvars

     set help [split $test ()]
     set test [lindex $help 0]\\([lindex $help 1]\\)
     regsub -all $test $item $replace($numvars) item
   }
}
# puts $item

# Evaluating expression list
if [info exist numvalues] {unset numvalues}

for {set i 1} {$i <= $numvars} {incr i} {

  if {$what($a)=="fourier" && $spec==0} {
     set value($i) [exec $moviehome/../cprog/readdata_pk $filename($a) $variables($i) $casesensitive $harm]
  } else {
     if {$what($a)=="netcdf"} {
         set value($i) [exec $moviehome/../cprog/readdata_nc $filename($a) $variables($i) $casesensitive]
     } else {
        set value($i) [exec $moviehome/../cprog/readdata $filename($a) $variables($i) $casesensitive]
     }
  }
#puts "$i  $variables($i) [lindex $value($i) 0]"

  set no_var($i) 0
  if [string match not_stored [lindex $value($i) 0]] {
     lappend value($i) 0
     set no_var($i) 1
     set not_stored($rem_item) 1
  }
  if ![info exist numvalues] {set numvalues [llength $value($i)]}
}

# Calculating output list
for {set j 0} {$j<$numvalues} {incr j} {
  set math $item
#decreasing loop to avoid replacing place10 by place1
  for {set i $numvars} {$i >=1} {set i [expr $i-1]} {
     if {$no_var($i)==0} {

       set wert [expr double([lindex $value($i) $j])]
       #set wert [lindex $value($i) $j]

     } else {set wert no_value}
 
     regsub -all $replace($i) $math $wert math
#     puts "i=$i replace=$replace($i) math=$math wert=$wert"

  }
  if {[catch {expr $math} wert]} {
     set error 1
     puts "math=$math wert=$wert"
     switch -- $math {
        nan {set errorstring -997; set infostring "NaN occurred"}
        -nan {set errorstring -997; set infostring "-NaN occurred"}
        inf {set errorstring -999; set infostring "Inf occurred"}
        -inf {set errorstring -998; set infostring "-Inf occurred"}
        default {set errorstring -991; set infostring "Unknown error occurred"}
     }
     lappend output $errorstring
  } else {
     # NEU 130813
     set wert [expr double($wert)]
     lappend output $wert
  }
}
if {$error==1} {
   textinfo "Error in expression $rem_item - $infostring"
   textinfo "Return value set to $errorstring"
}
# puts $output
return $output
}




