# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc fileselect {title type dir operation {initfile MOVIECOMMAND}} {

switch $type {

outc { set types {
	{ "Result files"	{.outc}	}
	{ "Result files"	{.outb}	}
	{ "Result files"	{.outa}	}
	{ "Result files"	{.nc}	}
	{ "Result files"	{.csv}	}
	{ "All files"		*}
    }
     set type outc
}

mcf  { set types {
	{ "Movie Command files"	{.mcf}}
	{ "All files"		*}
       }
       if [file exists $dir/mcf] {set dir $dir/mcf}   
     }

symb { set types {
	{ "Data files"	{.symb}	}
	{ "All files"		*}
     }
    }   

outa { set types {
	{ "Text output files"	{.outa}	}
	{ "All files"		*}
     }
    }   

info { set types {
	{ "Info files"	{.info}	}
	{ "All files"		*}
     }
       }   

c    { set types {
	{ "C Source Files"	{.c}}
	{ "All files"		*}
       }   
     }

m    { set types {
	{ "MatLab Files"	{.m}}
	{ "All files"		*}
       }   
     }

ps    { set types {
	{ "PS Files"	{.ps .eps}}
	{ "All files"		*}
       }
     }

ps    { set types {
	{ "PDF Files"	{.pdf}}
	{ "All files"		*}
       }
     }

agr    { set types {
	{ "XMGR, Grace"	{.agr .xmgr .xvg .xgr}}
	{ "All files"		*}
       }
     }

txt -
asc    { set types {
	{ "Text"	{.txt .asc}}
	{ "All files"		*}
       }
     }

bat    { set types {
	{ "Batch files"	{.bat}}
	{ "All files"		*}
       }
     }

lst    { set types {
	{ "Sequences"	{.lst}}
	{ "All files"		*}
       }
     }

csv    { set types {
	{ "CSV"	{.csv .txt .dat}}
	{ "All files"		*}
       }
     }


default { set types {
	   { "All files"		*}
	   { "Movie Command files"	{.mcf}}
	   { "Tcl Scripts"		{.tcl}}
	   { "C Source Files"	{.c .h}}
        }   
    }
}



global tk_strictMotif
set tk_strictMotif 0
    if {$operation == "open"} {
	set file [tk_getOpenFile -title $title -filetypes $types -initialdir $dir]
    } else {
	set file [tk_getSaveFile -filetypes $types -title $title -initialdir $dir -initialfile $initfile -defaultextension .$type]
    }
    
return $file
}


proc dirselect {title dir {exist 1}} {
global tk_strictMotif
set tk_strictMotif 0
set dir [tk_chooseDirectory -initialdir $dir -title $title -mustexist $exist]
return $dir
}


