# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc makeslider {{a 1}} {

global actstart actstartt starttime endtime outd timewin tickint timewint cycle
global timewinrem
global filename maxfiles connect
global buttonFont can
global ovc slid

set slid $ovc.left.slid 
frame $slid
pack $slid

scrolledframe $slid.scr -xscroll [list $slid.hsb set] -yscroll [list $slid.vsb set]
scrollbar $slid.vsb -command [list $slid.scr yview]
scrollbar $slid.hsb -command [list $slid.scr xview] -orient horizontal
grid $slid.scr -row 0 -column 0 -sticky news
grid $slid.scr.scrolled -row 0 -column 0 -sticky news
grid $slid.vsb -row 0 -column 1 -sticky ns

set max_frameheight [expr int($can/2.5)]
set rowcount 0
for {set i 1} {$i<=$a} {incr i} {
	if {$i==1} {set tlabel "Select Starttime"} else {set tlabel ""}
# Initializing of sliders
#------------------------
#starttime
	if [info exists filename($i)] {
		set tickint [max [expr ($endtime($i)-$starttime($i))/2] 360]
		scale $slid.scr.scrolled.start$i  -font $buttonFont -from $starttime($i) -to $endtime($i)\
		      -variable actstart($i) \
		      -orient horizontal -label $tlabel \
		      -tickinterval $tickint -showvalue true -resolution $outd \
		      -bigincrement 360
		
		grid $slid.scr.scrolled.start$i -column 0 -row $rowcount  -sticky news
		bind $slid.scr.scrolled.start$i <ButtonRelease-1> "corrStart $i"
		incr rowcount
		set actstartt($i) $actstart($i)
		
		if {$i>=1} {
			entry $slid.scr.scrolled.tstart$i -width 25 -textvariable actstartt($i) -font $buttonFont
			grid $slid.scr.scrolled.tstart$i  -column 0 -row $rowcount 
			bind $slid.scr.scrolled.tstart$i <Return> "corrStartt $i"
			incr rowcount
		}
	}
}
#timewin
scale $slid.scr.scrolled.timewin  -font $buttonFont -from $outd -to $timewinrem -variable timewin \
      -orient horizontal -label "Set time window" \
      -tickinterval $tickint -showvalue true -resolution $outd \
      -bigincrement 360

grid $slid.scr.scrolled.timewin  -column 0 -row $rowcount -sticky news
bind $slid.scr.scrolled.timewin <ButtonRelease-1> "corrTimewin"
incr rowcount

set timewint $timewin
entry $slid.scr.scrolled.timewint -width 25 -textvariable timewint -font $buttonFont 
grid $slid.scr.scrolled.timewint  -column 0 -row $rowcount -sticky nw
bind $slid.scr.scrolled.timewint <Return> "corrTimewint"
update
#puts "width slid [winfo reqwidth $slid] slid.scr [winfo reqwidth $slid.scr] slid.scr.scrolled [winfo reqwidth $slid.scr.scrolled]"
set req_frameheight [winfo reqheight $slid.scr]
if {$req_frameheight <= $max_frameheight} {grid forget $slid.vsb}
set frameheight [min $req_frameheight $max_frameheight]
set framewidth [winfo reqwidth $slid.scr]
$slid.scr configure -height $frameheight -width $framewidth
update
#puts "height slid [winfo reqheight $slid] slid.scr [winfo reqheight $slid.scr] slid.scr.scrolled [winfo reqheight $slid.scr.scrolled]"

# NEW 221102
frame $ovc.left.wcontrol1
pack $ovc.left.wcontrol1 -fill x
#~ grid $ovc.left.wcontrol1

if [info exist cycle(1)] {
button $ovc.left.wcontrol1.windowcycle  -text {set to cycle} -font $buttonFont  \
	    -command {set timewin $cycle(1);corrTimewin}
pack $ovc.left.wcontrol1.windowcycle -fill x -side left
}
button $ovc.left.wcontrol1.windowreset  -text {reset} -font $buttonFont  \
	    -command {set timewin $timewinrem;corrTimewin}
pack $ovc.left.wcontrol1.windowreset -fill x

# NEW 221102

frame $ovc.left.wcontrol2
pack $ovc.left.wcontrol2 -fill x
#~ grid $ovc.left.wcontrol2

#
# In den Kommandos der folgenden Buttons ist die eigentlich sinnlose Schleife $i von1 bis 1 verwendet. 
# Es kann sein, dass zur Beseitigung noch nicht erkennbarer Nebeneffekte die Schleife bis $maxfiles laufen muss
# Abwarten!!!!!!!!!!!!!!!!  
global slidloop
if {$connect==1} {set slidloop $maxfiles} else {set slidloop $maxfiles}

button $ovc.left.wcontrol2.windowfirst  -text {<<-} -font $buttonFont  \
	    -command { for {set i 1} {$i<=$slidloop} {incr i} {
						if [info exist actstart($i)] {
							set actstart($i) $starttime($i)
							corrStart $i
						    }	
						}
				 }
pack $ovc.left.wcontrol2.windowfirst  -fill x -side left

button $ovc.left.wcontrol2.windowprev  -text {<-} -font $buttonFont  \
	    -command {for {set i 1} {$i<=$slidloop} {incr i} {
	                 if [info exist actstart($i)] {
                        set actstart($i) [expr $actstart($i)-$timewin]
                        corrStart $i
                      }
                   }
                 }
pack $ovc.left.wcontrol2.windowprev  -fill x -side left 

button $ovc.left.wcontrol2.windownext  -text {->} -font $buttonFont  \
	    -command {for {set i 1} {$i<=$slidloop} {incr i} {
	                 if [info exist actstart($i)] {
						 set temp [expr $actstart($i)+$timewin]
						 if {$temp < $endtime($i)} {
								set actstart($i) $temp
								corrStart $i
						}		
                      }
                   }
                 }

button $ovc.left.wcontrol2.windowlast  -text {->>} -font $buttonFont  \
	    -command { for {set i 1} {$i<=$slidloop} {incr i} {
						if [info exist actstart($i)] {
							set actstart($i) [expr $endtime($i)-$timewin] 
							corrStart $i
						    }	
						}
				 }
pack $ovc.left.wcontrol2.windowlast  -fill x -side right
pack $ovc.left.wcontrol2.windownext  -fill x -side right
}

proc enableslider {} {configslider normal black} 

proc disableslider {} {configslider disabled "#a3a3a3"} 


proc configslider {slstate fgcol} {
	global ovc slid maxfiles
    set list "$slid.scr.scrolled.timewin $slid.scr.scrolled.timewint $ovc.left.wcontrol1.windowcycle $ovc.left.wcontrol1.windowreset $ovc.left.wcontrol2.windowprev $ovc.left.wcontrol2.windownext"
   	for {set i 1} {$i<=$maxfiles} {incr i} {
       lappend list "$slid.scr.scrolled.start$i"
       lappend list "$slid.scr.scrolled.tstart$i"
    }   
    foreach item $list {
		puts $item
		if [winfo exist $item] {$item config -state $slstate;$item config -fg $fgcol}
    }
}

