# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc eval_slid {j k} {
global starttime endtime outdelt timewin
global actstart
global singleresult result command
global meanflag sumflag stepmean stepsum logflag
global toolflag
global spectrum harm numharm what harmend startharm

if {$spectrum==0 || $what($k)!="fourier"} {
  scan [expr ($actstart($k)-$starttime($k))/$outdelt($k)] %d first
  scan [expr $first +$timewin/$outdelt($k)] %d last
} else {
  if ![info exist startharm] {set startharm 0}
  scan [expr $startharm*2.0] %d first
  if {$startharm>0} {set first [expr $first-1]}
  scan [expr $first +$harm*2] %d last
  if {$startharm>0} {set last [expr $last-1]}
}

   
foreach selectvar $command($j) {
  set singleresult($selectvar) [lrange $result($selectvar) $first $last]

  if {$stepmean==1} {set singleresult($selectvar) [step_calc $singleresult($selectvar) 1 mean]}
  if {$stepsum ==1} {set singleresult($selectvar) [step_calc $singleresult($selectvar) 1 sum]}

  if {$meanflag ==1 && $toolflag != "text"} {
    set singleresult($selectvar) [lmean $singleresult($selectvar)]
  }

  if {$sumflag ==1 && $toolflag != "text"} {
    set singleresult($selectvar) [lsum $singleresult($selectvar)]
  }
   if {$logflag ==1 } {
    set singleresult($selectvar) [llog $singleresult($selectvar)]
  }

}

}

proc calc_ext {j} {
global ymin ymax
global singleresult command
global seq seq_min seq_max

set ymax($j) [lindex $singleresult([lindex $command($j) 0]) 0]
set ymin($j) $ymax($j)

foreach selectvar $command($j) {
   if {$seq==0} {
     set ymax($j) [max [lmax $singleresult($selectvar)] $ymax($j)]
     set ymin($j) [min [lmin $singleresult($selectvar)] $ymin($j)]
   } else {
     set ymin($j) $seq_min($selectvar)
     set ymax($j) $seq_max($selectvar)
   }
}
}

proc calc_glob_ext {} {
global ymin ymax
global gc

set ymaxhelp $ymax(0)
set yminhelp $ymaxhelp

for {set j 0} { $j <= $gc } {incr j} {
     set ymaxhelp [max $ymaxhelp $ymax($j)]
     set yminhelp [min $yminhelp $ymin($j)]
}

for {set j 0} { $j <= $gc } {incr j} {
     set ymax($j) $ymaxhelp
     set ymin($j) $yminhelp
}


}



