# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc SetLabel {} {
global labelFont labelboldFont
global buttonFont
global lfontsize ovc can

toplevel .lab

wm title .lab {Set Label}
wm geometry .lab "+[expr $can+100]+$can"
wm attributes .lab -topmost yes

$ovc.right.misc.lab configure -state disabled

set labelFont -*-Helvetica-Medium-R-Normal--*-180-*-*-*-*-*-*
set labelboldFont -*-Helvetica-Bold-R-Normal--*-180-*-*-*-*-*-*
set fontsize 18

set t [entry .lab.text -width 40  -font $buttonFont -textvariable labtext]
pack .lab.text

bind .lab.text <Return> "labelLoad .lab.text \$labtext"
focus .lab.text

menubutton .lab.font  -font $buttonFont -text Fontsize -menu .lab.font.menu
pack .lab.font -side left
set m [menu .lab.font.menu -tearoff 0]
set labels {10 14 18 22 26}

foreach lab $labels {
  $m add radio -label $lab -variable lfontsize -value $lab -command {labfsize}
}

button .lab.apply  -font $buttonFont -text {apply}\
       -command {labelLoad .lab.text $labtext} 

button .lab.close  -font $buttonFont -text {close}\
       -command {destroy .lab; $ovc.right.misc.lab configure -state normal} 
pack .lab.close -side right
pack .lab.apply -side right


}

proc labfsize {} {
global labelFont labelboldFont lfontsize
set labelFont -*-Helvetica-Medium-R-Normal--*-${lfontsize}0-*-*-*-*-*-*
set labelboldFont -*-Helvetica-Bold-R-Normal--*-${lfontsize}0-*-*-*-*-*-*
}

proc labelLoad {w ff} {
global can mf
global lab
global labelFont labelboldFont
global moviehome
$w delete 0 end
$w insert 0 $ff

set c $mf.left.plot 
set xpos [expr $can*0.75]
set ypos 30

set item [$c create text $xpos $ypos -text $ff \
                   -anchor n -font $labelFont]

$c addtag label withtag $item

#$c bind label <3> "erase $c current"

$c bind label <1> "labelDown $c %x %y current;\
                    $c itemconfig selected -fill lightgrey"

$c bind label <ButtonRelease-1> "labelMove $c %x %y;\
                                 $c itemconfig selected -fill black"

set lab(lastX) 0
set lab(lastY) 0

}


proc labelDown {w x y g} {
    global lab
   
    $w dtag selected
    $w addtag selected withtag $g
    set lab(lastX) $x
    set lab(lastY) $y
}

proc labelMove {w x y} {
    global lab
    $w move selected [expr $x-$lab(lastX)] [expr $y-$lab(lastY)]
    set lab(lastX) $x
    set lab(lastY) $y
}


