# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg


proc matlab_openf {} {
global pwd gc 
global matlab_out
global data title gc_rem matlab_legend

set o_data data
set o_title title
set gc_rem 1
set matlab_legend ""

# Preparation of the  header structure 
set systemTime [clock seconds]
puts $matlab_out "% Automatically generated MatLab  m-file by MoViE "
puts $matlab_out "%  [clock format $systemTime -format %D] [clock format $systemTime -format %H:%M:%S]"
puts $matlab_out "% (c) Cora Kohlmeier* & Frank Hamberg"
puts $matlab_out "%     *ICBM University of Oldenburg, Germany"
puts $matlab_out "%     phone +49-441-7983067 "
puts $matlab_out "%     email kohlmeier@icbm.de"
puts $matlab_out "%"
puts $matlab_out "clear all"
puts $matlab_out "close all"
puts $matlab_out "clc"
puts $matlab_out "set(0,'DefaulttextInterpreter','none') % for underscore in filenames"

puts $matlab_out "f1= figure(\'Name\',\'MoViE\', \'Position\', \[100,200,1000,800\],\'color\',\'white\');"
puts $matlab_out "figure(f1)"
puts $matlab_out "leg=\[\];"

}
#############################

proc matlab_open_graph { graph starttime endtime wymin wymax ytitle type {flip 0}} {
global g_c gc matlab_out
global toolflag
global worldxmin worldxmax 
global subplot_num_rows subplot_num_columns g_c
global matlab_header

set g_c [expr $graph + 1]

set subplot_num_graphs [expr $gc + 1]

switch $subplot_num_graphs {
1 {
    set subplot_num_rows 1
    set subplot_num_columns 1
}
2 {
    set subplot_num_rows 2
    set subplot_num_columns 1
}
3 {
    set subplot_num_rows 3
    set subplot_num_columns 1
}
4 {
    set subplot_num_rows 2
    set subplot_num_columns 2
}
5 {
    set subplot_num_rows 2
    set subplot_num_columns 3
}
6 {
    set subplot_num_rows 2
    set subplot_num_columns 3
}
7 {
    set subplot_num_rows 3
    set subplot_num_columns 3
}
8 {
    set subplot_num_rows 3
    set subplot_num_columns 3
}
9 {
    set subplot_num_rows 3
    set subplot_num_columns 3
}

}
set matlab_header $ytitle
set worldxmin $starttime
set worldxmax $endtime

}
#############################

proc matlab_set_num {graph setnum data set_title outdelt {timedata xxx}} {
global matlab_out matlab_color gmfile command
global worldxmin worldxmax
global subplot_num_rows subplot_num_columns g_c gc_rem matlab_legend

#Daten eines sets in ein File schreiben
set id [open $gmfile\_$graph\_$setnum.dat w]  

set t 0
set systemTime [clock seconds]
puts $matlab_out "% Automatically generated by MoViE  [clock format $systemTime -format %D] [clock format $systemTime -format %H:%M:%S]"
puts $id "$set_title"
puts $id "time $command($setnum)"
  
foreach item $data {
if {$timedata == "xxx"} {
  set time [expr $t*$outdelt+$worldxmin]
} else {
   #timedata !=xxx in phase tool for 2D plot
   #Daten eines sets in ein File schreiben
   # in diesem Fall reduziert sich die Zahl der sets
  set time [lindex $timedata $t]
}

  puts $id "$time $item"
  incr t
}
close $id

#Eintrag in das m-Skript
if {$set_title != {} } {
   if {$gc_rem != $g_c} {
     # puts $matlab_out "legend( leg,\'location\',\'Best\')"
      puts $matlab_out "leg = \'$set_title\';"
      set gc_rem $g_c
     puts $matlab_out "% Ende graph $g_c"
     puts $matlab_out "" 
   } else {
      puts $matlab_out "leg = strvcat(leg,\'$set_title\');"
   }
} 
 
  # Matlab indiziert erst ab 1
  set mgraph [expr $graph+1]
  set msetnum [expr $setnum+1]
  puts $matlab_out "clear val;"
  puts $matlab_out "dateiname=\"[file tail $gmfile]\_$graph\_$setnum.dat\";"
  puts $matlab_out "val=importdata(dateiname,' ',3);"
  puts $matlab_out "acttime=val.data(1:end,1);"
  puts $matlab_out "actdata=val.data(1:end,2);"
  puts $matlab_out "time{$mgraph,$msetnum}=acttime;"
  puts $matlab_out "value{$mgraph,$msetnum}=actdata; "
 
 
# if {$timedata == "xxx"} {
# 
#   puts $matlab_out "T = $worldxmin:$outdelt: $worldxmax;"
# } else {
#   set time $timedata $t
#    puts $matlab_out "T = $timedata;"
# }

# puts $matlab_out "D = \[$data\];"

puts $matlab_out "subplot($subplot_num_rows,$subplot_num_columns,$g_c)"
puts $matlab_out "plot(time{$mgraph,$msetnum},value{$mgraph,$msetnum})"
puts $matlab_out "hold all"

puts $matlab_out "% Ende set [expr $setnum +1]"
puts $matlab_out ""
}
#############################

proc matlab_add_bar {bar value title} {
global matlab_bar_names matlab_bar_values


if {$bar==0} {
      set matlab_bar_values $value
      set matlab_bar_names \'$title\'
} else {
      lappend matlab_bar_values $value
      lappend matlab_bar_names \'$title\'
}
}
#############################

proc matlab_plot_bars {} {
global matlab_out matlab_bar_names matlab_bar_values matlab_header
global subplot_num_rows subplot_num_columns g_c 

puts $matlab_out "values=\[$matlab_bar_values\];"
puts $matlab_out "names=\{$matlab_bar_names\};"

puts $matlab_out "subplot($subplot_num_rows,$subplot_num_columns,$g_c)"
puts $matlab_out "bar(values)"
puts $matlab_out "set(gca,'XTickLabel', names)"
puts $matlab_out "title( \'$matlab_header\');"

}

proc matlab_open_multibar_header {graph setnum set_title} {
global matlab_out

puts $matlab_out "@s$setnum legend \"$set_title\""
puts $matlab_out "@s$setnum line pattern 0"
puts $matlab_out "@s$setnum symbol fill pattern 4"
puts $matlab_out "@target G$graph.S$setnum"
puts $matlab_out "@type bar"
}

proc matlab_close_multibar_header {} {
global matlab_out

puts $matlab_out "&"
}
#############################

proc matlab_init_valu { graph setnum set_title color time val_dat {ytop 0} {ybot 0}} {
global matlab_out matlab_header command
global gmfile
global subplot_num_rows subplot_num_columns g_c

#Daten eines sets in ein File schreiben
set id [open $gmfile\_$graph\_$setnum.dat w] 
set systemTime [clock seconds]
puts $id "% Automatically generated by MoViE  [clock format $systemTime -format %D] [clock format $systemTime -format %H:%M:%S]"
puts $id "$set_title"
puts $id "time $command($setnum)"

set errorbar 0
for {set k 0} {$k<[llength $time]} {incr k} {
    set line ""
    lappend line [lindex $time $k] [lindex $val_dat $k]
    
    if {[lindex $ytop $k]!=0 && [lindex  $ybot $k]!=0 
        && [lindex $ytop $k]!="" && [lindex $ybot $k]!=""} {
       lappend line [lindex $ytop $k]  [lindex  $ybot $k] [lindex $ytop $k] [lindex $ybot $k]
       set errorbar 1
        }
  puts $id $line
}
close $id

# Matlab indiziert erst ab 1
set mgraph [expr $graph+1]
set msetnum [expr $setnum+1]
puts $matlab_out "clear val;"
puts $matlab_out "dateiname=\"[file tail $gmfile]\_$graph\_$setnum.dat\";"
puts $matlab_out "val=importdata(dateiname,' ',3);"
puts $matlab_out "acttime=val.data(1:end,1);"
puts $matlab_out "actdata=val.data(1:end,2);"
puts $matlab_out "time{$mgraph,$msetnum}=acttime;"
puts $matlab_out "value{$mgraph,$msetnum}=actdata; "
puts $matlab_out "leg = strvcat(leg,\'$set_title\');"
puts $matlab_out "subplot($subplot_num_rows,$subplot_num_columns,$g_c)"

if {$errorbar==1} {
     
      puts $matlab_out "actDU=val.data(1:end,3);"
      puts $matlab_out "actDL=val.data(1:end,4);"
      puts $matlab_out "DU{$mgraph,$msetnum}=actDU;"
      puts $matlab_out "DL{$mgraph,$msetnum}=actDL; "
      puts $matlab_out "errorbar(time{$mgraph,$msetnum},value{$mgraph,$msetnum},...
      DL{$mgraph,$msetnum}-value{$mgraph,$msetnum},value{$mgraph,$msetnum}-DU{$mgraph,$msetnum},...
      \'Marker\',\'*\',\'LineStyle\',\'none\')"
} else {
      puts $matlab_out "plot(time{$mgraph,$msetnum},value{$mgraph,$msetnum})"
}
puts $matlab_out "title( \'$matlab_header\')"
puts $matlab_out "hold all"
puts $matlab_out "% Ende set [expr $setnum +1]"
puts $matlab_out ""
}
#############################

proc matlab_close_graph {{setnum 0}} {
global matlab_out matlab_legend matlab_header
global toolflag 

if {$toolflag=="compare"} {
    puts $matlab_out "ll=legend( leg,\'location\',\'Best\');"
    puts $matlab_out "tt=title( \'$matlab_header\');"        
    puts $matlab_out "set(ll,'Interpreter','none');"
    puts $matlab_out "set(tt,'Interpreter','none');"
    
}

if {$toolflag=="overview"} {
    if {$setnum==1} {
        puts $matlab_out "tt=title(leg)"
        puts $matlab_out "set(tt,'Interpreter','none');"
} else {
        puts $matlab_out "ll=legend( leg,\'location\',\'NorthWest\')"
        puts $matlab_out "set(ll,'Interpreter','none');"
}
}


}
#############################

proc matlab_closef {mfile} {
global matlab_out matlab_flag matlab_legend matlab_header

set pdffile [file tail [file rootname $mfile]].pdf
#puts $matlab_out "set(gcf,\'PaperOrientation\',\'landscape\')"
puts $matlab_out "%set PaperSize so that the complete grahics can be saved as PDF"
puts $matlab_out "set(gcf,\'PaperUnits\',\'centimeters\')"
puts $matlab_out "set(gcf,\'PaperSize\',\[36 36\])"
puts $matlab_out "%saveas (gcf,\'$pdffile\')"
close $matlab_out
}

##############################
#############################
############################

