# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc var_selector {} {
global DOS
global can
global varlist boxlist nicevarlist
global comvarlist comboxlist
global varrem boxrem
global boxwin varwin
global newset newgraph
global toolflag
global filename
global casesensitive
global boxFont
global varbut boxbut var_butwid_extra box_butwid_extra
global buttoncolor
global moviehome
global onewindow bs vs mf

#set max_frameheight [expr [winfo height .mf.left] - [winfo height .mf.right.msg]]
if {[info exist vs] && [winfo exist $vs]} {
	set kids [winfo children $vs]
    foreach kid $kids { destroy $kid }
}

set col 5

if {$onewindow==0} {
	if {[info exist vs] && [winfo exist $vs]} {destroy $vs}
	set vs .vs
	toplevel $vs
	wm title $vs {Variable Selector}
	wm geometry $vs "+[expr $can+450]+350"
	wm group $vs .
	wm transient $vs .
	wm protocol $vs WM_DELETE_WINDOW exit
	set max_frameheight [expr [winfo screenheight .]/2] 
	set max_framewidth [expr [winfo screenwidth .]/2] 
	
	set l [llength $comvarlist]
	if {$l > 10} {set col 5}
	if {$l > 125} {set col 8}
	if {$l > 240} {set col 10}
} else {
#	set max_frameheight [expr $can + [winfo height $bs] - [winfo height .mf.right.msg]]
	set max_frameheight [expr $can + [winfo height $bs]]
	set max_framewidth [expr [winfo width $mf.right] -200]
}
set count 0
set framecount 0
set butwid 1
foreach item $comvarlist {set butwid [max $butwid  [string length $item]]}
set butwid [expr $butwid + $var_butwid_extra]

set varbut ""

set butheight 1

scrolledframe $vs.vsm -xscroll [list $vs.hsb set] -yscroll [list $vs.vsb set] 
scrollbar $vs.vsb -command [list $vs.vsm yview]
scrollbar $vs.hsb -command [list $vs.vsm xview] -orient horizontal

grid $vs.vsm -row 0 -column 0 -sticky nw
grid $vs.vsm.scrolled -row 0 -column 0 -sticky nw
grid $vs.vsb -row 0 -column 1 -sticky ns
grid $vs.hsb -row 1 -column 0 -sticky ew

#grid rowconfigure $vs 0 -weight 1
#grid columnconfigure $vs 0 -weight 1

set col1 black
set col2 darkred

foreach var $comvarlist {
	set butid [string tolower $var]
	set offset [expr fmod($count,$col) ]
	set count [expr $count+1]

  if {$offset ==0} {
      set framecount [expr $framecount+1]
      frame $vs.vsm.scrolled.$framecount
#      pack $vs.vsm.scrolled.$framecount -anchor nw -side left -side top -fill x
      grid $vs.vsm.scrolled.$framecount -column 0 -row $framecount -sticky news
     }

set textcol black
if  [info exist buttoncolor($butid)] {
    if  {$buttoncolor($butid) !=""} {
      set textcol $buttoncolor($butid)
    }
}

   button $vs.vsm.scrolled.$framecount.$butid -text $var \
          -font $boxFont -fg $textcol \
          -command "makecommand $var -1;disablestart"

   pack $vs.vsm.scrolled.$framecount.$butid -side left -fill x
   lappend varbut $vs.vsm.scrolled.$framecount.$butid

   if {$toolflag == "overview" || $toolflag == "phase" || $toolflag == "profile"} {
      bind $vs.vsm.scrolled.$framecount.$butid <2> {tkButton2Down %W}
      bind $vs.vsm.scrolled.$framecount.$butid <ButtonRelease-2> \
              "set newset 1;makecommand $var -1;tkButton2Up %W"
###################### Baustelle ########################
#      bind $vs.vsm.scrolled.$framecount.$butid <ButtonPress-4> {$vs.vsb set %d}
#      bind $vs.vsm.scrolled.$framecount.$butid <ButtonPress-5> {$vs.vsb set %d}
   }

   if {$toolflag != "film" && $toolflag != "contour" && $toolflag != "phase"} {
     bind $vs.vsm.scrolled.$framecount.$butid <3> {tkButton3Down %W}
     bind $vs.vsm.scrolled.$framecount.$butid <ButtonRelease-3> \
              "set newgraph 1;makecommand $var -1;tkButton3Up %W"
   }
  
}

#set ll [winfo children $vs.vsm.scrolled]
#if [info exists varwin] {unset varwin}

#foreach l $ll { append varwin [winfo children $l] " "}
#if {[llength $varwin]==0} {textinfo "No common variables" 1}

foreach but $varbut {$but config -width $butwid -padx 1}

set req_frameheight [expr $framecount*[winfo reqheight [lindex $varbut 0]]]
set req_framewidth [expr $col*[winfo reqwidth [lindex $varbut 0]]]
set frameheight [min $req_frameheight $max_frameheight]
set framewidth [min $req_framewidth $max_framewidth]

#puts "max_frameheight:$max_frameheight req_frameheight:$req_frameheight frameheight:$frameheight"
#puts "max_framewidth:$max_framewidth req_framewidth:$req_framewidth framewidth:$framewidth"
if {$req_frameheight<$max_frameheight} {
	grid forget $vs.vsb
}
if {$req_framewidth<$max_framewidth} {
	grid forget $vs.hsb
}
$vs.vsm config -width $framewidth -height $frameheight
$vs.vsm.scrolled config -width $framewidth -height $frameheight
set varwin $varbut
}

