# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc make_gnucmd_phase {counter {dummy 0}} {
global pwd canvas can command xangle zangle gprunning DOS moviehome
global gnu_flag gmfile gnu_out
global seq seq_min seq_max env mf
if [info exist gprunning] {
   set gprunning 0
   Stopgnuplot
}
set id [open $pwd/plots/gnucmd_phase w]

if {$DOS == 1} {
  puts $id "set terminal gif"
  puts $id "set output \"plots/gnuplot.gif\" "
} else {
  puts $id "set terminal tkcanvas"
}
set varx [lindex $command($counter) 0]
set vary [lindex $command($counter) 1]
set varz [lindex $command($counter) 2]

puts $id "set view $xangle,$zangle,1,1"
#puts $id "set size $can,$can"
puts $id "set border 4095"
puts $id "set nokey"
puts $id "set grid"
puts $id "set title \"$command($counter)\" "
puts $id "set xlabel \"$varx\" "
puts $id "set ylabel \"$vary\" "
puts $id "set zlabel \"$varz\" "
if {$seq==1} {
   puts $id "set xrange \[$seq_min($varx):$seq_max($varx)\]"
   puts $id "set yrange \[$seq_min($vary):$seq_max($vary)\]"
   puts $id "set zrange \[$seq_min($varz):$seq_max($varz)\]"
}
puts $id "splot \"plots/gnutemp_phase.dat\" with lines "

close $id

if {$DOS == 1} {
	set gnup $env(GNUPLOT)
	eval exec "$gnup plots/gnucmd_phase"
	set item [image create photo 3DPlot -file $pwd/gnuplot.gif]
	set item [$mf.left.plot  create image 0 0  -image 3DPlot -anchor nw]
	$canvas addtag gif withtag $item
} else {
	eval exec "gnuplot  plots/gnucmd_phase > plots/gnuplot_phase.tcl"
	source $pwd/plots/gnuplot_phase.tcl
	gnuplot $mf.left.plot  
	file delete  $pwd/plots/gnuplot_phase.tcl
}

# Printout abarbeiten, ist aber ja schon gnuplot
if {$gnu_flag==1} {
      # Daten

      set source "$pwd/plots/gnutemp_phase.dat"
      set target $gmfile.dat
      file copy -force $source $target
      #Batch-Datei
      puts $gnu_out "set view $xangle,$zangle,1,1"
      puts $gnu_out "set nokey"
      puts $gnu_out "set title \"$command($counter)\" "
      puts $gnu_out "set xlabel \"$varx\" "
      puts $gnu_out "set ylabel \"$vary\" "
      puts $gnu_out "set zlabel \"$varz\" "
      if {$seq==1} {
		 puts $gnu_out "set xrange \[$seq_min($varx):$seq_max($varx)\]"
		 puts $gnu_out "set yrange \[$seq_min($vary):$seq_max($vary)\]"
		 puts $gnu_out "set zrange \[$seq_min($varz):$seq_max($varz)\]"
      }
      puts $gnu_out "splot \"$target\" with lines "
      if [winfo exists .as] {raise .as}
}

}

