# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc makezerocsv {in out} {
global symb_cycle symb_outdelt symb_year symb_start symb_end
set  id [open $in r]
set i 1

set kmax 0
set varlist ""
set boxlist ""
while {[gets $id line] >=0} {

  if [string match *val* $line] {

  regsub -all , $line " " temp
  regsub -all : $temp " " temp
  regsub -all /val/ $temp "" temp
  set varbox [split [lindex $temp 0] ()]
  lappend varlist [lindex $varbox 0]
  lappend boxlist [lindex $varbox 1]

}

}
close $id

set vars [lsort -ascii -unique $varlist]
set boxes [lsort -integer -unique $boxlist]
set numvars [expr [llength $vars]*[llength $boxes]]

set wid [open $out w]
puts $wid "Stores Variables:$numvars"
puts $wid "Start Time:$symb_start"
puts $wid "End Time:$symb_end"
puts $wid "Outdelt:$symb_outdelt"
puts $wid "Year:$symb_year"
puts $wid "Cycle:$symb_cycle"

set header "time,"
set values ""
foreach var $vars {
     foreach box $boxes {
        lappend header $var\($box\),
        lappend values 0.0,
     }
}

set header [string trimright $header ,]
puts $wid $header

set values [string trimright $values ,]

for {set k $symb_start} {$k <= [expr $symb_end+0.99*$symb_outdelt]} {set k [expr $k+$symb_outdelt]} {
    puts $wid "$k,$values"
}
  
close $wid



}

