# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

#########################################
# Main Prepare procedure called from mov
#########################################
proc preparetool {} {
global moviehome iconpath pwd
global toolflag
global datadir data
global defaultresult2 defaultresult3
global buttonFont

if [winfo exist .prepare] {destroy .prepare}
toplevel .prepare

global can
global filename
global allbuts

wm title .prepare {Tiger Graphics Prepare Tool}
#wm geometry .prepare "[expr $can+400]x$can+0+0"
wm geometry .prepare +300+150
wm attributes .prepare -topmost yes
#wm protocol .prepare WM_DELETE_WINDOW exit


frame .prepare.right
pack .prepare.right -side top -fill x

# Initializing of the drawing area
#---------------------------------
#canvas .prepare.plot -bg white -width $can -height $can
#pack .prepare.plot -side left

# Initializing of the info window
#---------------------------------
#ScrolledListbox .prepare.right.msg
#pack .prepare.right.msg -side top -fill x
execlog

# Initializing of the buttons
#----------------------------
set rowcounter 0
frame .prepare.right.but
grid .prepare.right.but -row $rowcounter -column 1 -sticky news
incr rowcounter
 
checkbutton  .prepare.right.but.bg  -font $buttonFont -text {Start in Background} -variable pbg
pack  .prepare.right.but.bg -side right -padx 5
set allbuts .prepare.right.but.bg

#CSVRESULT
#---------

labelframe .prepare.right.csv -text "Textformat-Tranformations"
grid .prepare.right.csv -row $rowcounter -column 1 -sticky news
incr rowcounter

button  .prepare.right.csv.rc  -font $buttonFont -text {Result (.outc) -> Textformat (.outa)} -command {result2outa}
pack  .prepare.right.csv.rc -side left -padx 5

button  .prepare.right.csv.cr  -font $buttonFont -text {Text (.outa) -> Result (.outc)} -command {csv2result}
pack  .prepare.right.csv.cr -side left -padx 5
lappend allbuts .prepare.right.csv.rc .prepare.right.csv.cr



#CSVDATA
#---------

labelframe .prepare.right.csvd -text "Transformation to and from MoViE-CSV"
grid .prepare.right.csvd -row $rowcounter -column 1 -sticky news
incr rowcounter

button  .prepare.right.csvd.dc  -font $buttonFont -text {Data (.symb) -> "MoViE-CSV" (.mcsv)} -command {symb2mcsv}
pack  .prepare.right.csvd.dc -side left -padx 5

button  .prepare.right.csvd.cd  -font $buttonFont -text {"MoViE-CSV" (.mcsv) -> Data (.symb)} -command {mcsv2symb}
pack  .prepare.right.csvd.cd -side left  -padx 5
lappend allbuts .prepare.right.csvd.dc .prepare.right.csvd.cd

labelframe .prepare.right.symb2 -text "Transformation from and to Validation data files (.symb)"
grid .prepare.right.symb2 -row $rowcounter -column 1 -sticky news
incr rowcounter

#RESULT2SYMB
#----------
button  .prepare.right.symb2.cd2  -font $buttonFont -text {Result (.outc) -> Data (.symb) } -command {result2symb}
pack  .prepare.right.symb2.cd2 -side left -padx 5
lappend allbuts .prepare.right.symb2.cd2 
#SYMB2ZERO
#---------
button  .prepare.right.symb2.dz  -font $buttonFont -text {Data (.symb) -> Zero (.outc) } -command {symb2zero}
pack  .prepare.right.symb2.dz -side left -padx 5
lappend allbuts .prepare.right.symb2.dz 

#SYMB2RESULT
#---------
button  .prepare.right.symb2.dc  -font $buttonFont -text {Data (.symb) -> Result (.outc)} -command {symb2result}
pack  .prepare.right.symb2.dc -side left -padx 5
lappend allbuts .prepare.right.symb2.dc 

#FOURIER
#-------
labelframe .prepare.right.fourier -text "Fourier Transformations"
grid .prepare.right.fourier -row $rowcounter -column 1 -sticky news
incr rowcounter

button  .prepare.right.fourier.rf  -font $buttonFont -text {Result  (.outc) -> Fourier (_pk.outc) } -command {result2fourier}
pack .prepare.right.fourier.rf -side left  -padx 5

button  .prepare.right.fourier.df  -font $buttonFont -text {Data (.symb) -> Fourier (_dpk.outc) } -command {symb2fourier}
pack  .prepare.right.fourier.df -side left -padx 5
lappend allbuts .prepare.right.fourier.rf .prepare.right.fourier.df


#DIFFERENCE
#----------
labelframe .prepare.right.diff -text "Compute result file difference with different distance functions"
grid .prepare.right.diff -row $rowcounter -column 1 -sticky news
incr rowcounter

global difftype
menubutton .prepare.right.diff.mm  -font $buttonFont -text "Difference Type" -menu .prepare.right.diff.mm.menu
pack .prepare.right.diff.mm -side left -padx 5
set m [menu .prepare.right.diff.mm.menu -tearoff 0]

set labels {"result1-result2"  "abs(result1-result2)"  "{least square}" "abs(result1-result2)/(abs(result1)+abs(result2))" "100\*(result2-result1)/result1"}
set i 0
foreach lab $labels {
$m add radio -label $lab -command "set difftype $i;.prepare.right.diff.mm config -text $lab"
incr i
}

$m invoke 0

button  .prepare.right.diff.ff  -font $buttonFont -text {First File} -command {makediff 1 $difftype}
pack  .prepare.right.diff.ff -side left -padx 5

button  .prepare.right.diff.sf  -font $buttonFont -text {Second File} -command {makediff 2 $difftype}
pack  .prepare.right.diff.sf -side left  -padx 5

.prepare.right.diff.sf configure -state disabled

lappend allbuts .prepare.right.diff.mm .prepare.right.diff.ff .prepare.right.diff.sf

update
update idletasks

frame .prepare.right.main
grid .prepare.right.main -row $rowcounter -column 1 -sticky news
incr rowcounter


button  .prepare.right.main.exit  -font $buttonFont -text {Exit} -command {
if [info exist data] {unset data}
destroy .prepare
}
pack  .prepare.right.main.exit -side right -padx 5

.prepare.right.but.bg invoke
after 10
.prepare.right.but.bg invoke
macraise
}

