# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc symb2result {} {
global pwd prep_command log moviehome

global symbr_cycle symbr_outdelt symbr_starttime symbr_endtime symbr_offset symbr_fill
global symbfile

if ![info exist symbr_cycle] {set symbr_cycle 365.0}
if ![info exist symbr_outdelt] {set symbr_outdelt 0.1}
if ![info exist symbr_starttime] {set symbr_starttime 0.0}
if ![info exist symbr_endtime] {set symbr_endtime 365.0}
if ![info exist symbr_offset] {set symbr_offset 0.0}
if ![info exist symbr_fill] {set symbr_fill -9999.0}

$log delete 1.0 end
$log insert end   "Fillvalue=-9999.0 is ignored by CeVoS\n\n"

wm attributes .prepare -topmost no
set symbfile [fileselect  "Select data file" symb $pwd open]
if {$symbfile==""} {
wm attributes .prepare -topmost yes
return
}

toplevel .symb

wm title .symb {symb_to_result Parameters}
wm geometry .symb "+350+500"
wm attributes .symb -topmost yes

frame .symb.main
pack .symb.main

frame .symb.main.3
pack .symb.main.3
label .symb.main.3.start -text "Starttime" -width 20
pack .symb.main.3.start -side left -pady {0 5} -padx 10
entry .symb.main.3.symb_start -width 12 -textvariable symbr_starttime
pack .symb.main.3.symb_start -side left -pady {0 5} -padx 10
.symb.main.3.symb_start icursor end
bind .symb.main.3.symb_start <Return> "focus .symb.main.4.symb_end"

frame .symb.main.4
pack .symb.main.4
label .symb.main.4.end -text "Endtime" -width 20
pack .symb.main.4.end -side left -pady {0 5} -padx 10
entry .symb.main.4.symb_end -width 12 -textvariable symbr_endtime
.symb.main.4.symb_end icursor end
pack .symb.main.4.symb_end -side left -pady {0 5} -padx 10
bind .symb.main.4.symb_end <Return> "focus .symb.main.2.symb_outdelt"

frame .symb.main.2
pack .symb.main.2
label .symb.main.2.outdelt -text "Outdelt" -width 20
pack .symb.main.2.outdelt -side left -pady {0 5} -padx 10
entry .symb.main.2.symb_outdelt -width 12 -textvariable symbr_outdelt
pack .symb.main.2.symb_outdelt -side left -pady {0 5} -padx 10
.symb.main.2.symb_outdelt icursor end
bind .symb.main.2.symb_outdelt <Return> "focus .symb.main.1.symb_cycle"

frame .symb.main.1
pack .symb.main.1
label .symb.main.1.cycle -text "Cycle" -width 20
pack .symb.main.1.cycle -side left -pady {0 5} -padx 10
entry .symb.main.1.symb_cycle -width 12 -textvariable symbr_cycle
pack .symb.main.1.symb_cycle -side left -pady {0 5} -padx 10
.symb.main.1.symb_cycle icursor end
bind .symb.main.1.symb_cycle <Return> "focus .symb.main.5.symb_offset"

frame .symb.main.5
pack .symb.main.5
label .symb.main.5.offset -text "Offset" -width 20
pack .symb.main.5.offset -side left -pady {0 5} -padx 10
entry .symb.main.5.symb_offset -width 12 -textvariable symbr_offset
pack .symb.main.5.symb_offset -side left -pady {0 5} -padx 10
.symb.main.5.symb_offset icursor end
bind .symb.main.5.symb_offset <Return> "focus .symb.main.6.symb_fill"

frame .symb.main.6
pack .symb.main.6
label .symb.main.6.fill -text "Fill value" -width 20
pack .symb.main.6.fill -side left -pady {0 5} -padx 10
entry .symb.main.6.symb_fill -width 12 -textvariable symbr_fill
pack .symb.main.6.symb_fill -side left -pady {0 5} -padx 10
.symb.main.6.symb_fill icursor end
bind .symb.main.6.symb_fill <Return> "focus .symb.but.ok"
focus .symb.main.3.symb_start


frame .symb.but
pack .symb.but

button .symb.but.cancel -text {Cancel}\
       -command { destroy .symb
				  wm attributes .prepare -topmost yes
                }
pack .symb.but.cancel -side left -pady {0 5}

button .symb.but.ok -text {OK}\
       -command {
#$log delete 1.0 end
						   wm attributes .prepare -topmost yes
                           $log insert end "Converting $symbfile "
#                           set ext [file extension $symbfile]
#                           regsub $ext $symbfile "" file
                           set file [file rootname $symbfile]
                           $log insert end "to $file\_symb.outc \n"
                           set prep_command "$moviehome/../cprog/symb2result $file $symbr_starttime $symbr_endtime $symbr_cycle $symbr_outdelt $symbr_offset $symbr_fill"
                           Run
                           $log insert end "Ready\n"
                           destroy .symb
                }
pack .symb.but.ok -side left -pady {0 5}

}


