# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc symb2zero {} {

global pwd prep_command log moviehome datadir tempdir
global symb_cycle symb_outdelt symb_year symb_start symb_end
global symb_file

set symb_cycle 365
set symb_outdelt 1
set symb_year 2006
set symb_start 0
set symb_end 365

wm attributes .prepare -topmost no
set symb_file [fileselect  "Select data file" symb $datadir open]
if {$symb_file==""} {
wm attributes .prepare -topmost yes
return
}
$log delete 1.0 end
$log insert end   "Creating result file (_zero.outc) with zero values for looking only to data (.symb) \n\n"

toplevel .symb

wm title .symb {outc file settings}
wm geometry .symb "+350+500"
wm attributes .symb -topmost yes

#.ovc.right.misc.ana configure -state disabled

frame .symb.main
pack .symb.main

#bind .symb.times.fac <Return> "facLoad $faclabel \$factor"
#focus .symb.times.fac
frame .symb.main.1
pack .symb.main.1
label .symb.main.1.start -text "Start" -width 20
pack .symb.main.1.start -side left -pady {0 5} -padx 10
entry .symb.main.1.symb_start -width 12 -textvariable symb_start
pack .symb.main.1.symb_start -side left -pady {0 5} -padx 10
.symb.main.1.symb_start icursor end
bind .symb.main.1.symb_start <Return> "focus .symb.main.2.symb_end"
focus .symb.main.1.symb_start

frame .symb.main.2
pack .symb.main.2
label .symb.main.2.end -text "End" -width 20
pack .symb.main.2.end -side left -pady {0 5} -padx 10
entry .symb.main.2.symb_end -width 12 -textvariable symb_end
pack .symb.main.2.symb_end -side left -pady {0 5} -padx 10
.symb.main.2.symb_end icursor end
bind .symb.main.2.symb_end <Return> "focus .symb.main.3.symb_outdelt"
focus .symb.main.2.symb_end

frame .symb.main.3
pack .symb.main.3
label .symb.main.3.outdelt -text "Outdelt" -width 20
pack .symb.main.3.outdelt -side left -pady {0 5} -padx 10
entry .symb.main.3.symb_outdelt -width 12 -textvariable symb_outdelt
pack .symb.main.3.symb_outdelt -side left -pady {0 5} -padx 10
.symb.main.3.symb_outdelt icursor end
bind .symb.main.3.symb_outdelt <Return> "focus .symb.main.4.symb_cycle"

frame .symb.main.4
pack .symb.main.4
label .symb.main.4.cycle -text "Cycle" -width 20
pack .symb.main.4.cycle -side left -pady {0 5} -padx 10
entry .symb.main.4.symb_cycle -width 12 -textvariable symb_cycle
pack .symb.main.4.symb_cycle -side left -pady {0 5} -padx 10
.symb.main.4.symb_cycle icursor end
bind .symb.main.4.symb_cycle <Return> "focus .symb.main.5.symb_year"
focus .symb.main.4.symb_cycle

frame .symb.main.5
pack .symb.main.5
label .symb.main.5.year -text "Year" -width 20
pack .symb.main.5.year -side left -pady {0 5} -padx 10
entry .symb.main.5.symb_year -width 12 -textvariable symb_year
pack .symb.main.5.symb_year -side left -pady {0 5} -padx 10
.symb.main.5.symb_year icursor end
bind .symb.main.5.symb_year <Return> "focus .symb.main.1.start"


frame .symb.but
pack .symb.but

button .symb.but.cancel -text {Cancel}\
       -command { destroy .symb
				  wm attributes .prepare -topmost yes
#                 .ovc.right.misc.ana configure -state normal
                }
pack .symb.but.cancel -side left -pady {0 5}

button .symb.but.ok -text {OK}\
       -command { $log delete 1.0 end
                  $log insert end "Converting $symb_file "

                  set file [file rootname $symb_file]
                  set tempfile "$tempdir/[file rootname [file tail $symb_file]_zero.outa]"
                  $log insert end "to $file\_zero.outc \n"

                  makezerocsv $symb_file $tempfile

                 set prep_command "$moviehome/../cprog/outa2result $tempfile $file\_zero"
				 wm attributes .prepare -topmost yes
                 Run
		         destroy .symb
#                 .ovc.right.misc.ana configure -state normal
                }
pack .symb.but.ok -side left -pady {0 5}

}
