# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc prep_profvalu {a j} {

global profvalu
global command
global startbox lastbox boxwindow boxlist
global valtime valdata
global valtid
global valinb valint
global valint valper valdep
global ymin ymax
global profile_valu_flag evallayer valushow

# a: file   j: graph  i:box

# Profile Value Flag wird gesetzt, wenn es Profile Daten mit Tiefeninformation sind
# In diesem Fall wird die Box-Struktur bersteuert
# Auswertung in profile_valu_plot
set profile_valu_flag($a,$j) 0

set lastbox [expr $startbox + $boxwindow]
set item [string tolower [lindex $command($j) 0]]

for {set i [lindex $boxlist(1) 0]} {$i<=[lindex $boxlist(1) end]} {incr i} {

   regsub -all {[(][0-9]+[)]} $item "($i)" commando

   readvalu $a $j $commando

   if [info exists valtime($a,$j)] {
      set valtime($a,$j,$i) $valtime($a,$j)
   } else {
      if [info exist valtime($a,$j,$i)] {unset valtime($a,$j,$i)}
   }

   if [info exists valdata($a,$j)] {
      set valdata($a,$j,$i) $valdata($a,$j)
      set ymax($j) [max $ymax($j) [lmax $valdata($a,$j)]]
      set ymin($j) [min $ymin($j) [lmin $valdata($a,$j)]]
   } else {
      if [info exist valdata($a,$j,$i)] {unset valdata($a,$j,$i)}
   }

   if [info exists valdep($a,$j)] {
      set valdep($a,$j,$i) $valdep($a,$j)
      set profile_valu_flag($a,$j) 1
      if {$evallayer==0 && $valushow($a)==1} {set evallayer 1;interpret}

   } else {
     if [info exist valdep($a,$j,$i)] {unset valdep($a,$j,$i)}

   }
   
   #if [info exists valint($a,$j)] {set valint($a,$j,$i) $valint($a,$j)}
   #if [info exists valstd($a,$j)] {set valstd($a,$j,$i) $valstd($a,$j)}
   #if [info exists valper($a,$j)] {set valper($a,$j,$j) $valper($a,$j)}
}

}

