# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc profile_valuplot {a j setnum color} {

global graph gl mf

global symbolFont symbollist
global barchart
global valtime valdata valdep
global startbox lastbox
global xmin xmax ymin ymax
global layer flipxy exact time
global datawin
global comboxlist tiefe

set c $mf.left.plot  

set graph [lindex $gl $j]

set barchart 0


# Suche nach dem Boxindex in dem Daten stehen
# Daten in einem File mssen gleiche Boxkennung haben !!!

set box 0
set verylastbox [llength $comboxlist]

for {set i 1} {$i<=$verylastbox} {incr i} {
 if [info exist valdep($a,$j,$i)] {set box $i}
}
# Anpassung der dep-Werte an die Layer-Struktur

if [info exists valtime($a,$j,$box)] {

       set len [llength $valtime($a,$j,$box)]
       

      for {set k 0} {$k<$len} {incr k} {
        set vtime [lindex $valtime($a,$j,$box) $k]

	if {$datawin !=""}  {
           set checktime $datawin
        } else {
           set checktime 0
        }

	if {[expr abs($vtime-$time)] <= $checktime || $exact==0} {
	   set dataflag 1
	} else {
	   set dataflag 0
        }

	if {$dataflag==1} {


	  set value [lindex $valdata($a,$j,$box) $k]
	  set depth [lindex $valdep($a,$j,$box) $k]
 
	  if {$depth <= $tiefe([min [expr $lastbox+1] $verylastbox]) && $value >= $ymin($j)} {

            if {$flipxy==0} {
               set x [nnx $depth]
               set y [nnyj $value $j]
            } else {
	       set x [nx $value $ymin($j) $ymax($j)]
               set y [ny [expr $xmax-$depth] $xmin $xmax]
	    }

# Value itself
            set symbol [lindex $symbollist $a]
            set item [eval {$c create text}  $x $y  -text $symbol -fill $color -font $symbolFont]
            $c addtag $graph withtag $item
	  }
	  
	}; #end if dataflag
      }; #End for k
}; #end if info exist

}


