# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc profvaluplot {j row setnum} {

global colorlist
global plotFont boldFont
global graph gl sc gc mf
global barchart
global filelist
global legendtext
global dataname datalist
global vertoff
global valtime valdata
global valinb
global valint
global valper
global fourier
global vint vinb vper
global xvgr_flag
global startbox lastbox
global xmin xmax ymin ymax
global layer layervalue tiefe  flipxy exact time
global sets
global datawin
global valushow
global profile_valu_flag
global symbollist symbolFont
set c $mf.left.plot  

set graph [lindex $gl $j]

set wid 4
set pint 4
set pinb 4

set symbolFont *helvetica-medium-r-normal-*-*18*
set colorindex [max 3 [lindex $filelist end]]
set symbollist "* * * o x a a a a a a a a a a a a"

foreach a $datalist {
 if {$valushow($a)==1} {
   
   set color [lindex $colorlist $colorindex]
   # Profile Daten mit Tiefeninformation
   
   if {$profile_valu_flag($a,$j)==1} {

      profile_valuplot $a $j $setnum $color
   
   } else {
   
   # Normale Daten fuer Box bzw Layer
     set xv_tim($a,$j) ""
     set xv_dat($a,$j) ""

     set pos $xmin
     set layer([expr $startbox-1]) 0
     for {set i $startbox} {$i<=$lastbox} {incr i} {

      if {$barchart==0} {
         set pos [expr $pos+$layer([expr $i-1])]
      } else {
         set pos [expr $pos+1]
      }

      if [info exists valtime($a,$j,$i)] {

        set len [llength $valtime($a,$j,$i)]
       

        for {set k 0} {$k<$len} {incr k} {
          set vtime [lindex $valtime($a,$j,$i) $k]

	  if {$datawin !=""}  {
             set checktime $datawin
          } else {
             set checktime 0
          }

	  if {[expr abs($vtime-$time)] <= $checktime} {
	     set dataflag 1
	  } else {
	     set dataflag 0
          }

	  if {$exact==0} {set dataflag 1}

	  if {$dataflag==1} {

	    set value [lindex $valdata($a,$j,$i) $k]

            if {$flipxy==0} {
               set x [nnx $pos]
	       if {$barchart==1} {set x [nnx [expr $pos-0.5]]}
               set y [nnyj $value $j] 

               if {$layervalue==1} {
                     lappend xv_tim($a,$j)   [string trim [format "%10.3g" $tiefe($i)]]
                } else {
                     lappend  xv_tim($a,$j) $i
                }
		      
	       lappend xv_dat($a,$j) $value

            } else {
	       set x [nx $value $ymin($j) $ymax($j)]
               if {$barchart==1} {set x [nx $value $ymin($j) $ymax($j)]}
               set y [ny [expr $xmax-$pos] $xmin $xmax]
               if {$barchart==1} {set y [ny [expr $xmax-$pos+$layer($i)+0.5] $xmin $xmax]}

	     
	       lappend xv_tim($a,$j) $value

               if {$layervalue==1} {
                     lappend xv_dat($a,$j)   [string trim [format "%10.3g" $tiefe($i)]]
                } else {
                     lappend  xv_dat($a,$j) $i
                }
		      
	    }

# Value itself
            set symbol [lindex $symbollist $a]
            set item [eval {$c create text}  $x $y  -text $symbol -fill $color -font $symbolFont]
            $c addtag $graph withtag $item
	  }
	}
      }
    }
  }

   # Plotting of legend
   #-------------------
   set row [expr $row+$vertoff]
   if {$j == 0} {

    set text [file rootname [file tail $dataname($a)]]
    set item [$c create text 450 $row -text $text -font $plotFont -fill $color -anchor w]
    $c addtag $color$graph withtag $item
    $c addtag legend$graph withtag $item
    $c addtag $graph withtag $item

    $c bind legend$graph <1> "complegendDown $c %x %y legend$graph;\
                           $c itemconfig legend$graph -font {$boldFont}"
    $c bind legend$graph <ButtonRelease-1> "complegendMove $c %x %y;\
                           $c dtag selected;\
                           $c itemconfig legend$graph -font {$plotFont}"
    set compleg(lastX) 0
    set compleg(lastY) 0
   }


   if {$xvgr_flag ==1} {


      if [info exist xv_tim($a,$j)] {

        if [info exist vint($a,$j)] {
          xv_init_valu $gc $setnum [file rootname [file tail $dataname($a)]] $colorindex \
                       $xv_tim($a,$j) $xv_dat($a,$j) $vint($a,$j) $vinb($a,$j)
        } else {
          xv_init_valu $gc $setnum [file rootname [file tail $dataname($a)]] $colorindex $xv_tim($a,$j) $xv_dat($a,$j)
        }
      }

   }
  incr setnum
  incr colorindex
  }
}
}


