# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc extract_profdata {{a 1}} {

global profdata
global timemin timemax
global command
global startbox boxwindow
global gc
global comvarlist
global meanflag sumflag stepmean stepsum logflag

set lastbox [expr $startbox + $boxwindow]
set timemin($gc)  inf
set timemax($gc) -inf

foreach item $command($gc) {
  for {set i $startbox} {$i<=$lastbox} {incr i} {
    regsub -all {[(][0-9]+[)]} $item "($i)" commando
     set profdata($item,$i,$a) [extract_one_set $a $commando]
     
    foreach number $profdata($item,$i,$a) {
      set timemin($gc) [min $timemin($gc) $number]
      set timemax($gc) [max $timemax($gc) $number]
    }
  }

# Aufbereitung für Mittelwerte
   if {$meanflag==1 || $stepmean==1 ||  $stepsum==1 || $sumflag==1 || $logflag==1} {

   set timemin($gc)  inf
   set timemax($gc) -inf

       for {set i $startbox} {$i <= $lastbox} {incr i} {
            # if {$meanflag ==1} { set profdata($item,$i,$a) [lmean $profdata($item,$i,$a) 1 mean]}
             if {$stepmean==1} {set profdata($item,$i,$a) [step_calc $profdata($item,$i,$a) 1 mean] }
             if {$stepsum ==1} {set profdata($item,$i,$a)  [step_calc $profdata($item,$i,$a) 1 sum] }
             if {$sumflag ==1 } {set profdata($item,$i,$a)  [lsum $profdata($item,$i,$a)] }
             if {$logflag ==1 } {set profdata($item,$i,$a) [llog $profdata($item,$i,$a)] }

            foreach number $profdata($item,$i,$a) {
               set timemin($gc) [min $timemin($gc) $number]
               set timemax($gc) [max $timemax($gc) $number]
            }
     }




  }
 


}; #End foreach  item


#extract_layer
set found 0
foreach var $comvarlist {
if {$found==0} {
   if {[string tolower $var ]=="layer"} {set found 1} else {set found 0}
}
}

for {set i $startbox} {$i<=$lastbox} {incr i} {
    if {$found==1} {
     set profdata(layer,$i,1) [extract_one_set 1 layer($i)]
    } else {
     set profdata(layer,$i,1) "" 
    }
}


}

