# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc paxes {j {c none}} {

global can mf
global outdelt timewin cycle
global actstart
global pxmin pxmax pymin pymax pxdelt pydelt
global xmin xmax ymin ymax xdelt ydelt
global colorlist colorindex
global plotFont boldFont
global command
global graph gl singleresult
global vertoff
global xvgr_flag
global smooth
global fixymax fixymin
global startbox boxwindow
global layer layersum barchart
global tiefe layervalue
global logflag

   if {$c=="none"} {set c $mf.left.plot} 

   # Plotting of x-axis
   #--------------------------
   set item [$c create line $pxmin $pymin $pxmax $pymin -width 1.5]
   $c addtag axis withtag $item
   $c addtag $graph withtag $item


   # Plotting of y-axis
   #--------------------------


   set item [$c create line $pxmin $pymin $pxmin $pymax -width 1.5]
   $c addtag axis withtag $item
   $c addtag $graph withtag $item


  # Plotting of y-axis labels
  #--------------------------

  for {set i 0} {$i <= 10} {incr i} {
    set ylabel [expr $ymin($j) + ($i*$ydelt/10) ]
    set ytext [string trim [format "%10.3g" $ylabel]]

if {$logflag==1} {set ytext [string trim [format "%10.3g" [expr pow(10,$ylabel)]]]}

    set yoff [nnyj $ylabel $j]

    set item [$c create line [expr $pxmin-5] $yoff $pxmin $yoff -width 2]
    $c addtag axis withtag $item
    $c addtag $graph withtag $item
    set item [$c create text [expr $pxmin-10] $yoff -text $ytext \
                   -anchor e -font     $plotFont]
    $c addtag axis withtag $item
    $c addtag $graph withtag $item
  }

  # Plotting of x-axis labels
  #--------------------------

  set lastbox [expr $startbox + $boxwindow]
  set pos [expr $ymin($j) +1]
  
  set pos [expr $xmin]

  for {set i $startbox} {$i <= $lastbox} {incr i} {

    if {$layervalue==1} {
       set xtext  [string trim [format "%10.3g" $tiefe($i)]]
    } else {
       set xtext $i
    }

    set xpos [nnx $pos]
    set xlabelpos [nnx [expr $pos+0.5*$barchart]]


    set item [$c create line  $xpos [expr $pymin+5]  $xpos $pymin -width 2]
    $c addtag axis withtag $item
    $c addtag $graph withtag $item

    set item [$c create text $xlabelpos [expr $pymin+10] -text $xtext \
                   -anchor n -font   $plotFont]

    $c addtag axis withtag $item
    $c addtag $graph withtag $item

    if {$barchart==1} {
      set pos [expr $pos+1]
    } else {
      set pos [expr $pos+$layer($i)]
    }
  }

  # Bindings for horizontal line
  #-----------------------------

if {$j==0} {
  bind $c <Button-1> "xlineDown $c %x %y"
  bind $c <B1-Motion> "xlineMotion $c %x %y"
  bind $c <ButtonRelease-1> "xlineRelease $c"

} else {
  bind $c <Button-1> ""
  bind $c <B1-Motion> ""
  bind $c <ButtonRelease-1> ""
}

  # Bindings for vertical line
  #-----------------------------

    if {$j<3} {
      bind $c <Button-3> "ylineDown $c %x %y"
      bind $c <B3-Motion> "ylineMotion $c %x %y"
      bind $c <ButtonRelease-3> "ylineRelease $c"

    } else {
      bind $c <Button-3> ""
      bind $c <B3-Motion> ""
      bind $c <ButtonRelease-3> ""
    }


}



