# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

#########################################
# Main Profile procedure called from mov
#########################################
proc profControl {} {
global can ovc
global time startbox boxwindow
global starttime endtime outd
global boxlist
global flipxy
global buttonFont

set flipxy 0
if {[llength $boxlist(1)] <2} {textinfo "No profile stored!" 1;return}

# Initializing of sliders
#------------------------
#startbox
set startbox  [lindex $boxlist(1) 0]
set boxinterval [expr ([lindex $boxlist(1) end] - [lindex $boxlist(1) 0]) / 5]

scale $ovc.left.start  -font $buttonFont -from [lindex $boxlist(1) 0] -to [expr [lindex $boxlist(1) end] -1]\
      -variable startbox \
      -orient horizontal -label "Select startbox" \
      -tickinterval $boxinterval -showvalue true -resolution 1 \
      -bigincrement 5

pack $ovc.left.start -fill x
bind $ovc.left.start <ButtonRelease-1> "corrBoxwin"


#boxwindow
set boxwindow [expr [lindex $boxlist(1) end] -[lindex $boxlist(1) 0]]

scale $ovc.left.boxwindow  -font $buttonFont -from 1 -to $boxwindow -variable boxwindow \
      -orient horizontal -label "Set box window" \
      -tickinterval $boxinterval -showvalue true -resolution 1 \
      -bigincrement 5

pack $ovc.left.boxwindow -fill x
bind $ovc.left.boxwindow <ButtonRelease-1> "corrStartbox"


set_and_graph

frame $ovc.right
grid $ovc.right -row 0 -column 2 -sticky news

frame $ovc.right.fix
pack $ovc.right.fix -side top -anchor w


frame $ovc.right.misc
pack $ovc.right.misc -side top -pady {0 5}

checkbutton $ovc.right.misc.elay  -font $buttonFont -text {eval layer} \
       -variable evallayer  -anchor w \
       -command {interpret}
pack $ovc.right.misc.elay  -fill x -pady {0 5} -anchor w

checkbutton $ovc.right.misc.lay  -font $buttonFont -text {show layervalue} \
       -variable layervalue  -anchor w \
       -command {interpret}
pack $ovc.right.misc.lay  -fill x -pady {0 5} -anchor w

checkbutton $ovc.right.misc.flip  -font $buttonFont -text {flip x-y} \
       -variable flipxy  -anchor w \
       -command {interpret}
pack $ovc.right.misc.flip  -fill x -pady {0 5} -anchor w

checkbutton $ovc.right.misc.ax  -font $buttonFont -text {same axes} \
       -variable sameaxis  -anchor w \
       -command {interpret}
pack $ovc.right.misc.ax  -fill x -pady {0 5} -anchor w


checkbutton $ovc.right.misc.timemax  -font $buttonFont -text {scale to time max} \
       -variable timemaxflag  -anchor w \
       -command {interpret}
pack $ovc.right.misc.timemax  -fill x -pady {0 5} -anchor w



label $ovc.right.misc.axtext  -font $buttonFont -text "axes maximum"
pack $ovc.right.misc.axtext
set t [entry $ovc.right.misc.ymax -width 15 -textvariable fixymax  -font $buttonFont ]

pack $ovc.right.misc.ymax
bind $ovc.right.misc.ymax <Return> "interpret"


label $ovc.right.misc.axtext0  -font $buttonFont -text "axes minimum"
pack $ovc.right.misc.axtext0
set t [entry $ovc.right.misc.ymin -width 15 -textvariable fixymin  -font $buttonFont ]

pack $ovc.right.misc.ymin
bind $ovc.right.misc.ymin <Return> "interpret"

checkbutton $ovc.right.misc.bar  -font $buttonFont -text {Barchart} \
       -variable barchart  -anchor w \
       -command {interpret}
pack $ovc.right.misc.bar  -fill x -pady {0 5} -anchor w

checkbutton $ovc.right.misc.smooth  -font $buttonFont -text {smooth} \
       -variable smooth  -anchor w \
       -command {interpret}
pack $ovc.right.misc.smooth  -fill x -pady {0 5} -anchor w

control_bindings
apply_button
right_buttons

#extract_layer
makeselector
timeslid
makecommand -1 -1
#macraise
}


