# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc timeslid {} {
global can onewindow bs
global outd starttime endtime 
global timewin toolflag global rstart rend
global buttonFont 

if {$onewindow==0} {
    set bs .ts
    toplevel $bs
    wm title $bs {Time}
    wm geometry $bs "+50+[expr $can+150]"
    wm group $bs .
    wm transient $bs .
    wm protocol $bs WM_DELETE_WINDOW exit
    
} else {
	$bs configure -text "Time"
}	

if {$toolflag=="profile"} {
  set ende [format "%7.2f" $endtime(1)]
} else {
  set ende [format "%7.2f" [expr $starttime(1) + $timewin]]
}

set timeinterval [expr ($endtime(1) - $starttime(1)) / 10]
scale $bs.speed -length $can -font $buttonFont\
      -from $starttime(1) -to $ende \
      -variable time \
      -command interpret \
      -orient horizontal \
      -tickinterval [max $timeinterval 1] \
      -showvalue true \
      -resolution $outd\
      -digits 5 \
      -bigincrement 100
pack $bs.speed -fill x
#bind $bs.speed <1> "interpret -1";
frame $bs.rec
pack $bs.rec

#checkbutton $bs.rec.one -text {Into one file} \
#-variable onefile
#pack $bs.rec.one -side left
#set onefile 1

label $bs.rec.text1 -text "from" -font $buttonFont
pack $bs.rec.text1 -side left
set t [entry $bs.rec.rstart -width 10 -font $buttonFont -textvariable rstart]
pack $bs.rec.rstart -side left

label $bs.rec.text2 -text "to" -font $buttonFont
pack $bs.rec.text2 -side left
set t [entry $bs.rec.rend -width 10 -font $buttonFont -textvariable rend ]
pack $bs.rec.rend -side left

button $bs.rec.record -text {Record} -font $buttonFont -command profRecord
pack $bs.rec.record -side left
set rstart $starttime(1)
set rend $ende
}


