# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

#########################################
# Main Overview procedure called from mov
#########################################
proc TextControl {} {
global can ovc
global starttime endtime outd
global actstart timewin outwin
global eformat digits
global buttonFont

set eformat f
set digits 5

control_bindings
makeslider

set outwin $outd

#outputwin
#scale $ovc.left.outwin -from $outd -to $timewin -variable outwin \
#      -orient horizontal -label "Set output window" \
#      -showvalue true -resolution $outd
#      -bigincrement 360 -tickinterval $tickint

#pack $ovc.left.outwin -fill x
#bind $ovc.left.outwin <ButtonRelease-1> "corrOutwin"


labelframe $ovc.left.graph -text "Column Control"
pack $ovc.left.graph -side bottom -anchor w -fill x

button $ovc.left.graph.newgraph  -font $buttonFont -text {new}\
       -command {set newgraph 1}
pack $ovc.left.graph.newgraph -side left

button $ovc.left.graph.erasegraph  -font $buttonFont -text {erase} \
       -command {set erasegraph 1;makecommand -1 -1} \
       -state disabled
pack $ovc.left.graph.erasegraph -side left

button $ovc.left.graph.eraseallgraphs  -font $buttonFont -text {erase all} \
       -command {set eraseallgraphs 1;makecommand -1 -1} \
       -state disabled
pack $ovc.left.graph.eraseallgraphs -side right

frame $ovc.right
grid $ovc.right -row 0 -column 2 -sticky news

frame $ovc.right.fix
pack $ovc.right.fix -side top -anchor w


checkbutton $ovc.right.fix.fixvar  -font $buttonFont -text {fix variables} \
       -variable fixvar -anchor w \
       -command {$ovc.right.fix.fixbox config -state disabled;fixVar $fixvar} 
pack $ovc.right.fix.fixvar -fill x

checkbutton $ovc.right.fix.fixbox  -font $buttonFont -text {fix boxes} \
       -variable fixbox -anchor w \
       -command {$ovc.right.fix.fixvar config -state disabled;fixBox $fixbox} 
pack $ovc.right.fix.fixbox  -fill x

checkbutton $ovc.right.fix.aoag  -font $buttonFont -text {act on all columns} \
       -variable aoag -anchor w -state disabled
pack $ovc.right.fix.aoag -fill x


#label $ovc.right.fix.flabel  -font $buttonFont -text "Format"
#pack $ovc.right.fix.flabel -pady 1

labelframe $ovc.right.f -text "Format"
pack $ovc.right.f -side top -pady {0 5}

radiobutton $ovc.right.f.formats  -font $buttonFont -variable eformat \
              -text s -value s

radiobutton $ovc.right.f.formatg  -font $buttonFont -variable eformat \
              -text g -value g

radiobutton $ovc.right.f.formatf  -font $buttonFont -variable eformat \
              -text f -value f

radiobutton $ovc.right.f.formate  -font $buttonFont -variable eformat \
              -text e -value e

pack $ovc.right.f.formats -side left -pady {0 5}
pack $ovc.right.f.formatg -side left -pady {0 5}
pack $ovc.right.f.formatf -side left -pady {0 5}
pack $ovc.right.f.formate -side left -pady {0 5}

labelframe $ovc.right.d -text "Decimal Places"
pack $ovc.right.d -side top

#label $ovc.right.d.dlabel  -font $buttonFont -text "Decimal Places"
#pack $ovc.right.d.dlabel -pady 1

radiobutton $ovc.right.d.d2  -font $buttonFont -variable digits \
              -text 2 -value 2
radiobutton $ovc.right.d.d3  -font $buttonFont -variable digits \
              -text 3 -value 3
radiobutton $ovc.right.d.d5  -font $buttonFont -variable digits \
              -text 5 -value 5
radiobutton $ovc.right.d.d8  -font $buttonFont -variable digits \
              -text 8 -value 8
pack $ovc.right.d.d2 -side left -pady {0 5}
pack $ovc.right.d.d3 -side left -pady {0 5}
pack $ovc.right.d.d5 -side left -pady {0 5}
pack $ovc.right.d.d8 -side left -pady {0 5}

frame $ovc.right.misc
pack $ovc.right.misc -side top -pady {0 5} -anchor w -fill x

apply_button
button $ovc.right.misc.ana  -font $buttonFont -text {Analysis} \
       -command {analysis}
pack $ovc.right.misc.ana -fill x

checkbutton $ovc.right.misc.fourier  -font $buttonFont -text {Spectrum} \
       -variable spectrum -command {interpret} -anchor w
pack $ovc.right.misc.fourier -fill x

button $ovc.right.misc.com  -font $buttonFont -text {Command} \
       -command {command}
pack $ovc.right.misc.com -fill x

makeselector

}


